
program Main_March
USE VarDef
USE Datasets


IMPLICIT NONE

!####################### VARIABLE DECLARATION ########################


real(8)        :: gamma_step1(212), npar !number of parameters plus 17 rental rates to estimate
real(8)        :: gamma_iterate(80)  !subset of parameters I am iterating over = parents' parameters
character(150) :: inputname, outputname, tag

integer        :: i, stopping, k, kk, wtype, ctype, skiploop, idum, mkt, sim_cost, iter, iter_r, iter_pv,docalib, docalibprof, apps, noeval, sim



integer        :: noevalCASEN



!Common block SIMCE
real(8)        ::  epsilon_pSIMCE(3,n_s,D), epsilon_pvec(3*n_s*D)  

!used to compute avg ability of teahcers, needed to match parents' moments, ie read in by mom_simce and mom_casenp
real(8)        :: sumweight_wM(n_mkt), sumweight_wV(n_mkt), awM(n_mkt), awV(n_mkt)
!moments: outputs of mom_* subroutines
real(8)        ::  momvec_simce(321)  
real(8)        :: momvec_casenp(510)
real(8)        :: momvec_casenw(234) 
real(8)        :: momvec_eld(218)

!weighting matrices
real(8)       ::  W_SIMCE(321,321),  MpWSIMCE(321) 
!objective function
real(8)        :: objf_I, objfCASENW, objfELD

!moments casenp
integer        :: zeroSM(n_mkt), zeroSV(n_mkt), noevalCASENP
!moments simce
integer        :: noevalSIMCE
!moment eld
integer        :: noevalELD

integer  :: weighting



integer        :: highab !a signal = 1 if ability of teachers too high at that parameter value




!switching on and off simce moments
integer    :: match_tsM, match_tsV, match_tsMsq, match_tsVsq, match_pV, match_pVsq ,match_fracV


CALL cpu_time (BeginningTime)
!write(*,*) "^^^^^^^^^^^^^^^^^^^^^^^^^^^^"
!write(*,*) "STARTING PROGRAM Main_Estim1: STEP 1 of the estimation"
!write(*,*) "^^^^^^^^^^^^^^^^^^^^^^^^^^^^"


!###################################################################

!##### Read in input parameters and assign thetas using gamma ######

!###################################################################

!First, read in paramters that stay fixed
gamma_step1=0.0d0

open(unit=1732,file='./gamma_step1_212')
do i=1,213
 !write(*,*) "i", i
  if(i.eq.1) then
   read(1732,*) npar
  else
   read(1732,*) gamma_step1(i-1)
  end if


end do

close(1732)




!Now read in the only paraemters I iterate over

gamma_iterate=0.0d0
theta=0.0d0


call getarg(1,inputname)
call getarg (2,outputname)
call getarg(3,tag)

open(unit=173,file=inputname,access='sequential')

  read(173,*)
 do i=1,81
  !write(*,*) "i", i
  if(i.eq.1) then
   read(173,*) npar
  else
   read(173,*) gamma_iterate(i-1)
  end if
 end do
close(173)


do i=133, 212
  gamma_step1(i)=gamma_iterate(i-132)
end do








!Assign thetas of workers
do i=1,3
  theta(i)=gamma_step1(i)
end do
do i=5,93
 theta(i)=gamma_step1(i-1)
end do
do i=106,109
 theta(i)=gamma_step1(i-13)
end do
 theta(194)=gamma_step1(97)
do i=177, 193
 theta(i)=gamma_step1(i-79)
end do
do i=287,304
 theta(i)=gamma_step1(i-172)
end do





!Assign thetas of parents
do i=110, 120
 theta(i)=gamma_step1(i+23)
end do
do i=123,128
 theta(i)=gamma_step1(i+21)
end do
do i=155,157
 theta(i)=gamma_step1(i-5)
end do
do i=162, 165
 theta(i)=gamma_step1(i-9)
end do
 theta(169)=gamma_step1(157)
 theta(171)=gamma_step1(158)
 theta(195)=gamma_step1(159)
do i=197,244
 theta(i)=gamma_step1(i-37)
end do
 theta(247)=gamma_step1(208)
do i=249,252
 theta(i)=gamma_step1(i-40)
end do






!#######################################################

!############## Read in datasets #######################

!######################################################


!SIMCE06_media and primaria together
open(unit=12,file='./SIMCE410_final.txt')
    do i=1,n_s
       read(12,*) id_s(i), mkt7_s(i),primaria_s(i),rural_s(i), nfam_s(i), peduc_s(i), fem_s(i), unempl_s(i), blue_s(i), mincome_s(i), &
       & m_s(i), v_s(i), mtuition_s(i), standability_s(i) 
    end do
close(12)  



!read(*,*) stopping
!change wage into 100k pesos. Mtuition is already in terms of 100k pesos
do i=1,n_s
  mincome_s(i)=mincome_s(i)/100000.0d0
  if(blue_s(i).eq.2) then
   blue_s(i)=0
  end if 
end do

do i=1,n_s
 if(mkt7_s(i).eq.6661) then
     mkt7_s(i)=1
    else if (mkt7_s(i).eq.6662) then
     mkt7_s(i)=2 
    else if (mkt7_s(i).eq.6663) then
     mkt7_s(i)=3 
    else if (mkt7_s(i).eq.6664) then
     mkt7_s(i)=4 
    else if (mkt7_s(i).eq.6665) then
     mkt7_s(i)=5 
    else if (mkt7_s(i).eq.6666) then
     mkt7_s(i)=6 
    else if (mkt7_s(i).eq.6667) then
     mkt7_s(i)=7 
    else if (mkt7_s(i).eq.6668) then
     mkt7_s(i)=8 
    else if (mkt7_s(i).eq.6669) then
     mkt7_s(i)=9 
    else if (mkt7_s(i).eq.66610) then
     mkt7_s(i)=10 
    else if (mkt7_s(i).eq.66612) then
     mkt7_s(i)=11 
    else if (mkt7_s(i).eq.66613) then
     mkt7_s(i)=12 
    else if (mkt7_s(i).eq.66614) then
     mkt7_s(i)=13 
    else if (mkt7_s(i).eq.66615) then
     mkt7_s(i)=14 
    else if (mkt7_s(i).eq.66616) then
     mkt7_s(i)=15 
    else if (mkt7_s(i).eq.66617) then
     mkt7_s(i)=16 
    else if (mkt7_s(i).eq.66618) then
     mkt7_s(i)=17 
    else if (mkt7_s(i).eq.66619) then
     mkt7_s(i)=18 
   end if
end do

 !### read in the workers' dataset ######



!WORKERS UNIQUE
open(unit=13,file='./workers_unique.txt') !a dot between final and trim indicates that this is the dataset with the corrected weights (corrected using idoneidad and fraction teaching obtained in original casen, before imputation)
    do i=1,n_w
       read(13,*) id_w(1,i), id_w(2,i), mkt7_w(i), graddeg_w(i), perfec_w(i), nkids_w(i), nkids2_w(i), nkids6_w(i), age_w(i), fem_w(i), &
       & peduc_w(i), m_w(i), v_w(i), nt_w(i), h_w(i),wage_w(i)
    end do
close(13)

    
do i=1,n_w
   wage_w(i)=wage_w(i)/100000.0d0
end do

do i=1,n_w
  age_w(i)=age_w(i)-19

   if(mkt7_w(i).eq.6661) then
     mkt7_w(i)=1
    else if (mkt7_w(i).eq.6662) then
     mkt7_w(i)=2 
    else if (mkt7_w(i).eq.6663) then
     mkt7_w(i)=3 
    else if (mkt7_w(i).eq.6664) then
     mkt7_w(i)=4 
    else if (mkt7_w(i).eq.6665) then
     mkt7_w(i)=5 
    else if (mkt7_w(i).eq.6666) then
     mkt7_w(i)=6 
    else if (mkt7_w(i).eq.6667) then
     mkt7_w(i)=7 
    else if (mkt7_w(i).eq.6668) then
     mkt7_w(i)=8 
    else if (mkt7_w(i).eq.6669) then
     mkt7_w(i)=9 
    else if (mkt7_w(i).eq.66610) then
     mkt7_w(i)=10 
    else if (mkt7_w(i).eq.66612) then
     mkt7_w(i)=11 
    else if (mkt7_w(i).eq.66613) then
     mkt7_w(i)=12 
    else if (mkt7_w(i).eq.66614) then
     mkt7_w(i)=13 
    else if (mkt7_w(i).eq.66615) then
     mkt7_w(i)=14 
    else if (mkt7_w(i).eq.66616) then
     mkt7_w(i)=15 
    else if (mkt7_w(i).eq.66617) then
     mkt7_w(i)=16 
    else if (mkt7_w(i).eq.66618) then
     mkt7_w(i)=17 
    else if (mkt7_w(i).eq.66619) then
     mkt7_w(i)=18 
   end if
end do







!MKT_CHAR
open(unit=16,file='./mkt_char5.csv')
    do i=1,n_mktvd
       read(16,*) mkt7(i),  size_mkt7(i), educ_mkt7(i),   sdeduc_mkt7(i), blue_mkt7(i),mincome_mkt7(i), sdminc_mkt7(i), fona_mkt7(i), fonb_mkt7(i), fonc_mkt7(i),&
                 & fond_mkt7(i),isapre_mkt7(i), chilesol_mkt7(i), rural_mkt7(i), unempl_mkt7(i), nowork_mkt7(i), nsub_mkt7(i), r_13(i), r_15(i), Norte(i),&
                 & Central(i), Sur(i), numM(i), numV(i), numU(i),Drural_mkt7(i), Dchilsol_mkt7(i),studM_mkt7(i),studV_mkt7(i),sharestudV_mkt7(i), teachM_mkt7(i),&
                 & imp_teachV_mkt7(1,i),imp_teachV_mkt7(2,i),imp_teachV_mkt7(3,i),imp_teachV_mkt7(4,i),imp_teachV_mkt7(5,i),imp_teachV_mkt7(6,i),imp_teachV_mkt7(7,i), &
                 & imp_teachV_mkt7(8,i),imp_teachV_mkt7(9,i),imp_teachV_mkt7(10,i),imp_shareteachV_mkt7(1,i),imp_shareteachV_mkt7(2,i),imp_shareteachV_mkt7(3,i),&
                 & imp_shareteachV_mkt7(4,i),imp_shareteachV_mkt7(5,i),imp_shareteachV_mkt7(6,i),imp_shareteachV_mkt7(7,i),imp_shareteachV_mkt7(8,i),&
                 & imp_shareteachV_mkt7(9,i),imp_shareteachV_mkt7(10,i), imp_studteachV(1,i),imp_studteachV(2,i),imp_studteachV(3,i),imp_studteachV(4,i),imp_studteachV(5,i),&
                 & imp_studteachV(6,i),imp_studteachV(7,i),imp_studteachV(8,i),imp_studteachV(9,i),imp_studteachV(10,i), studteachM(i), mean_maxpv(i)
    end do  
close(16)


!Market level categories
!pvd_cat, educd_cat, mincomed_cat
do i=1,n_mkt
 !pvd_cat
 if(mean_maxpv(i)<=40000.0d0.AND.mean_maxpv(i)>=0.0d0) then
   pvd_cat(i)=1
 else if  (mean_maxpv(i)<=48000.0d0.AND.mean_maxpv(i)>40000.0d0) then
   pvd_cat(i)=2
 else if (mean_maxpv(i)<=53500.0d0.AND.mean_maxpv(i)>48000.0d0 ) then
   pvd_cat(i)=3
 else if (mean_maxpv(i)>53500.0d0) then
   pvd_cat(i)=4
 else
   pvd_cat(i)=-99
 end if
 
 !educd_cat
 if(educ_mkt7(i)<=8.60d0.AND.educ_mkt7(i)>=0.0d0) then
  educd_cat(i)=1
 else if (educ_mkt7(i)> 8.60d0.AND.educ_mkt7(i)<=9.30d0) then
  educd_cat(i)=2
 else if (educ_mkt7(i)>9.30d0.AND.educ_mkt7(i)<=10.10d0) then
  educd_cat(i)=3
 else if (educ_mkt7(i)>10.10d0) then
  educd_cat(i)=4
 else
  educd_cat(i)=-99
 end if
 
 !mincomed_cat
 if(mincome_mkt7(i)<=190000.0d0.AND.mincome_mkt7(i)>=0.0d0) then
  mincomed_cat(i)=1
 else if(mincome_mkt7(i)>190000.0d0.AND.mincome_mkt7(i)<=211358.0d0) then
  mincomed_cat(i)=2
 else if (mincome_mkt7(i)>211358.0d0.AND.mincome_mkt7(i)<=250000.0d0) then
  mincomed_cat(i)=3
 else if (mincome_mkt7(i)>250000.0d0) then
  mincomed_cat(i)=4
 else
  mincomed_cat(i)=-99
 end if
 
 !Dblue dummy
 if(blue_mkt7(i).le.0.6490d0) then
  Dblue_mkt7(i)=0
 else
  Dblue_mkt7(i)=1
 end if 
end do

                 

do i=1,n_mkt
  mincome_mkt7(i)=mincome_mkt7(i)/100000.0d0
  mean_maxpv(i)=mean_maxpv(i)/100000.0d0
end do
do i=1,n_mkt
 if(rural_mkt7(i)>=.22) then
  Drural_mkt7(i)=1.0d0
 else
  Drural_mkt7(i)=0.0d0
 end if
 if(chilesol_mkt7(i)>=0.0128) then
  Dchilsol_mkt7(i)=1.0d0
 else
  Dchilsol_mkt7(i)=0.0d0
 end if    
end do

CALL cpu_time (EndTime)
!write(*,*) "Time:", EndTime-StartTime
MidTime=EndTime


  


   call simability_workers(noeval,zeroSM, zeroSV, awM, awV)





   if(noeval.ne.1) then !i.e. only if it is not true that there is at least one market in which noone teaches in school

   
  
    !Draw shocks of SIMCE parents

    idum=7777
   call gasdev(idum,epsilon_pvec,3*n_s*D)


 
do i=1,n_s
 do sim=1,D
  epsilon_pSIMCE(1,i,sim)=exp(theta(156))*epsilon_pvec(i+(sim-1)*n_s)          !production of cogn ach in M
   
  epsilon_pSIMCE(2,i,sim)=exp(theta(157))*epsilon_pvec(n_s*D+i+(sim-1)*n_s)  !production of cogn ach in V
  epsilon_pSIMCE(3,i,sim)=exp(theta(155))*epsilon_pvec(2*n_s*D+i+(sim-1)*n_s)!preference for M
 end do 
end do


    
  call mom_simce3(zeroSM,zeroSV,awM,awV,epsilon_pSIMCE, momvec_simce)

  

!########################################

!# Compute objective function ###########

!########################################

weighting=1

if(weighting.eq.1) then



!Read in weighting matrix


open(unit=8456,file='./inverseSIMCE.csv')
do k=1,321
  read(8456,*) W_SIMCE(k,1:321)
end do

close(8456)





!Matrix multiplication
 MpWSIMCE=0.0d0
do k=1,321
 do kk=1,321
   MpWSIMCE(k)=MpWSIMCE(k)+momvec_simce(kk)*W_SIMCE(kk,k)
  end do
end do







!compute objective function by doing matrix multiplicaiton

objf_I=0.0d0
do kk=1,321
 do k=1,321
  objf_I=objf_I+momvec_simce(k)*W_SIMCE(k,kk)*momvec_simce(kk)
  end do
end do



else if (weighting.eq.0) then



objf_I=0.0d0
do i=1,321
 objf_I=objf_I+momvec_simce(i)**2.0d0
end do

end if









!write(*,*) "obj function", objf_I




!#########################################################
!############# WRITE OBJ FUN TO FILE #####################
!#########################################################
open(unit=900, file=outputname)
      write(900,*) 1
      write(900,*) objf_I
     close(900)

open(unit=900900, file='./diagnostics_simce')
      write(900900,*) "OVERALL objf" , objf_I  
     write(900900,*) "Vector of SIMCE moments"
      do i=1,321
       write(900900,*) i, momvec_simce(i)
     end do
     close(900900)





!write(*,*) "value of objective function", objf_I


else if (noeval.eq.1) then
  open(unit=90088, file=outputname)

    
      write(90088,*) "noeval=1 from simability i.e. at this paramter get unfeasible avg teachers' abilities"
     close(90088)

open(unit=909089, file='./diagnostics_simce')
      write(909089,*) "noeval=1: in at least one market there is zero supply to at least one sector"
     
     close(909089)


end if !noeval





end program Main_March