
program Main_March
USE VarDef
USE Datasets


IMPLICIT NONE

!####################### VARIABLE DECLARATION ########################


real(8)        :: gamma_step1(212), npar, gamma_workers(132) !number of parameters plus 17 rental rates to estimate
character(150) :: inputname, outputname, tag
character(61)  :: path
integer        :: i, stopping, k, kk, wtype, ctype, skiploop, idum, mkt, sim_cost, iter, iter_r, iter_pv,docalib, docalibprof, apps, noeval, sim

real(8)        ::  epsilon_w(4,n_w,D), epsilon_wvec(4*n_w*D)
real(8)        :: epsilon_p(3,n_cp,D) 



integer        :: zeroSM(n_mkt), zeroSV(n_mkt), weighting

integer      :: matchwage, matchsquare, matchfrac, matchELD
integer      :: matchfrac_casenw





!used to compute avg ability of teahcers, needed to match parents' moments, ie read in by mom_simce and mom_casenp
real(8)        :: sumweight_wM(n_mkt), sumweight_wV(n_mkt), awM(n_mkt), awV(n_mkt)

real(8)        ::  momvec_workers(286)

!weighting matrices
real(8)       :: W_WORKERS(286,286)
!Relative to the objective function: weighting matrix
real(8)   :: MpW_workers(286)
!objective function
real(8)        :: objf_I





real(8)        :: epsilon_p(3,n_cp2vd,D), epsilon_pvec(3*n_cp2vd*D)

integer        :: highab 






CALL cpu_time (BeginningTime)
!write(*,*) "^^^^^^^^^^^^^^^^^^^^^^^^^^^^"
!write(*,*) "STARTING PROGRAM Main_Estim1: STEP 1 of the estimation"
!write(*,*) "^^^^^^^^^^^^^^^^^^^^^^^^^^^^"



!###################################################################

!##### Read in input parameters and assign thetas using gamma ######

!###################################################################


gamma_step1=0.0d0
gamma_workers=0.0d0
theta=0.0d0

!First, read in gamma_step1: fixed.

open(unit=376,file='./gamma_step1_212')
read(376,*)

do i=1,212
   read(376,*) gamma_step1(i)
end do
close(unit=376)



!Now read in the parameters we loop over


call getarg(1,inputname)
call getarg (2,outputname)
call getarg(3,tag)

open(unit=173,file=inputname,access='sequential')

  read(173,*) !Remember to add another read statement if yoi read in from raptor!
  read(173,*)
 do i=1,132
   read(173,*) gamma_workers(i)
 end do
close(173)


!Now assign correct gamma_step1 by substituting old, fixed elements of gamma_step1 with the ones that vary
do i=1,132
   gamma_step1(i)=gamma_workers(i)
end do


!Assign thetas
do i=1,3
  theta(i)=gamma_step1(i)
end do
do i=5,93
 theta(i)=gamma_step1(i-1)
end do
do i=106,109
 theta(i)=gamma_step1(i-13)
end do
 theta(194)=gamma_step1(97)
do i=177, 193
 theta(i)=gamma_step1(i-79)
end do
do i=287,304
 theta(i)=gamma_step1(i-172)
end do






!#######################################################

!############## Read in datasets #######################

!######################################################



!WORKERS UNIQUE
open(unit=13,file='./workers_unique.txt') !
    do i=1,n_w
       read(13,*) id_w(1,i), id_w(2,i), mkt7_w(i), graddeg_w(i), perfec_w(i), nkids_w(i), nkids2_w(i), nkids6_w(i), age_w(i), fem_w(i), &
       & peduc_w(i), m_w(i), v_w(i), nt_w(i), h_w(i),wage_w(i)
    end do
close(13)

!write(*,*) "First line unique workers"
!i=1
!write(*,*) id_w(1,i), id_w(2,i), mkt7_w(i), graddeg_w(i), perfec_w(i), nkids_w(i), nkids2_w(i), nkids6_w(i), age_w(i), fem_w(i), &
!       & peduc_w(i), m_w(i), v_w(i), nt_w(i), h_w(i),wage_w(i)

!write(*,*) "Last line unique workers"
!i=n_w
!write(*,*)  id_w(1,i), id_w(2,i), mkt7_w(i), graddeg_w(i), perfec_w(i), nkids_w(i), nkids2_w(i), nkids6_w(i), age_w(i), fem_w(i), &
!       & peduc_w(i), m_w(i), v_w(i), nt_w(i), h_w(i),wage_w(i)
!read(*,*) stopping 

do i=1,n_w
   wage_w(i)=wage_w(i)/100000.0d0
end do

do i=1,n_w

   age_w(i)=age_w(i)-19

   if(mkt7_w(i).eq.6661) then
     mkt7_w(i)=1
    else if (mkt7_w(i).eq.6662) then
     mkt7_w(i)=2 
    else if (mkt7_w(i).eq.6663) then
     mkt7_w(i)=3 
    else if (mkt7_w(i).eq.6664) then
     mkt7_w(i)=4 
    else if (mkt7_w(i).eq.6665) then
     mkt7_w(i)=5 
    else if (mkt7_w(i).eq.6666) then
     mkt7_w(i)=6 
    else if (mkt7_w(i).eq.6667) then
     mkt7_w(i)=7 
    else if (mkt7_w(i).eq.6668) then
     mkt7_w(i)=8 
    else if (mkt7_w(i).eq.6669) then
     mkt7_w(i)=9 
    else if (mkt7_w(i).eq.66610) then
     mkt7_w(i)=10 
    else if (mkt7_w(i).eq.66612) then
     mkt7_w(i)=11 
    else if (mkt7_w(i).eq.66613) then
     mkt7_w(i)=12 
    else if (mkt7_w(i).eq.66614) then
     mkt7_w(i)=13 
    else if (mkt7_w(i).eq.66615) then
     mkt7_w(i)=14 
    else if (mkt7_w(i).eq.66616) then
     mkt7_w(i)=15 
    else if (mkt7_w(i).eq.66617) then
     mkt7_w(i)=16 
    else if (mkt7_w(i).eq.66618) then
     mkt7_w(i)=17 
    else if (mkt7_w(i).eq.66619) then
     mkt7_w(i)=18 
   end if
end do




!MKT_CHAR
open(unit=16,file='./mkt_char5.csv')
    do i=1,n_mktvd
       read(16,*) mkt7(i),  size_mkt7(i), educ_mkt7(i),   sdeduc_mkt7(i), blue_mkt7(i),mincome_mkt7(i), sdminc_mkt7(i), fona_mkt7(i), fonb_mkt7(i), fonc_mkt7(i),&
                 & fond_mkt7(i),isapre_mkt7(i), chilesol_mkt7(i), rural_mkt7(i), unempl_mkt7(i), nowork_mkt7(i), nsub_mkt7(i), r_13(i), r_15(i), Norte(i),&
                 & Central(i), Sur(i), numM(i), numV(i), numU(i),Drural_mkt7(i), Dchilsol_mkt7(i),studM_mkt7(i),studV_mkt7(i),sharestudV_mkt7(i), teachM_mkt7(i),&
                 & imp_teachV_mkt7(1,i),imp_teachV_mkt7(2,i),imp_teachV_mkt7(3,i),imp_teachV_mkt7(4,i),imp_teachV_mkt7(5,i),imp_teachV_mkt7(6,i),imp_teachV_mkt7(7,i), &
                 & imp_teachV_mkt7(8,i),imp_teachV_mkt7(9,i),imp_teachV_mkt7(10,i),imp_shareteachV_mkt7(1,i),imp_shareteachV_mkt7(2,i),imp_shareteachV_mkt7(3,i),&
                 & imp_shareteachV_mkt7(4,i),imp_shareteachV_mkt7(5,i),imp_shareteachV_mkt7(6,i),imp_shareteachV_mkt7(7,i),imp_shareteachV_mkt7(8,i),&
                 & imp_shareteachV_mkt7(9,i),imp_shareteachV_mkt7(10,i), imp_studteachV(1,i),imp_studteachV(2,i),imp_studteachV(3,i),imp_studteachV(4,i),imp_studteachV(5,i),&
                 & imp_studteachV(6,i),imp_studteachV(7,i),imp_studteachV(8,i),imp_studteachV(9,i),imp_studteachV(10,i), studteachM(i), mean_maxpv(i)
    end do  
close(16)


!Market level categories
!pvd_cat, educd_cat, mincomed_cat
do i=1,n_mkt
 !pvd_cat
 if(mean_maxpv(i)<=40000.0d0.AND.mean_maxpv(i)>=0.0d0) then
   pvd_cat(i)=1
 else if  (mean_maxpv(i)<=48000.0d0.AND.mean_maxpv(i)>40000.0d0) then
   pvd_cat(i)=2
 else if (mean_maxpv(i)<=53500.0d0.AND.mean_maxpv(i)>48000.0d0 ) then
   pvd_cat(i)=3
 else if (mean_maxpv(i)>53500.0d0) then
   pvd_cat(i)=4
 else
   pvd_cat(i)=-99
 end if
 
 !educd_cat
 if(educ_mkt7(i)<=8.60d0.AND.educ_mkt7(i)>=0.0d0) then
  educd_cat(i)=1
 else if (educ_mkt7(i)> 8.60d0.AND.educ_mkt7(i)<=9.30d0) then
  educd_cat(i)=2
 else if (educ_mkt7(i)>9.30d0.AND.educ_mkt7(i)<=10.10d0) then
  educd_cat(i)=3
 else if (educ_mkt7(i)>10.10d0) then
  educd_cat(i)=4
 else
  educd_cat(i)=-99
 end if
 
 !mincomed_cat
 if(mincome_mkt7(i)<=190000.0d0.AND.mincome_mkt7(i)>=0.0d0) then
  mincomed_cat(i)=1
 else if(mincome_mkt7(i)>190000.0d0.AND.mincome_mkt7(i)<=211358.0d0) then
  mincomed_cat(i)=2
 else if (mincome_mkt7(i)>211358.0d0.AND.mincome_mkt7(i)<=250000.0d0) then
  mincomed_cat(i)=3
 else if (mincome_mkt7(i)>250000.0d0) then
  mincomed_cat(i)=4
 else
  mincomed_cat(i)=-99
 end if
 
 !Dblue dummy
 if(blue_mkt7(i).le.0.6490d0) then
  Dblue_mkt7(i)=0
 else
  Dblue_mkt7(i)=1
 end if 
end do

                 

do i=1,n_mkt
  mincome_mkt7(i)=mincome_mkt7(i)/100000.0d0
  mean_maxpv(i)=mean_maxpv(i)/100000.0d0
end do
do i=1,n_mkt
 if(rural_mkt7(i)>=.22) then
  Drural_mkt7(i)=1.0d0
 else
  Drural_mkt7(i)=0.0d0
 end if
 if(chilesol_mkt7(i)>=0.0128) then
  Dchilsol_mkt7(i)=1.0d0
 else
  Dchilsol_mkt7(i)=0.0d0
 end if    
end do

CALL cpu_time (EndTime)
!write(*,*) "Time:", EndTime-StartTime
MidTime=EndTime



!#####################################################################################################################

!########################### Draw shocks by datasets and compute moments #############################################

!#####################################################################################################################


CALL cpu_time (StartTime)


!Draw epsilon_w i.e. the worker's shocks

! Draw D draws for every worker, and shock type
idum=3333
call gasdev(idum,epsilon_wvec,4*n_w*D)

do i=1,n_w
 do sim=1,D
  epsilon_w(1,i,sim)=exp(theta(106))*epsilon_wvec(i+(sim-1)*n_w)        !preference for Home
  epsilon_w(2,i,sim)=exp(theta(107))*epsilon_wvec(n_w*D+i+(sim-1)*n_w)   !shock in M wage
  epsilon_w(3,i,sim)=exp(theta(108))*epsilon_wvec(2*n_w*D+i+(sim-1)*n_w) !shock in V wage
  epsilon_w(4,i,sim)=exp(theta(109))*epsilon_wvec(3*n_w*D+i+(sim-1)*n_w) !shock in NT wage
  
 end do
end do  




  call mom_workers( epsilon_w,momvec_workers)


   
!########################################

!# Compute objective function ###########

!########################################



!### read in weighting matrix ######

open(unit=8456,file='./inverseworkers.csv')
do k=1,286
  read(8456,*) W_WORKERS(k,1:286)
end do

close(8456)





weighting=1
objf_I=0.0d0

if(weighting.eq.1) then



!Matrix multiplication
MpW_workers=0.0d0
do k=1,286
 do kk=1,286
  MpW_workers(k)=MpW_workers(k)+momvec_workers(kk)*W_WORKERS(kk,k)
 end do
end do


!write(*,*) momvec_eld
do i=1,286

   objf_I=objf_I+(momvec_workers(i)*MpW_workers(i))
 

end do




else !use identity matrix

do i=1,286
 objf_I=objf_I+momvec_workers(i)**2.0d0
end do


end if !weighting

!#########################################################
!############# WRITE OBJ FUN TO FILE #####################
!#########################################################
open(unit=900, file=outputname)
      write(900,*) 1
      write(900,*) objf_I
     close(900)

open(unit=900900, file='./diagnostics_workers')
      write(900900,*) "OVERALL objf" , objf_I


     close(900900)






!write(*,*) "END OF PROGRAM"
!write(*,*) ""
!write(*,*) "Overall time", EndTime-BeginningTime
!read(*,*) i
end program Main_March