subroutine simability_workers(noeval,zeroSM,zeroSV,awM,awV)
USE VarDef
USE Datasets
IMPLICIT NONE


integer, parameter    :: Drep=100
real(8), intent(out)  :: awM(n_mkt), awV(n_mkt)
integer, intent(out)  :: noeval, zeroSM(n_mkt), zeroSV(n_mkt)
real(8)               :: den_awM(n_mkt), den_awV(n_mkt)

real(8)               :: epsilon_w(4,n_w,Drep), epsilon_wvec(4*n_w*Drep)
real(8)               :: sM(n_w,Drep), sV(n_w,Drep), sNT(n_w,Drep), sH(n_w,Drep), stskills(n_w,Drep)
real(8)               :: type_i(n_w,Drep), unif(n_w*Drep), Psi(NWType)


real(8)  :: constM(NWType), constNT(NWType),lnwageM(n_w,Drep), lnwageV(n_w,Drep), lnwageNT(n_w,Drep), uwM, uwV, uwNT, uwH
real(8)  :: umax, ln_r
integer  :: i, sim, mkt, wtype, cat, stopping, idum



noeval=0
zeroSM=-99; zeroSV=-99
den_awM=0.0d0; den_awV=0.0d0
sM=-99.0d0; sV=-99.0d0; sNT=-99.0d0; sH=-99.0d0; stskills=-99.0d0

 
   !Draw shocks of college graduates
    ! Draw Drep draws for every worker, and shock type
    idum=3333
    call gasdev(idum,epsilon_wvec,4*n_w*Drep)




    do i=1,n_w
     do sim=1,Drep
      epsilon_w(1,i,sim)=exp(theta(106))*epsilon_wvec(i+(sim-1)*n_w)          !preference for Home
      epsilon_w(2,i,sim)=exp(theta(107))*epsilon_wvec(n_w*Drep+i+(sim-1)*n_w)   !shock in M wage
      epsilon_w(3,i,sim)=exp(theta(108))*epsilon_wvec(2*n_w*Drep+i+(sim-1)*n_w) !shock in V wage
      epsilon_w(4,i,sim)=exp(theta(109))*epsilon_wvec(3*n_w*Drep+i+(sim-1)*n_w) !shock in NT wage
  
     end do
    end do  

 

!Draw one type draw for each individual and simulation
Psi(1)=1.0d0-theta(92)-theta(93)
Psi(2)=theta(92)
Psi(3)=theta(93)

!write(*,*) "Prob1, prob2, prob3", Psi(1), Psi(2), Psi(3)


idum=777
unif=-99.0d0
call ran1(idum,unif,n_w*Drep)

do i=1,n_w
  do sim=1,Drep
    if(unif(i+(sim-1)*Drep)>=0.0d0.AND.unif(i+(sim-1)*Drep)<=Psi(1)) then
      type_i(i,sim)=1
    else if(unif(i+(sim-1)*Drep)>Psi(1).AND.unif(i+(sim-1)*Drep)<=Psi(1)+Psi(2)) then
      type_i(i,sim)=2
    else if (unif(i+(sim-1)*Drep)>Psi(1)+Psi(2).AND.unif(i+(sim-1)*Drep)<=1.0d0) then
      type_i(i,sim)=3
    end if
   end do
end do




!Now compute teaching skills of each worker in the market given ytpe and shock



do i=1,n_w
 do sim=1,Drep

   if(type_i(i,sim).eq.1) then
      stskills(i,sim)=exp(theta(10)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+theta(16)*dble(perfec_w(i))+&
             & theta(17)*dble(graddeg_w(i))+epsilon_w(3,i,sim))

   else if (type_i(i,sim).eq.2) then
      stskills(i,sim)=exp(theta(10)+theta(11)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+theta(16)*dble(perfec_w(i))+&
             & theta(17)*dble(graddeg_w(i))+epsilon_w(3,i,sim))
  else if (type_i(i,sim).eq.3) then
      stskills(i,sim)=exp(theta(10)+theta(12)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+theta(16)*dble(perfec_w(i))+&
             & theta(17)*dble(graddeg_w(i))+epsilon_w(3,i,sim))
   end if
 
  
  if(theta(10)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+theta(16)*dble(perfec_w(i))+&
           & theta(17)*dble(graddeg_w(i))+epsilon_w(3,i,sim).ge.1.0D307.OR.&
           &theta(10)+theta(11)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+theta(16)*dble(perfec_w(i))+&
           & theta(17)*dble(graddeg_w(i))+epsilon_w(3,i,sim).ge.1.0D307.OR.&
           &theta(10)+theta(12)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+theta(16)*dble(perfec_w(i))+&
           & theta(17)*dble(graddeg_w(i))+epsilon_w(3,i,sim).ge.1.0D307) then
    write(*,*) "WARNING: Argument of exp() in subroutine simdata_casenw is dangerously high"
    noeval=1
    !write(*,*) "Type any integer to continue"
    !read(*,*) stopping
  end if
 
             
  end do !sim 
end do !i

!Compute optimal choice for each worker, and simulation number


do i=1,n_w

    mkt=mkt7_w(i)



  
    
    !NT: notice: they vary by worker's type, NB: constNT=ability constant. ln_r=log of wage
    if(mkt.eq.1) then
     constNT(1)=theta(18)
     constNT(2)=theta(18)+theta(36)
     constNT(3)=theta(18)+theta(54)
     ln_r=0.10d0
    constM(1)=theta(1)
     constM(2)=theta(1)+theta(2)
     constM(3)=theta(1)+theta(3)


    else if (mkt.eq.2) then
    constNT(1)=theta(19)
    constNT(2)=theta(19)+theta(37)
    constNT(3)=theta(19)+theta(55)
    ln_r=theta(177)
     constM(1)=theta(288)
     constM(2)=theta(288)+theta(2)
     constM(3)=theta(288)+theta(3)

    else if (mkt.eq.3) then
    constNT(1)=theta(20)
    constNT(2)=theta(20)+theta(38)
    constNT(3)=theta(20)+theta(56)
    ln_r=theta(178)
     constM(1)=theta(289)
     constM(2)=theta(289)+theta(2)
     constM(3)=theta(289)+theta(3)


     else if (mkt.eq.4) then
    constNT(1)=theta(21)
    constNT(2)=theta(21)+theta(39)
    constNT(3)=theta(21)+theta(57)
    ln_r=theta(179)
     constM(1)=theta(290)
     constM(2)=theta(290)+theta(2)
     constM(3)=theta(290)+theta(3)



     else if (mkt.eq.5) then
    constNT(1)=theta(22)
    constNT(2)=theta(22)+theta(40)
    constNT(3)=theta(22)+theta(58)
    ln_r=theta(180)
    constM(1)=theta(291)
     constM(2)=theta(291)+theta(2)
     constM(3)=theta(291)+theta(3)



    else if (mkt.eq.6) then
    constNT(1)=theta(23)
    constNT(2)=theta(23)+theta(41)
    constNT(3)=theta(23)+theta(59)
    ln_r=theta(181)
     constM(1)=theta(292)
     constM(2)=theta(292)+theta(2)
     constM(3)=theta(292)+theta(3)


    else if (mkt.eq.7) then
    constNT(1)=theta(24)
    constNT(2)=theta(24)+theta(42)
    constNT(3)=theta(24)+theta(60)
    ln_r=theta(182)
     constM(1)=theta(293)
     constM(2)=theta(293)+theta(2)
     constM(3)=theta(293)+theta(3)


    else if (mkt.eq.8) then
    constNT(1)=theta(25)
    constNT(2)=theta(25)+theta(43)
    constNT(3)=theta(25)+theta(61)
    ln_r=theta(183)
     constM(1)=theta(294)
     constM(2)=theta(294)+theta(2)
     constM(3)=theta(294)+theta(3)



    else if (mkt.eq.9) then
    constNT(1)=theta(26)
    constNT(2)=theta(26)+theta(44)
    constNT(3)=theta(26)+theta(62)   
    ln_r=theta(184)
    constM(1)=theta(295)
     constM(2)=theta(295)+theta(2)
     constM(3)=theta(295)+theta(3)



    else if (mkt.eq.10) then
    constNT(1)=theta(27)
    constNT(2)=theta(27)+theta(45)
    constNT(3)=theta(27)+theta(63)
    ln_r=theta(185)
    constM(1)=theta(296)
     constM(2)=theta(296)+theta(2)
     constM(3)=theta(296)+theta(3)


    else if (mkt.eq.11) then
    constNT(1)=theta(28)
    constNT(2)=theta(28)+theta(46)
    constNT(3)=theta(28)+theta(64)
    ln_r=theta(186)
     constM(1)=theta(297)
     constM(2)=theta(297)+theta(2)
     constM(3)=theta(297)+theta(3)



    else if (mkt.eq.12) then
    constNT(1)=theta(29)
    constNT(2)=theta(29)+theta(47)
    constNT(3)=theta(29)+theta(65)
    ln_r=theta(187)
    constM(1)=theta(298)
     constM(2)=theta(298)+theta(2)
     constM(3)=theta(298)+theta(3)


    else if (mkt.eq.13) then
    constNT(1)=theta(30)
    constNT(2)=theta(30)+theta(48)
    constNT(3)=theta(30)+theta(66)
    ln_r=theta(188)
     constM(1)=theta(299)
     constM(2)=theta(299)+theta(2)
     constM(3)=theta(299)+theta(3)



    else if (mkt.eq.14) then
    constNT(1)=theta(31)
    constNT(2)=theta(31)+theta(49)
    constNT(3)=theta(31)+theta(67)
    ln_r=theta(189)
    constM(1)=theta(300)
     constM(2)=theta(300)+theta(2)
     constM(3)=theta(300)+theta(3)



    else if (mkt.eq.15) then
    constNT(1)=theta(32)
    constNT(2)=theta(32)+theta(50)
    constNT(3)=theta(32)+theta(68)
    ln_r=theta(190)
    constM(1)=theta(301)
     constM(2)=theta(301)+theta(2)
     constM(3)=theta(301)+theta(3)



    else if (mkt.eq.16) then
    constNT(1)=theta(33)
    constNT(2)=theta(33)+theta(51)
    constNT(3)=theta(33)+theta(69)
    ln_r=theta(191)
    constM(1)=theta(302)
     constM(2)=theta(302)+theta(2)
     constM(3)=theta(302)+theta(3)



    else if (mkt.eq.17) then
    constNT(1)=theta(34)
    constNT(2)=theta(34)+theta(52)
    constNT(3)=theta(34)+theta(70)
    ln_r=theta(192)
     constM(1)=theta(303)
     constM(2)=theta(303)+theta(2)
     constM(3)=theta(303)+theta(3)



    else if (mkt.eq.18) then
    constNT(1)=theta(35)
    constNT(2)=theta(35)+theta(53)
    constNT(3)=theta(35)+theta(71)
    ln_r=theta(193)
     constM(1)=theta(304)
     constM(2)=theta(304)+theta(2)
     constM(3)=theta(304)+theta(3)

    
    end if

do sim=1,Drep


 
  
   if(type_i(i,sim).eq.1) then
  lnwageM(i,sim)=constM(1)+theta(5)*dble(age_w(i))+theta(6)*(dble(age_w(i))**2.0d0)+theta(7)*dble(fem_w(i))+theta(8)*dble(perfec_w(i))+&
                    & theta(9)*dble(graddeg_w(i))+epsilon_w(2,i,sim)


     lnwageV(i,sim) =ln_r+theta(10)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+&
                           & theta(16)*dble(perfec_w(i))+theta(17)*dble(graddeg_w(i))+epsilon_w(3,i,sim)
     lnwageNT(i,sim)=constNT(1)+theta(72)*dble(age_w(i))+theta(73)*(dble(age_w(i))**2.0d0)+theta(74)*dble(fem_w(i))+theta(75)*dble(perfec_w(i))+&
                       & theta(76)*dble(graddeg_w(i))+epsilon_w(4,i,sim) 
     uwM=lnwageM(i,sim)+theta(77)
     uwV=lnwageV(i,sim)+theta(80)
     uwNT=lnwageNT(i,sim)
     uwH=theta(83)+theta(86)*dble(fem_w(i))+theta(87)*dble(fem_w(i))*dble(nkids_w(i))+theta(88)*dble(age_w(i))+theta(194)*(dble(age_w(i)))**2.0d0+&
               & theta(89)*dble(nkids_w(i))+theta(90)*dble(nkids2_w(i))+&
               & theta(91)*(dble(nkids6_w(i))-dble(nkids2_w(i)))+epsilon_w(1,i,sim)
   
   else if (type_i(i,sim).eq.2) then

  lnwageM(i,sim)=constM(2)+theta(5)*dble(age_w(i))+theta(6)*(dble(age_w(i))**2.0d0)+theta(7)*dble(fem_w(i))+theta(8)*dble(perfec_w(i))+&
                    & theta(9)*dble(graddeg_w(i))+epsilon_w(2,i,sim)

   
     lnwageV(i,sim) =ln_r+theta(10)+theta(11)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+&
                      & theta(16)*dble(perfec_w(i))+theta(17)*dble(graddeg_w(i))+epsilon_w(3,i,sim)
     lnwageNT(i,sim)=constNT(2)+theta(72)*dble(age_w(i))+theta(73)*(dble(age_w(i))**2.0d0)+theta(74)*dble(fem_w(i))+theta(75)*dble(perfec_w(i))+&
                     & theta(76)*dble(graddeg_w(i))+epsilon_w(4,i,sim)
     uwM=lnwageM(i,sim)+theta(77)+theta(78)
     uwV=lnwageV(i,sim)+theta(80)+theta(81)
     uwNT=lnwageNT(i,sim)
     uwH=theta(83)+theta(84)+theta(86)*dble(fem_w(i))+theta(87)*dble(fem_w(i))*dble(nkids_w(i))+theta(88)*dble(age_w(i))+&
               & theta(194)*(dble(age_w(i)))**2.0d0+theta(89)*dble(nkids_w(i))+theta(90)*dble(nkids2_w(i))+&
               & theta(91)*(dble(nkids6_w(i))-dble(nkids2_w(i)))+epsilon_w(1,i,sim)

  else if (type_i(i,sim).eq.3) then

  lnwageM(i,sim)=constM(3)+theta(5)*dble(age_w(i))+theta(6)*(dble(age_w(i))**2.0d0)+theta(7)*dble(fem_w(i))+theta(8)*dble(perfec_w(i))+&
                    & theta(9)*dble(graddeg_w(i))+epsilon_w(2,i,sim)


     lnwageV(i,sim) =ln_r+theta(10)+theta(12)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+ &
                       & theta(16)*dble(perfec_w(i))+theta(17)*dble(graddeg_w(i))+epsilon_w(3,i,sim)
     lnwageNT(i,sim)=constNT(3)+theta(72)*dble(age_w(i))+theta(73)*(dble(age_w(i))**2.0d0)+theta(74)*dble(fem_w(i))+theta(75)*dble(perfec_w(i))+ &
                      & theta(76)*dble(graddeg_w(i))+epsilon_w(4,i,sim)
     uwM=lnwageM(i,sim)+theta(77)+theta(79)
     uwV=lnwageV(i,sim)+theta(80)+theta(82)
     uwNT=lnwageNT(i,sim)
     uwH=theta(83)+theta(85)+theta(86)*dble(fem_w(i))+theta(87)*dble(fem_w(i))*dble(nkids_w(i))+theta(88)*dble(age_w(i))+&
           & theta(194)*(dble(age_w(i)))**2.0d0+theta(89)*dble(nkids_w(i))+theta(90)*dble(nkids2_w(i))+&
           & theta(91)*(dble(nkids6_w(i))-dble(nkids2_w(i)))+epsilon_w(1,i,sim)   
   
end if
  

   umax=max(uwM,uwV,uwNT,uwH)
   if(umax==uwM) then
    sM(i,sim)=1.0d0
    sV(i,sim)=0.0d0
    sNT(i,sim)=0.0d0
    sH(i,sim)=0.0d0
   
   
   else if(umax==uwV) then
    sM(i,sim)=0.0d0
    sV(i,sim)=1.0d0
    sNT(i,sim)=0.0d0
    sH(i,sim)=0.0d0
   

   else if (umax==uwNT) then
    sM(i,sim)=0.0d0
    sV(i,sim)=0.0d0
    sNT(i,sim)=1.0d0
    sH(i,sim)=0.0d0
     
   else if (umax==uwH) then
    sM(i,sim)=0.0d0
    sV(i,sim)=0.0d0
    sNT(i,sim)=0.0d0
    sH(i,sim)=1.0d0
   

   else
    write(*,*) "Problem in subroutine simulate_casenw: did not find optimal choice for worker i, of type, sim number", i, wtype, sim
    !read(*,*) stopping
   end if  


  end do !sim
 
end do !i







awM=0.0d0
awV=0.0d0
den_awM=0.0d0
den_awV=0.0d0

do i=1,n_w

 mkt=mkt7_w(i)

  do sim=1,Drep

  if(sM(i,sim).eq.1.0d0) then
    den_awM(mkt)=den_awM(mkt)+id_w(2,i)
    awM(mkt)=awM(mkt)+stskills(i,sim)*id_w(2,i)
  end if

  if(sV(i,sim).eq.1.0d0) then
    den_awV(mkt)=den_awV(mkt)+id_w(2,i)
    awV(mkt)=awV(mkt)+stskills(i,sim)*id_w(2,i)
  end if

   end do !sim
end do !i


zeroSM=0
zeroSV=0


do mkt=1,n_mkt

 
 if(den_awM(mkt).ne.0.0d0) then
 awM(mkt)=awM(mkt)/den_awM(mkt)

  else
  zeroSM(mkt)=1
 end if
  if(den_awV(mkt).ne.0.0d0) then
 awV(mkt)=awV(mkt)/den_awV(mkt)
  else
  zeroSV(mkt)=1
 end if

 if(zeroSV(mkt).eq.1.AND.zeroSM(mkt).eq.1) then   
  noeval=1
 end if

end do






end subroutine simability_workers



