

subroutine Interpolation(l_lnr, u_lnr, l_p, u_p,outputname,Reg,ahatmat,Rsqmat,epsilon_p,epsilon_w,type_ip, type_iw, pv_omat, r_omat,positive_maxaprof)
                       


                       
USE VarDef
USE MATRIX


IMPLICIT NONE

real(8), intent(in)         :: l_lnr, u_lnr, l_p, u_p
character(150), intent(in)  :: outputname
real(8), intent(in)         :: Reg(1:iter_num,1:10)
real(8), intent(out)        :: ahatmat(10,n_mktvd,Dpr),Rsqmat(n_mktvd,Dpr) 
real(8), intent(in)         :: epsilon_p(3,n_svd,D), epsilon_w(4,n_wvd,D), type_ip(n_svd,D), type_iw(n_wvd,D)

real(8), intent(out)        :: pv_omat(n_mktvd, Dpr), r_omat(n_mktvd,Dpr), positive_maxaprof(n_mktvd,Dpr)

integer                     :: noeval



real(8)                       ::  pv, ln_r

real(8)                       :: shock_cost_stand(Dpr), shock_cost(Dpr), shock_cost_iter

integer                       :: i, mkt, stopping, idum, sim, iter, iter_r, iter_pv, sim_cost, k, kk, errinv

integer                       :: num_eval(n_mktvd, Dpr)  !number of evaluation points used in each market and cost shock draw. 

real(8), dimension(n_mktvd)   :: awV, awM, SV, TSV
real(8), dimension(n_mktvd)   :: zeroSM, zeroSV
real(8), dimension(n_mktvd)   :: DV, EPV


real(8), dimension(iter_num,n_mktvd) :: DVmat, EPVmat, TSVmat, SVmat 

real(8)                       :: unit_revenue(iter_num,n_mktvd,Dpr), unit_fellow(iter_num,n_mktvd,Dpr), profitmat(iter_num,n_mktvd,Dpr)

real(8)                       :: XpYprof(10), ybar, RSS, TSS
real(8)                       :: XpX(10,10), XpX_inv(10,10)  
real(8), allocatable          :: Yprof_hat(:)  !It will have a size equal to the number of evaluation points i.e. nonmissing profits
real(8)                       :: checkreg(10,10) 
integer                       :: SINGULAR
integer                     :: use_draw(n_mktvd,Dpr)



!Used by constrained profit maximizaton routine
real(8)                       :: ahat(10)
real(8)                       :: p_o, r_o, lambda_o , maximized_aprofits


errinv=0

use_draw=1
num_eval=0

pv_omat=-99.0d0
r_omat=-99.0d0

noeval=0
ahatmat=0.0d0; Rsqmat=-99.0d0; profitmat=-99.0d0

positive_maxaprof=-99.0d0


!######## Draw cost shocks ############

idum=773
call gasdev(idum, shock_cost_stand,Dpr)


!######### Start looping over the evaluation points (=pairs (pv,r) )



      open(unit=6565,file='profits.txt') !file where I print the simulate profits to double check regressions
iter=0

do iter_r=1,rnodes
 do iter_pv=1,pvnodes
   iter=iter+1  

     !Chebichev 
         pv=(cos(((2.0d0*dble(iter_pv)-1.0d0)/(2.0d0*dble(pvnodes)))*3.14159265))*((u_p-l_p)/2.0d0)+0.5d0*(u_p+l_p+2.0d0*voucher)            !If you change this, change it also in subroutine interpolation
         ln_r=(cos(((2.0d0*dble(iter_r)-1.0d0)/(2.0d0*dble(rnodes)))*3.14159265))*((u_lnr-l_lnr)/2.0d0)+0.5d0*(u_lnr+l_lnr)
      !The cost shock has NO EFFECT on DV, Totskills_wV and awV

      ! ##### Given current iteration for rate (the same for all markets), compute supply of teachers, supply of teaching skills and average taching skills
      !       in all markets. Output also a dummy for whether at that price there is zero supply to M or to V, in each market

      call simulate_workers(ln_r,epsilon_w, type_iw,awV, awM, SV, TSV, zeroSM, zeroSV ) 

      ! ##### Given current iteration for price (the same for all markets) and given the current teaching abilities, compute demand for enrollment and average price paid
      !       in all markets. If for a certain market there are zero teachers in both schools at that value: assume that DV=0, and assign  alow value to profits (zero?)
      !      so that it will never want to pick that value at the optimum 

      call simulate_parents(pv, zeroSM, zeroSV, awM,awV,epsilon_p, type_ip, DV, EPV )

    ! write(*,*) "CLass size mkt1", DV(1)/SV(1)
    !Fill in a matrix with: DV, EPV, TSV, SV in all markets and at all evaluation points
     
    do mkt=1, n_mktvd
      DVmat(iter,mkt)=DV(mkt)
      EPVmat(iter,mkt)=EPV(mkt)
      TSVmat(iter,mkt)=TSV(mkt)
      SVmat(iter,mkt)=SV(mkt)

     !## Conditional on being in a certain markte, start loop over cost shock
     !## Interpolate profits inside the cost shock loop

     do sim_cost=1,Dpr
        shock_cost(sim_cost)=exp( exp(theta2(1))*shock_cost_stand(sim_cost)  )/100.0d0  !the cost is lognormal, so I have to take the exp of the normal draw. Unit change, innocuous. 
        shock_cost_iter=shock_cost(sim_cost)

        if(DV(mkt).ne.0.0d0.AND.SV(mkt).ne.0.0d0) then
           !write profit function using actual governmental formulas
           if(0.50d0*oneUSE<EPVmat(iter,mkt).le.oneUSE) then
              unit_revenue(iter,mkt,sim_cost)=Reg(iter,2)-0.10d0*(EPVmat(iter,mkt)-0.50d0*oneUSE)
           else if (oneUSE<EPVmat(iter,mkt).le.2.0d0*oneUSE) then
              unit_revenue(iter,mkt,sim_cost)=Reg(iter,2)-0.10d0*0.50d0*oneUSE-0.20d0*(EPVmat(iter,mkt)-oneUSE)
           else if (2.0d0*oneUSE<EPVmat(iter,mkt))  then
              unit_revenue(iter,mkt,sim_cost)=Reg(iter,2)-0.10d0*0.50d0*oneUSE-0.20d0*oneUSE-0.350d0*(EPVmat(iter,mkt)-2.0d0*oneUSE)
           end if 
        
           if(EPVmat(iter,mkt).le.oneUSE) then
             unit_fellow(iter,mkt,sim_cost)=0.050d0*EPVmat(iter,mkt)
           else if (oneUSE<EPVmat(iter,mkt).le.2.0d0*oneUSE) then
             unit_fellow(iter,mkt,sim_cost)=0.050d0*oneUSE+0.070d0*(EPVmat(iter,mkt)-oneUSE)
           else if(2.0d0*oneUSE<EPVmat(iter,mkt)) then
             unit_fellow(iter,mkt,sim_cost)=0.050d0*oneUSE+0.070d0*oneUSE+0.10d0*(EPVmat(iter,mkt)-2.0d0*oneUSE)
           end if

        profitmat(iter,mkt,sim_cost)=(unit_revenue(iter,mkt,sim_cost)-unit_fellow(iter,mkt,sim_cost))*DV(mkt)-(theta2(2)+shock_cost_iter)*DV(mkt)-theta2(3)*DV(mkt)**2.0d0&
                                   &-(exp(ln_r)*TSV(mkt))-theta2(4)*((DV(mkt)/SV(mkt))/45.0d0)
  
             if(profitmat(iter,mkt,sim_cost)>0.0d0) then
               num_eval(mkt,sim_cost)=num_eval(mkt,sim_cost)+1

             else
                profitmat(iter,mkt,sim_cost)=-99.0d0

              end if

        else
    
          profitmat(iter,mkt,sim_cost)=-99.0d0  

       end if !DV=0 and SV=0

        





     end do !sim cost

   end do !mkt


        


 end do !iter_pv
end do  !iter_ln

close(6565)








 
!###### Done computing true value of profits in each market, at each evaluation point and for each error shock. Now interpolate for each mkt and error shock draw.
!replace profit to missing when negative. Negative values are due to SV=0, which happens only bc I use the empirical distribution
!of teachers' oservables instead of the theoretical one, which would be such that SV never =0.


    

do sim_cost=1,Dpr
   do mkt=1,n_mktvd
   
   if(num_eval(mkt,sim_cost)<1) then   !i.e. if profits are always negative at this cost shock draw and for this market

   use_draw(mkt,sim_cost)=0

   
   
  else   !if there are positive profits, then compute the ahat interpolation parameters and max the approximated profits

 
   XpYprof=0.00
     do k=1,10 !9 regressors + 1 constant =10
      do i=1, iter_num  !num_eval(mkt,sim_cost)
       if(profitmat(i,mkt,sim_cost).ne.-99.0d0) then
        XpYprof(k)=XpYprof(k)+Reg(i,k)*profitmat(i,mkt,sim_cost) 
       end if    
      end do !i
     end do !k


!Compute XpX and XpX_inv used in all regressions
XpX=0.00d0
 
  
  do kk=1,10
   do k=1,10 !9 regressors + 1 constant =10
    do i=1, iter_num !num_eval(mkt,sim_cost)
       if(profitmat(i,mkt,sim_cost).ne.-99.0d0) then
           XpX(k,kk)=XpX(k,kk)+Reg(i,k)*Reg(i,kk)

       end if
   end do !i
  end do !k
 end do !kk
 

!write(*,*) "XpX", XpX
!write(*,*) "num_eval", num_eval(mkt,sim_cost)
!write(*,*) "mkt, sim_cost", mkt, sim_cost
!write(*,*) 
 
XpX_inv=XpX !initializing

XpX_inv=MATINV(XpX)

!call matrix_inverse(XpX,XpX_inv)
!SINGULAR=0
!call  dmatinv2(XpX,XpX_inv,10,SINGULAR)  !first is matrix to be inverted, second is matrix that is inverted


!write(*,*) "Checking that inverse computed correctly"


checkreg=0.00
do kk=1,10
   do k=1,10 !9 regressors + 1 constant = 10 
  do i=1,10
    checkreg(k,kk)=checkreg(k,kk)+XpX_inv(k,i)*XpX(i,kk) 
   end do
  end do !k
 end do !kk
 
 
 do kk=1,10
  do k=1,10
    if(k==kk.AND.(checkreg(k,kk)<0.999.OR.checkreg(k,kk)>1.001)) then
   !  write(*,*) "ERROR while inverting XpX for csV and profit approximation"
   !  write(*,*) "Diagonal element not close enough to 1.0=", checkreg(k,kk)
   !  write(*,*) "number of obs used", num_eval(mkt,sim_cost)
   !  write(*,*) "mkt, sim_cost", mkt, sim_cost
    ! write(*,*) "XpX row by row"
    ! write(*,*) "Row 1:", XpX(1,1:10)
    ! write(*,*) "Row 2:", XpX(2,1:10)
    ! write(*,*) "Row 3:", XpX(3,1:10)
    ! write(*,*) "Row 4:", XpX(4,1:10)
    ! write(*,*) "Row 5:", XpX(5,1:10)
    ! write(*,*) "Row 6:", XpX(6,1:10)
     errinv=1
        !  read(*,*) stopping
    else if(k.ne.kk.AND.(checkreg(k,kk)<-0.001.OR.checkreg(k,kk)>0.001)) then
    ! write(*,*) "ERROR while inverting matrix XpX for csV and profit approximation"
    ! write(*,*) "Off-diagonal element=", checkreg(k,kk)
    ! write(*,*) "number of obs used", num_eval(mkt,sim_cost)
    ! write(*,*) "mkt, sim_cost", mkt, sim_cost
    ! write(*,*) "XpX row by row"
    ! write(*,*) "Row 1:", XpX(1,1:10)
    ! write(*,*) "Row 2:", XpX(2,1:10)
    ! write(*,*) "Row 3:", XpX(3,1:10)
    ! write(*,*) "Row 4:", XpX(4,1:10)
    ! write(*,*) "Row 5:", XpX(5,1:10)
    ! write(*,*) "Row 6:", XpX(6,1:10)
    errinv=1
     !read(*,*) stopping
    end if
  end do
 end do 


 if(errinv.eq.1) then
    ! write(*,*) "Error inverting regressors used in interpolation"
    open(unit=9009, file='./diagnostics_inverse')
      write(9009,*) "Cannot properly invert regressors for interpolation"
    close(9009)
 end if




    ahatmat(1:10,mkt,sim_cost)=0.0d0
    ahat=0.0d0
 
    do k=1,10
      do kk=1,10
       ahatmat(k,mkt,sim_cost)=ahatmat(k,mkt,sim_cost)+XpX_inv(k,kk)*XpYprof(kk)
       ahat(k)=ahat(k)+XpX_inv(k,kk)*XpYprof(kk)
      end do !kk
    end do !k
   
  


!############ Stay within the market and cost shock draw, and compute the optimal tuition and wage rates ################

   call constr_maxprof(ahat, p_o, r_o, lambda_o,u_p, l_p, u_lnr, l_lnr,maximized_aprofits)

   pv_omat(mkt,sim_cost)=p_o
   r_omat(mkt,sim_cost)=r_o

   if(maximized_aprofits>0.0d0) then
      positive_maxaprof(mkt,sim_cost)=1.0d0
   else
      positive_maxaprof(mkt,sim_cost)=0.00   !this should never be the case, since we know that there are positive profits for some prices and wages...
   end if





     end if !that selects out the case in which there are zero observations with nonmissing profits . profits are missing if either zeroSV or zeroDV or they are negative
   end do !mkt
end do !cost shock


end subroutine Interpolation
