PROGRAM Main_Step2

USE VarDef
USE Datasets


IMPLICIT NONE



character(150) :: inputname, outputname, tag
real(8)        :: gamma_step1(212), rates(n_mkt)

integer        :: i, npar, idum, sim, noeval, sim_cost, mkt

real(8)        :: ln_r1(n_mkt) !these are the rental rates estimated in the previous step

!shocks and types of workers and parents
real(8)        :: epsilon_pvec(3*n_s*D), epsilon_p(3,n_s,D), epsilon_wvec(4*n_w*D), epsilon_w(4,n_w,D)
real(8)        :: Psi_w(3), Psi_p(3), unif_w(n_w*D), unif_p(n_s*D)
integer        :: type_ip(n_s,D), type_iw(n_w,D)

!Interpolating profits: obtain one interpolation per market and per shock draw
real(8)        :: Reg(iter_num,10), XpX(10,10), XpX_inv(10,10), ahatmat(10,n_mktvd,Dpr),Rsqmat(n_mktvd,Dpr)

!Choosing the lower and upper extremes for the interpolation of ln_r and pv
real(8)        :: l_lnr, u_lnr, l_p, u_p

!Solutions: one per market and per cost draw
real(8)        :: pv_omat(n_mktvd, Dpr), r_omat(n_mkt,Dpr), positive_maxaprof(n_mktvd,Dpr)



!For the likelihood
integer      :: Rused(n_mktvd)  
 
real(8)      :: dens(n_mktvd), bandwidth, log_likeli
integer      :: keep(n_mktvd,Dpr)


keep=0

l_lnr=-2.3900d0; u_lnr=0.30d0   

l_p=0.10d0; u_p=13.80d0       







!###################################################################

!##### Read in input parameters and assign thetas using gamma ######

!###################################################################

!Read in the 4 parameters I'm iterating over, then read in the prameters fro mthje previous step
call getarg(1,inputname)
call getarg (2,outputname)
call getarg(3,tag)


open (unit=7786,file=inputname,access='sequential')
  read(7786,*)
  do i=1,5
   if(i.eq.1) then
   read(7786,*) npar
   else
   read(7786,*) theta2(i-1)
  end if
  end do
close(7786)




!Now read in paramters that stay fixed
gamma_step1=0.0d0

open(unit=1732,file='./gamma_step1_212_aug22')
do i=1,212
   read(1732,*) gamma_step1(i)
end do
close(1732)




!Now read in the only paraemters I iterate over
theta=0.0d0





!Assign thetas of workers (the rental rates won't be used)
do i=1,3
  theta(i)=gamma_step1(i)
end do
do i=5,93
 theta(i)=gamma_step1(i-1)
end do
do i=106,109
 theta(i)=gamma_step1(i-13)
end do
 theta(194)=gamma_step1(97)
do i=177, 193
 theta(i)=gamma_step1(i-79)
end do
do i=287,304
 theta(i)=gamma_step1(i-172)
end do





 !estimated data: ln_r1 (from step 1)
 do i=177,193

   ln_r1(i-175)=theta(i)
 end do
  ln_r1(1)=0.10d0 !r in market one has been normalized to 0.1d0

 !Now set the thetas to zero so that I don't use the wrong ones 
do i=177,193
 theta(i)=0.0d0 !Letting the rental rates be zero, safety measure (a zero will give me an error message)
end do





!Assign thetas of parents
do i=110, 120
 theta(i)=gamma_step1(i+23)
end do
do i=123,128
 theta(i)=gamma_step1(i+21)
end do
do i=155,157
 theta(i)=gamma_step1(i-5)
end do
do i=162, 165
 theta(i)=gamma_step1(i-9)
end do
 theta(169)=gamma_step1(157)
 theta(171)=gamma_step1(158)
 theta(195)=gamma_step1(159)
do i=197,244
 theta(i)=gamma_step1(i-37)
end do
 theta(247)=gamma_step1(208)
do i=249,252
 theta(i)=gamma_step1(i-40)
end do




!#######################################################

!############## Read in datasets #######################

!######################################################


!SIMCE06_media and primaria together
open(unit=12,file='./SIMCE410_final.txt')
    do i=1,n_s
       read(12,*) id_s(i), mkt7_s(i),primaria_s(i),rural_s(i), nfam_s(i), peduc_s(i), fem_s(i), unempl_s(i), blue_s(i), mincome_s(i), &
       & m_s(i), v_s(i), mtuition_s(i), standability_s(i) 
    end do
close(12)  


do i=1,n_s
  mincome_s(i)=mincome_s(i)/100000.0d0
  if(blue_s(i).eq.2) then
   blue_s(i)=0
  end if 
end do

do i=1,n_s
 if(mkt7_s(i).eq.6661) then
     mkt7_s(i)=1
    else if (mkt7_s(i).eq.6662) then
     mkt7_s(i)=2 
    else if (mkt7_s(i).eq.6663) then
     mkt7_s(i)=3 
    else if (mkt7_s(i).eq.6664) then
     mkt7_s(i)=4 
    else if (mkt7_s(i).eq.6665) then
     mkt7_s(i)=5 
    else if (mkt7_s(i).eq.6666) then
     mkt7_s(i)=6 
    else if (mkt7_s(i).eq.6667) then
     mkt7_s(i)=7 
    else if (mkt7_s(i).eq.6668) then
     mkt7_s(i)=8 
    else if (mkt7_s(i).eq.6669) then
     mkt7_s(i)=9 
    else if (mkt7_s(i).eq.66610) then
     mkt7_s(i)=10 
    else if (mkt7_s(i).eq.66612) then
     mkt7_s(i)=11 
    else if (mkt7_s(i).eq.66613) then
     mkt7_s(i)=12 
    else if (mkt7_s(i).eq.66614) then
     mkt7_s(i)=13 
    else if (mkt7_s(i).eq.66615) then
     mkt7_s(i)=14 
    else if (mkt7_s(i).eq.66616) then
     mkt7_s(i)=15 
    else if (mkt7_s(i).eq.66617) then
     mkt7_s(i)=16 
    else if (mkt7_s(i).eq.66618) then
     mkt7_s(i)=17 
    else if (mkt7_s(i).eq.66619) then
     mkt7_s(i)=18 
   end if
end do

 !### read in the workers' dataset ######



!WORKERS UNIQUE
open(unit=13,file='./workers_unique.txt') !a dot between final and trim indicates that this is the dataset with the corrected weights (corrected using idoneidad and fraction teaching obtained in original casen, before imputation)
    do i=1,n_w
       read(13,*) id_w(1,i), id_w(2,i), mkt7_w(i), graddeg_w(i), perfec_w(i), nkids_w(i), nkids2_w(i), nkids6_w(i), age_w(i), fem_w(i), &
       & peduc_w(i), m_w(i), v_w(i), nt_w(i), h_w(i),wage_w(i)
    end do
close(13)

     
do i=1,n_w
   wage_w(i)=wage_w(i)/100000.0d0
end do

do i=1,n_w
  age_w(i)=age_w(i)-19

   if(mkt7_w(i).eq.6661) then
     mkt7_w(i)=1
    else if (mkt7_w(i).eq.6662) then
     mkt7_w(i)=2 
    else if (mkt7_w(i).eq.6663) then
     mkt7_w(i)=3 
    else if (mkt7_w(i).eq.6664) then
     mkt7_w(i)=4 
    else if (mkt7_w(i).eq.6665) then
     mkt7_w(i)=5 
    else if (mkt7_w(i).eq.6666) then
     mkt7_w(i)=6 
    else if (mkt7_w(i).eq.6667) then
     mkt7_w(i)=7 
    else if (mkt7_w(i).eq.6668) then
     mkt7_w(i)=8 
    else if (mkt7_w(i).eq.6669) then
     mkt7_w(i)=9 
    else if (mkt7_w(i).eq.66610) then
     mkt7_w(i)=10 
    else if (mkt7_w(i).eq.66612) then
     mkt7_w(i)=11 
    else if (mkt7_w(i).eq.66613) then
     mkt7_w(i)=12 
    else if (mkt7_w(i).eq.66614) then
     mkt7_w(i)=13 
    else if (mkt7_w(i).eq.66615) then
     mkt7_w(i)=14 
    else if (mkt7_w(i).eq.66616) then
     mkt7_w(i)=15 
    else if (mkt7_w(i).eq.66617) then
     mkt7_w(i)=16 
    else if (mkt7_w(i).eq.66618) then
     mkt7_w(i)=17 
    else if (mkt7_w(i).eq.66619) then
     mkt7_w(i)=18 
   end if
end do







!MKT_CHAR
open(unit=16,file='./mkt_char5.csv')
    do i=1,n_mktvd
       read(16,*) mkt7(i),  size_mkt7(i), educ_mkt7(i),   sdeduc_mkt7(i), blue_mkt7(i),mincome_mkt7(i), sdminc_mkt7(i), fona_mkt7(i), fonb_mkt7(i), fonc_mkt7(i),&
                 & fond_mkt7(i),isapre_mkt7(i), chilesol_mkt7(i), rural_mkt7(i), unempl_mkt7(i), nowork_mkt7(i), nsub_mkt7(i), r_13(i), r_15(i), Norte(i),&
                 & Central(i), Sur(i), numM(i), numV(i), numU(i),Drural_mkt7(i), Dchilsol_mkt7(i),studM_mkt7(i),studV_mkt7(i),sharestudV_mkt7(i), teachM_mkt7(i),&
                 & imp_teachV_mkt7(1,i),imp_teachV_mkt7(2,i),imp_teachV_mkt7(3,i),imp_teachV_mkt7(4,i),imp_teachV_mkt7(5,i),imp_teachV_mkt7(6,i),imp_teachV_mkt7(7,i), &
                 & imp_teachV_mkt7(8,i),imp_teachV_mkt7(9,i),imp_teachV_mkt7(10,i),imp_shareteachV_mkt7(1,i),imp_shareteachV_mkt7(2,i),imp_shareteachV_mkt7(3,i),&
                 & imp_shareteachV_mkt7(4,i),imp_shareteachV_mkt7(5,i),imp_shareteachV_mkt7(6,i),imp_shareteachV_mkt7(7,i),imp_shareteachV_mkt7(8,i),&
                 & imp_shareteachV_mkt7(9,i),imp_shareteachV_mkt7(10,i), imp_studteachV(1,i),imp_studteachV(2,i),imp_studteachV(3,i),imp_studteachV(4,i),imp_studteachV(5,i),&
                 & imp_studteachV(6,i),imp_studteachV(7,i),imp_studteachV(8,i),imp_studteachV(9,i),imp_studteachV(10,i), studteachM(i), mean_maxpv(i)
    end do  
close(16)



!Market level categories
!pvd_cat, educd_cat, mincomed_cat
do i=1,n_mkt
 !pvd_cat
 if(mean_maxpv(i)<=40000.0d0.AND.mean_maxpv(i)>=0.0d0) then
   pvd_cat(i)=1
 else if  (mean_maxpv(i)<=48000.0d0.AND.mean_maxpv(i)>40000.0d0) then
   pvd_cat(i)=2
 else if (mean_maxpv(i)<=53500.0d0.AND.mean_maxpv(i)>48000.0d0 ) then
   pvd_cat(i)=3
 else if (mean_maxpv(i)>53500.0d0) then
   pvd_cat(i)=4
 else
   pvd_cat(i)=-99
 end if
 
 !educd_cat
 if(educ_mkt7(i)<=8.60d0.AND.educ_mkt7(i)>=0.0d0) then
  educd_cat(i)=1
 else if (educ_mkt7(i)> 8.60d0.AND.educ_mkt7(i)<=9.30d0) then
  educd_cat(i)=2
 else if (educ_mkt7(i)>9.30d0.AND.educ_mkt7(i)<=10.10d0) then
  educd_cat(i)=3
 else if (educ_mkt7(i)>10.10d0) then
  educd_cat(i)=4
 else
  educd_cat(i)=-99
 end if
 
 !mincomed_cat
 if(mincome_mkt7(i)<=190000.0d0.AND.mincome_mkt7(i)>=0.0d0) then
  mincomed_cat(i)=1
 else if(mincome_mkt7(i)>190000.0d0.AND.mincome_mkt7(i)<=211358.0d0) then
  mincomed_cat(i)=2
 else if (mincome_mkt7(i)>211358.0d0.AND.mincome_mkt7(i)<=250000.0d0) then
  mincomed_cat(i)=3
 else if (mincome_mkt7(i)>250000.0d0) then
  mincomed_cat(i)=4
 else
  mincomed_cat(i)=-99
 end if
 
 !Dblue dummy
 if(blue_mkt7(i).le.0.6490d0) then
  Dblue_mkt7(i)=0
 else
  Dblue_mkt7(i)=1
 end if 
end do

                 

do i=1,n_mkt
  mincome_mkt7(i)=mincome_mkt7(i)/100000.0d0
  mean_maxpv(i)=mean_maxpv(i)/100000.0d0
end do
do i=1,n_mkt
 if(rural_mkt7(i)>=.22) then
  Drural_mkt7(i)=1.0d0
 else
  Drural_mkt7(i)=0.0d0
 end if
 if(chilesol_mkt7(i)>=0.0128) then
  Dchilsol_mkt7(i)=1.0d0
 else
  Dchilsol_mkt7(i)=0.0d0
 end if    
end do

CALL cpu_time (EndTime)
!write(*,*) "Time:", EndTime-StartTime
MidTime=EndTime







!#######################################################################################################################

!   To interpolate the profit function I must iterate over price and rates. To speed up the program, I draw OUTSIDE of these loops
!   the workers' and parents shocks and types.

!#########################################################################################################################



	idum=7777
	call gasdev(idum,epsilon_pvec,3*n_s*D)

 
	do i=1,n_s
 	 do sim=1,D
  	   epsilon_p(1,i,sim)=exp(theta(156))*epsilon_pvec(i+(sim-1)*n_s)          !production of cogn ach in M
  	   epsilon_p(2,i,sim)=exp(theta(157))*epsilon_pvec(n_s*D+i+(sim-1)*n_s)    !production of cogn ach in V
  	   epsilon_p(3,i,sim)=exp(theta(155))*epsilon_pvec(2*n_s*D+i+(sim-1)*n_s)  !preference for M
 	 end do 
	end do



	!Draw epsilon_w i.e. the worker's shocks

	! Draw D draws for every worker, and shock type
	idum=3333
	call gasdev(idum,epsilon_wvec,4*n_w*D)

	do i=1,n_w
	 do sim=1,D
	  epsilon_w(1,i,sim)=exp(theta(106))*epsilon_wvec(i+(sim-1)*n_w)        !preference for Home
	  epsilon_w(2,i,sim)=exp(theta(107))*epsilon_wvec(n_w*D+i+(sim-1)*n_w)   !shock in M wage
	  epsilon_w(3,i,sim)=exp(theta(108))*epsilon_wvec(2*n_w*D+i+(sim-1)*n_w) !shock in V wage
	  epsilon_w(4,i,sim)=exp(theta(109))*epsilon_wvec(3*n_w*D+i+(sim-1)*n_w) !shock in NT wage
	 end do
	end do  


	!Draw one type draw for each individual and simulation
	Psi_w(1)=1.0d0-theta(92)-theta(93)
	Psi_w(2)=theta(92)
	Psi_w(3)=theta(93)

	!write(*,*) "Prob1, prob2, prob3", Psi(1), Psi(2), Psi(3)


	idum=777
	unif_w=-99.0d0
	call ran1(idum,unif_w,n_w*D)

	do i=1,n_w
	  do sim=1,D
	    if(unif_w(i+(sim-1)*D)>=0.0d0.AND.unif_w(i+(sim-1)*D)<=Psi_w(1)) then
	      type_iw(i,sim)=1
	    else if(unif_w(i+(sim-1)*D)>Psi_w(1).AND.unif_w(i+(sim-1)*D)<=Psi_w(1)+Psi_w(2)) then
	      type_iw(i,sim)=2
	    else if (unif_w(i+(sim-1)*D)>Psi_w(1)+Psi_w(2).AND.unif_w(i+(sim-1)*D)<=1.0d0) then
	      type_iw(i,sim)=3
	    end if
	   end do
	end do


	
	!Draw one type draw for each individual
	Psi_p(1)=(1.0d0-theta(127)-theta(128))
	Psi_p(2)=theta(127)
	Psi_p(3)=theta(128)

	idum=775
	unif_p=-99.0d0
	call ran1(idum,unif_p,n_s*D)

	do i=1,n_s
	  do sim=1,D
	    if(unif_p(i+(sim-1)*D)>=0.0d0.AND.unif_p(i+(sim-1)*D)<=Psi_p(1)) then
	      type_ip(i,sim)=1
	    else if(unif_p(i+(sim-1)*D)>Psi_p(1).AND.unif_p(i+(sim-1)*D)<=Psi_p(1)+Psi_p(2)) then
	      type_ip(i,sim)=2
	    else if (unif_p(i+(sim-1)*D)>Psi_p(1)+Psi_p(2).AND.unif_p(i+(sim-1)*D)<=1.0d0) then
	      type_ip(i,sim)=3
	    end if
	   end do
	end do



!##############################################################

! Interpolate profits ########################################

!############################################################


!The matrix Reg has a number of lines equal to the number of observations on prices and rates used in the interpolation, and a number of columns equal to 10, the number of regressors
!used in the interpoalting polynomial
!The regressors are:
!     Reg(iter,1)=constant
!     Reg(iter,2)=pv                          !pv in terms of 100mila pesos
!     Reg(iter,3)=Reg(iter,2)**2.0d0          !pv^2
!     Reg(iter,4)=exp(ln_r)!exp(dble(lnr_iter)/100.0d0) !r (on wage expressed in millions)
!     Reg(iter,5)=Reg(iter,4)**2.0d0          !r^2
!     Reg(iter,6)=Reg(iter,2)*Reg(iter,4)     !pv*r
!     Reg(iter,7)=Reg(iter,2)**3.0d0          !pv^3
!     Reg(iter,8)=Reg(iter,4)**3.0d0          !r^3
!     Reg(iter,9)=Reg(iter,3)*Reg(iter,4)     !pv^2 * r
!     Reg(iter,10)=Reg(iter,2)*Reg(iter,5)    !pv * r^2


call  assign_regressors(l_lnr, u_lnr, l_p, u_p, Reg)





  
!write(*,*) ""
!write(*,*) "Interpolate and compute optimal prices in each market and cost shock draw"
call Interpolation(l_lnr, u_lnr, l_p, u_p,outputname,Reg,ahatmat,Rsqmat,epsilon_p,epsilon_w,type_ip, type_iw, pv_omat, r_omat,positive_maxaprof)





!############ Estimation ##############


Rused=0
bandwidth=0.0d0
keep=0
do sim_cost=1,Dpr
 do mkt=1,n_mktvd

   if(pv_omat(mkt,sim_cost)>0.0d0.AND.r_omat(mkt,sim_cost)>0.0d0.AND.positive_maxaprof(mkt,sim_cost)>0.0d0) then  !get rid of case of negative r or p beacuse I don't allow for taht
     Rused(mkt)=Rused(mkt)+1                    !Also, I am trunctating, i.e. selecting only the draws that are such that the maximal profits are positive!
     keep(mkt,sim_cost)=1
   end if

 !legend for p_o and r_o
 !-994 means lack of convergence (but no infinite loop)
 !-999 means infinite loop
 !-99 means I could solve, but it was not a  maximum

 !  write(88364,*) mkt, sim_cost, pv_omat(mkt,sim_cost), r_omat(mkt,sim_cost)


 end do
end do





	dens=0.0d0
         do mkt=1,n_mkt
	    	bandwidth=((4.0d0/5.0d0)**(1.0d0/6.0d0))*dble(Rused(mkt))**(-1.0d0/6.0d0)




	if(Rused(mkt)>0) then
	   do sim_cost=1,Dpr !Rused(mkt)
             if(keep(mkt,sim_cost).eq.1) then
		  dens(mkt)=dens(mkt)+(1.0d0/dble(Rused(mkt))*(bandwidth**2.0d0))*(1.0d0/2.0d0*3.14159265358979323846264338327950288419716939937510d0)*exp(-0.50d0* ( ( (pv_omat(mkt,sim_cost)-(1.20d0+voucher))/bandwidth)**2.0d0+ &
       	  & ((r_omat(mkt,sim_cost)-exp(ln_r1(mkt)) )/bandwidth)**2.0d0    )  )
              end if
	   end do

	else
           dens(mkt)=-99.0d0
	end if
	  end do !mkt


  



 log_likeli=0.0d0
do mkt=1,n_mkt
  if(dens(mkt).ne.-99.0d0.AND.dens(mkt).ne.0.0d0) then
  log_likeli=log_likeli+log(dens(mkt))
  end if
   if(dens(mkt).eq.0.0d0.OR.dens(mkt).eq.-99.0d0) then
    log_likeli=log_likeli+(-10000000000.0d0)
   end if
end do



open(unit=900, file=outputname)
      write(900,*) 1
      write(900,*) -log_likeli
     close(900)
































END PROGRAM Main_Step2