subroutine assign_regressors(l_lnr, u_lnr, l_p, u_p, Reg)
USE VarDef
IMPLICIT NONE

real(8), intent(in) :: l_lnr, u_lnr, l_p, u_p
real(8), intent(out) :: Reg(iter_num,10)

integer              :: iter_pv, iter_r, k, kk, i, stopping, iter
real(8)              :: pv, ln_r, checkreg(10,10)




!=============================  ASSIGN REGRESSORS FOR PROFIT APPROX   =====================
!### before drawing cost shocks, set value of regressors, which are the same across markets and cost shocks
!First, fill in regressors, which stay constant across markets
!Do it only for the first cost shock iteration





!write(*,*) "Assigning values to regressors"
Reg(1:iter_num,1)=1.0d0 !constant

iter=0
do iter_r=1,rnodes
 do iter_pv=1,pvnodes
    iter=iter+1

    pv=(cos(((2.0d0*dble(iter_pv)-1.0d0)/(2.0d0*dble(pvnodes)))*3.14159265))*((u_p-l_p)/2.0d0)+0.5d0*(u_p+l_p+2.0d0*voucher)   !If you change this, change it also in subroutine interpolation
    ln_r=(cos(((2.0d0*dble(iter_r)-1.0d0)/(2.0d0*dble(rnodes)))*3.14159265))*((u_lnr-l_lnr)/2.0d0)+0.5d0*(u_lnr+l_lnr)         !If you change this, change it also in subroutine interpolation
     !change also staring values in subroutine constr_maxprof_only_1_constr
    
    
     Reg(iter,2)=pv     !pv in terms of 100k pesos
     Reg(iter,3)=Reg(iter,2)**2.0d0          !pv^2
     Reg(iter,4)=exp(ln_r)!exp(dble(lnr_iter)/100.0d0) !r (on wage expressed in millions)
     Reg(iter,5)=Reg(iter,4)**2.0d0          !r^2
     Reg(iter,6)=Reg(iter,2)*Reg(iter,4)     !pv*r
     Reg(iter,7)=Reg(iter,2)**3.0d0          !pv^3
     Reg(iter,8)=Reg(iter,4)**3.0d0          !r^3
     Reg(iter,9)=Reg(iter,3)*Reg(iter,4)     !pv^2 * r
     Reg(iter,10)=Reg(iter,2)*Reg(iter,5)    !pv * r^2
    end do
  end do 
  
 ! write(*,*) "Finished assigning values to regressors"
 

end subroutine assign_regressors