subroutine constr_maxprof(ahat, p_o, r_o, lambda_o, u_p, l_p, u_lnr, l_lnr, maximized_aprofits)
USE VarDef
IMPLICIT NONE


!optimal prices outputted are -999 if I was unable to find an optimum, and -99 if what I found was a minimum and not an optimum



real(8), intent(in)  :: ahat(10)
real(8), intent(in)  :: u_p, l_p, u_lnr, l_lnr
real(8), intent(out) :: p_o, r_o, lambda_o  !o stands for optimal
real(8), intent(out)  :: maximized_aprofits
real(8)              :: pv(2), r(2), lambda(2),lambdak(2), max_prof(2) !1 for each of the 2 combinations
real(8)              :: pk(2), rk(2) !For Newton's method
integer              :: k,kk, i, count, stopping, SING, exiting,exiting1, exiting2, conv, conv2
real(8), parameter   :: epsilon=0.0000000000001d0, delta=0.00010d0
real(8)              :: J(2,2), detJ, sys(2), sk(2), Jcase2(3,3), Jcase2_inv(3,3), H(2,2), detH
integer              :: success, case1, feasible


p_o=-9911.0d0; r_o=-9911.0d0; lambda_o=-99.0d0; lambdak=-99.0d0; H=-99.0d0; exiting=0; exiting2=0
max_prof=-99.0d0
conv=-9911; conv2=-9911
success=0
!2 cases: solve for FOC's of lagrangean wrt p and r for each of the 2 combinations of binding and not binding constaints

!*************************************************
!*************************************************
!CASE 1: pv not binding  --> lambda=0
!        solve for r and pv
!  
!*************************************************
!*************************************************
!Solve for p and r


lambda(1)=0.0d0



!Initial guesses for p and r

 



pv(1)=((cos(((2.0d0*dble(1)-1.0d0)/(2.0d0*dble(pvnodes)))*3.14159265))*((u_p-l_p)/2.0d0)+0.5d0*(u_p+l_p+2.0d0*voucher)+&
     &(cos(((2.0d0*dble(pvnodes)-1.0d0)/(2.0d0*dble(pvnodes)))*3.14159265))*((u_p-l_p)/2.0d0)+0.5d0*(u_p+l_p+2.0d0*voucher))/2.0d0
     
r(1)=(exp((cos(((2.0d0*dble(1)-1.0d0)/(2.0d0*dble(rnodes)))*3.14159265))*((u_lnr-l_lnr)/2.0d0)+0.5d0*(u_lnr+l_lnr) )&
     & + exp((cos(((2.0d0*dble(rnodes)-1.0d0)/(2.0d0*dble(rnodes)))*3.14159265))*((u_lnr-l_lnr)/2.0d0)+0.5d0*(u_lnr+l_lnr) ))/2.0d0


pk(1)=pv(1)+epsilon*(1.0d0+pv(1))+10.0d0
rk(1)=r(1)+epsilon*(1.0d0+r(1))+10.0d0
sk(1)=epsilon*(1.0d0+pv(1))+10.0d0
sk(2)=epsilon*(1.0d0+r(1))+10.0d0

if(abs(sk(1))<=epsilon*(1.0d0+abs(pk(1))).OR.abs(sk(2))<=epsilon*(1.0d0+abs(rk(1)))) then
write(*,*) "problem in initialization, case1"
end if



count=0
exiting=0
exiting1=0
do while(    (abs(sk(1))>epsilon*(1.0d0+abs(pk(1))).OR.abs(sk(2))>epsilon*(1.0d0+abs(rk(1)))    ) .AND.exiting.eq.0)
 count=count+1

  !Compute Jacobian
   J(1,1)=2.0d0*ahat(3)+6.0d0*ahat(7)*pv(1)+2.0d0*ahat(9)*r(1)
   J(1,2)=ahat(6)+2.0d0*ahat(9)*pv(1)+2.0d0*ahat(10)*r(1)
   J(2,1)=ahat(6)+2.0d0*ahat(9)*pv(1)+2.0d0*ahat(10)*r(1)
   J(2,2)=2.0d0*ahat(5)+6.0d0*ahat(8)*r(1)+2.0d0*ahat(10)*pv(1)

  !Compute determinant of Jacobian
   detJ=J(1,1)*J(2,2)-J(1,2)*J(2,1)

  !Compute value of system at current guess
   sys(1)=ahat(2)+2.0d0*ahat(3)*pv(1)+ahat(6)*r(1)+3.0d0*ahat(7)*(pv(1)**2.0d0)+2.0d0*ahat(9)*pv(1)*r(1)+ahat(10)*(r(1)**2.0d0)
   sys(2)=ahat(4)+2.0d0*ahat(5)*r(1)+ahat(6)*pv(1)+3.0d0*ahat(8)*(r(1)**2.0d0)+ahat(9)*(pv(1)**2.0d0)+ahat(10)*pv(1)*2.0d0*r(1)
 
  !Compute sk, used to update guess
   sk(1)=-(J(2,2)*sys(1)-J(1,2)*sys(2))/detJ
   sk(2)=-(-J(2,1)*sys(1)+J(1,1)*sys(2))/detJ

  !update guess
   pk(1)=pv(1)+sk(1)
   rk(1)=r(1)+sk(2)

  !New guess
   pv(1)=pk(1)
   r(1)=rk(1)


  if(count==2000) then !get out of loop
    exiting=1
    exiting1=1
  end if
 

end do


if(abs(sys(1)).le.delta.AND.abs(sys(2)).le.delta) then   
    conv=1

 if(pv(1)>p_cap) then
   feasible=0
  else
    feasible=1
 end if
    !write(*,*) ""
    !write(*,*) "CASE 1: pv not binding"
    !write(*,*) "CONVERGENCE! In Newton steps", count
    !write(*,*)" p, r=", p(1), r(1)
    max_prof(1)=ahat(1)+ahat(2)*pv(1)+ahat(3)*(pv(1)**2.0d0)+ahat(4)*r(1)+ahat(5)*(r(1)**2.0d0)+ahat(6)*pv(1)*r(1)+&
                & ahat(7)*(pv(1)**3.0d0)+ahat(8)*(r(1)**3.0d0)+ahat(9)*(pv(1)**2.0d0)*r(1)+ahat(10)*pv(1)*(r(1)**2.0d0)
    !write(*,*) "Maximized approximated profits", max_prof(1)
    
else if(  (abs(sys(1)).gt.delta.OR.abs(sys(2)).gt.delta)  .AND.exiting.ne.1) then
    !write(*,*) ""
    ! write(*,*) "CASE 1: pv not binding"
     conv=0
     !write(*,*) "failed to converge "
    ! write(*,*) "Value of profits", ahat_prof(1)+ahat_prof(2)*pv(1)+ahat_prof(3)*(pv(1)**2.0d0)+ahat_prof(4)*r(1)+ahat_prof(5)*(r(1)**2.0d0)+ahat_prof(6)*pv(1)*r(1)+&
    ! & ahat_prof(7)*(pv(1)**3.0d0)+ahat_prof(8)*(r(1)**3.0d0)+ahat_prof(9)*(pv(1)**2.0d0)*r(1)+ahat_prof(10)*pv(1)*(r(1)**2.0d0)
    ! write(*,*) "in newton steps", count
    ! write(*,*) "value of system", sys
    ! read(*,*) stopping

 
 else  if (exiting.eq.1.AND.  (abs(sys(1)).gt.delta.OR.abs(sys(2)).gt.delta)) then  !i.e. we wre in an infinite loop, and we did not converge i.e. we are not close to the solution
    !write(*,*) ""
    conv=-99
    !write(*,*) "CASE 1: pv not binding"
    !write(*,*) "EXITED bc in infinite loop"
     !read(*,*) stopping
end if


 
!*************************************************
!*************************************************
!CASE 2: p binding      --> p=p_cap
!        solve for r and lambda
!   
!*************************************************
!*************************************************

!Use Newton method


pv(2)=p_cap


!Initial conditions for r(2) and lambda1(2)
  r(2)=(exp((cos(((2.0d0*dble(1)-1.0d0)/(2.0d0*dble(rnodes)))*3.14159265))*((u_lnr-l_lnr)/2.0d0)+0.5d0*(u_lnr+l_lnr) )&
     & + exp((cos(((2.0d0*dble(rnodes)-1.0d0)/(2.0d0*dble(rnodes)))*3.14159265))*((u_lnr-l_lnr)/2.0d0)+0.5d0*(u_lnr+l_lnr) ))/2.0d0

  lambda(2)=50.0d0

  rk(2)=r(2)+epsilon*(1.0d0+r(2))+10.0d0
  lambdak(2)=lambda(2)+epsilon*(1.0d0+lambda(2))+10.0d0
  sk(1)=epsilon*(1.0d0+r(2))+10.0d0
  sk(2)=epsilon*(1.0d0+lambda(2))+10.0d0


  if(abs(sk(1))<=epsilon*(1.0d0+abs(r(2))).OR.abs(sk(2))<=epsilon*(1.0d0+abs(lambda(2)))) then
   write(*,*) "problem in initialization, case3"
  end if

  count=0
  exiting2=0
  do while(  (    abs(sk(1))>epsilon*(1.0d0+abs(rk(2))).OR.abs(sk(2))>epsilon*(1.0d0+abs(lambdak(2)))   )  .AND.exiting2.eq.0)
  count=count+1

  !Compute Jacobian
   J(1,1)=ahat(6)+2.0d0*ahat(9)*p_cap+2.0d0*ahat(10)*r(2)
   J(1,2)=-1.0d0
   J(2,1)=2.0d0*ahat(5)+6.0d0*ahat(8)*r(2)+2.0d0*ahat(10)*p_cap
   J(2,2)=0.0d0

  !Compute determinant of Jacobian
   detJ=J(1,1)*J(2,2)-J(1,2)*J(2,1)

  !Compute value of system at current guess
   sys(1)=ahat(2)+2.0d0*ahat(3)*p_cap+ahat(6)*r(2)+3.0d0*ahat(7)*(p_cap**2.0d0)+2.0d0*ahat(9)*r(2)*p_cap+ahat(10)*(r(2)**2.0d0)-lambda(2)
   sys(2)=ahat(4)+2.0d0*ahat(5)*r(2)+ahat(6)*p_cap+3.0d0*ahat(8)*(r(2)**2.0d0)+ahat(9)*(p_cap**2.0d0)+2.0d0*ahat(10)*p_cap*r(2)

  !Compute sk, used to update guess
   sk(1)=-(J(2,2)*sys(1)-J(1,2)*sys(2))/detJ
   sk(2)=-(-J(2,1)*sys(1)+J(1,1)*sys(2))/detJ

  !update guess
   rk(2)=r(2)+sk(1)
   lambdak(2)=lambda(2)+sk(2)

  !New guess
   r(2)=rk(2)
   lambda(2)=lambdak(2)

  if(count==2000) then !get out of loop
     exiting2=1
   end if

end do !do while




if(abs(sys(1)).le.delta.AND.abs(sys(2)).le.delta) then   
   conv2=1
  ! write(*,*) ""
  ! write(*,*) "CASE 2: pv binding"
  ! write(*,*) "CONVERGENCE! In Newton steps", count
  ! write(*,*)" r, lambda1=", r(2), lambda1(2)
   max_prof(2)=ahat(1)+ahat(2)*p_cap+ahat(3)*(p_cap**2.0d0)+ahat(4)*r(2)+ahat(5)*(r(2)**2.0d0)+ahat(6)*p_cap*r(2)+&
             & ahat(7)*(p_cap**3.0d0)+ahat(8)*(r(2)**3.0d0)+ahat(9)*(p_cap**2.0d0)*r(2)+ahat(10)*p_cap*(r(2)**2.0d0)
  ! write(*,*) "Maximized approximated profits", max_prof(2)

  ! max_prof(3)=ahat_prof(1)+ahat_prof(2)*(p_cap+0.0010d0)+ahat_prof(3)*((p_cap+0.0010d0)**2.0d0)+ahat_prof(4)*r(3)+ahat_prof(5)*(r(3)**2.0d0)+ahat_prof(6)*(p_cap+0.0010d0)*r(3)+&
  ! & ahat_prof(7)*((p_cap+0.0010d0)**3.0d0)+ahat_prof(8)*(r(3)**3.0d0)+ahat_prof(9)*((p_cap+0.0010d0)**2.0d0)*r(3)+ahat_prof(10)*(p_cap+0.0010d0)*(r(3)**2.0d0)
  ! write(*,*) "Profits at p_cap + epsilon", max_prof(3)
  ! max_prof(3)=ahat_prof(1)+ahat_prof(2)*(p_cap-0.0010d0)+ahat_prof(3)*((p_cap-0.0010d0)**2.0d0)+ahat_prof(4)*r(3)+ahat_prof(5)*(r(3)**2.0d0)+ahat_prof(6)*(p_cap-0.0010d0)*r(3)+&
  ! & ahat_prof(7)*((p_cap-0.0010d0)**3.0d0)+ahat_prof(8)*(r(3)**3.0d0)+ahat_prof(9)*((p_cap-0.0010d0)**2.0d0)*r(3)+ahat_prof(10)*(p_cap-0.0010d0)*(r(3)**2.0d0)
  ! write(*,*) "Profits at p_cap - epsilon", max_prof(3)
end if
 if ((abs(sys(1)).gt.delta.OR.abs(sys(2)).gt.delta).AND.exiting2.ne.1) then
   conv2=0
  ! write(*,*) ""
  ! write(*,*) "CASE 2: pv binding"
  ! write(*,*) "failed to converge"

   ! write(*,*) "Value of profits", ahat_prof(1)+ahat_prof(2)*pv(3)+ahat_prof(3)*(pv(3)**2.0d0)+ahat_prof(4)*r(3)+ahat_prof(5)*(r(3)**2.0d0)+ahat_prof(6)*pv(3)*r(3)+&
   ! & ahat_prof(7)*(pv(3)**3.0d0)+ahat_prof(8)*(r(3)**3.0d0)+ahat_prof(9)*(pv(3)**2.0d0)*r(3)+ahat_prof(10)*pv(3)*(r(3)**2.0d0)
   ! write(*,*) "in newton steps", count
   ! write(*,*) "value of system", sys
   ! write(*,*) "Value of bump used to update guess", sk
   !write(*,*) "detJ", detJ
   !write(*,*) "Jacobian row 1", J(1,1:2)
   !write(*,*) "Jacobian row 2", J(2,1:2)
   !read(*,*) stopping
 
  end if
  if (exiting2.eq.1 .AND. (abs(sys(1)).gt.delta.OR.abs(sys(2)).gt.delta)) then
   conv2=-99
  ! write(*,*) ""
  ! write(*,*) "CASE 2: pv binding"
  ! write(*,*)"EXITED bc in infinite loop"

  
 
 end if
 
 



case1=0
success=0

!! OVERALL MAXIMUM !!!

!If I never converge: PROBLEM! set p and r to -999

	if(conv.eq.-99.AND.conv2.eq.-99) then   !I never converge --> set optimal prices to missing
	    p_o=-999.0d0
	    r_o=-999.0d0
         !  write(*,*) "Infinite loop"
	  
      end if 

	if (conv.eq.1.AND.conv2.ne.1) then  !onlt non-binding converges, solution is the not-binding case if feasible, otherwise no solution

 		if(feasible.eq.1) then
   	          p_o=pv(1)
   		   r_o=r(1)
   		   success=1
	          case1=1
              !   write(*,*) "Success: not binding solution:", p_o, r_o
 		else 
 		   p_o=-999.0d0
  		   r_o=-999.0d0
               !  write(*,*) "Failure: non-binding sol converges but infeasible"
 		end if
     end if

	 if(conv.ne.1.AND.conv2.eq.1) then !Only binding case converges, solution is the binding case

  		p_o=pv(2)
  		r_o=r(2)
		success=1
             case1=2
            !  write(*,*) "Success: binding solution:", p_o, log(r_o)
       end if
	 if (conv.eq.1.AND.conv2.eq.1) then  !Both converge: pick the maximum among the solutions that satisfy the constraint

			if(feasible.eq.1) then
 			    if(max_prof(1).ge.max_prof(2) ) then
   				 p_o=pv(1)
   				 r_o=r(1)
				 success=1
			        case1=1
                           !  write(*,*) "Success: not binding solution:", p_o, r_o
  			    else if (max_prof(1).lt.max_prof(2) ) then
  				 p_o=pv(2)
    				 r_o=r(2)
				 success=1
                            case1=2
                            ! write(*,*) "Success: binding solution:", p_o, log(r_o)
  			    end if

                     else  !the non-binding solution is not fasilbe, so the optimal is the binding

 				p_o=pv(2)
 				r_o=r(2)
			       success=1
                            case1=2
                           ! write(*,*) "Success: binding solution:", p_o, log(r_o)
			end if
          
         !write(*,*) "both converge, p_o, r_o", p_o, r_o


	end if

    if(conv.eq.0.AND.conv2.eq.0) then  !no convergence

      p_o=-994.0d0
      r_o=-994.0d0
   end if

    !Now set to -99 if what I found was in fact a minimum
   
 
 if(success.eq.1) then
  
 !Compute Hessian at maximum to check if Hessian matrix is negative semidefinite atr critical point, and hence if SOC for a maximum is satisfied
 !If waht I found is a minimum, assign a -99
  
  
 if(case1.eq.1) then !only in unconstrained case is the hessian required to be negative semi-definiete, if I'm at the boundary for pv, hessian can not be negative semidefinite
 
   H(1,1)=2.0d0*ahat(3)+6.0d0*ahat(7)*p_o+2.0d0*ahat(9)*r_o
   H(1,2)=ahat(6)+2.0d0*ahat(9)*p_o+2.0d0*ahat(10)*r_o
   H(2,1)=H(1,2)
   H(2,2)=2.0d0*ahat(5)+6.0d0*ahat(8)*r_o+2.0d0*ahat(10)*p_o
 
   detH=H(1,1)*H(2,2)-H(1,2)*H(2,1)
   !For H to be negative semidefinite, need leadng principal minors to alternate in sign.
   !i.e. H(1,1)<0 & detH>0
   if(H(1,1).ne.0.0d0.AND.detH.ge.0.0d0) then  !there is something wrong here... what i find seems to be a maximum even when this IF statement says it's not negative semi-denfinite!!!
     !write(*,*) ""
     !write(*,*) "SOC SATISFIED, it is a maximum"
     !    chekc manually that a little to the left and to the right the value is lower
 
     ! write(*,*) "Maximized profits", max_prof(1)
   else
     !notice that if we are a t a a corner solution, the SOC needs not be satisfied meaing that the functon could be increasing there
     !check manaully that a little to the left and to the right it is higher
     p_o=-99.0d0
     r_o=-99.0d0
   !  write(*,*) "Found a minimum in unconstrained case"
   !  write(*,*) "Profits at p and r", ahat(1)+ahat(2)*p_o+ahat(3)*(p_o**2.0d0)+ahat(4)*r_o+ahat(5)*(r_o**2.0d0)+ahat(6)*p_o*r_o+&
   !                                & ahat(7)*(p_o**3.0d0)+ahat(8)*(r_o**3.0d0)+ahat(9)*(p_o**2.0d0)*r_o+ahat(10)*p_o*(r_o**2.0d0)
 
    ! write(*,*) "Profits at p-delta", ahat(1)+ahat(2)*(p_o-0.0001d0)+ahat(3)*((p_o-0.0001d0*p_o)**2.0d0)+ahat(4)*r_o+ahat(5)*(r_o**2.0d0)+ahat(6)*(p_o-0.0001d0*p_o)*r_o+&
    !                               & ahat(7)*((p_o-0.0001d0*p_o)**3.0d0)+ahat(8)*(r_o**3.0d0)+ahat(9)*((p_o-0.0001d0*p_o)**2.0d0)*r_o+ahat(10)*(p_o-0.0001d0*p_o)*(r_o**2.0d0)
 
     !write(*,*) "Profits at p+delta", ahat(1)+ahat(2)*(p_o+0.0001d0*p_o)+ahat(3)*((p_o+0.0001d0*p_o)**2.0d0)+ahat(4)*r_o+ahat(5)*(r_o**2.0d0)+ahat(6)*(p_o+0.0001d0*p_o)*r_o+&
     !                            & ahat(7)*((p_o+0.0001d0*p_o)**3.0d0)+ahat(8)*(r_o**3.0d0)+ahat(9)*((p_o+0.0001d0*p_o)**2.0d0)*r_o+ahat(10)*(p_o-0.0001d0*p_o)*(r_o**2.0d0)
  
      !write(*,*) "Profits at r+delta", ahat(1)+ahat(2)*p_o+ahat(3)*(p_o**2.0d0)+ahat(4)*(r_o+0.00010d0*r_o)+ahat(5)*((r_o+0.00010d0*r_o)**2.0d0)+ahat(6)*p_o*(r_o+0.00010d0*r_o)+&
      !                    & ahat(7)*(p_o**3.0d0)+ahat(8)*((r_o+0.00010d0*r_o)**3.0d0)+ahat(9)*(p_o**2.0d0)*(r_o+0.00010d0*r_o)+ahat(10)*p_o*((r_o+0.00010d0*r_o)**2.0d0)
 
     !write(*,*) "Profits at r-delta", ahat(1)+ahat(2)*p_o+ahat(3)*(p_o**2.0d0)+ahat(4)*(r_o-0.00010d0*r_o)+ahat(5)*((r_o-0.00010d0*r_o)**2.0d0)+ahat(6)*p_o*(r_o-0.010d0*r_o)+&
     !                  & ahat(7)*(p_o**3.0d0)+ahat(8)*((r_o-0.00010d0*r_o)**3.0d0)+ahat(9)*(p_o**2.0d0)*(r_o-0.00010d0*r_o)+ahat(10)*p_o*((r_o-0.00010d0*r_o)**2.0d0)
     !read(*,*) stopping
     !write(*,*) ""
     !write(*,*) "SOC not satisfied, it is not a maximum"

     ! read(*,*) stopping
 
 
   end if !whether SOC is satisfied
 
 end if !whether it's case 1


  if(case1.eq.2) then !check whether we are in fact minimizing or mazimixing by looking at objective fcn in a neighborhood of maximum
  !  write(*,*) "Profits at p and r", ahat_prof(1)+ahat_prof(2)*pv_o+ahat_prof(3)*(pv_o**2.0d0)+ahat_prof(4)*r_o+ahat_prof(5)*(r_o**2.0d0)+ahat_prof(6)*pv_o*r_o+&
  !                                 & ahat_prof(7)*(pv_o**3.0d0)+ahat_prof(8)*(r_o**3.0d0)+ahat_prof(9)*(pv_o**2.0d0)*r_o+ahat_prof(10)*pv_o*(r_o**2.0d0)
! 
!     write(*,*) "Profits at p-delta", ahat_prof(1)+ahat_prof(2)*(pv_o-0.01d0)+ahat_prof(3)*((pv_o-0.01d0*pv_o)**2.0d0)+ahat_prof(4)*r_o+ahat_prof(5)*(r_o**2.0d0)+ahat_prof(6)*(pv_o-0.01d0*pv_o)*r_o+&
!                                   & ahat_prof(7)*((pv_o-0.01d0*pv_o)**3.0d0)+ahat_prof(8)*(r_o**3.0d0)+ahat_prof(9)*((pv_o-0.01d0*pv_o)**2.0d0)*r_o+ahat_prof(10)*(pv_o-0.01d0*pv_o)*(r_o**2.0d0)
! 
!     write(*,*) "Profits at p+delta", ahat_prof(1)+ahat_prof(2)*(pv_o+0.01d0*pv_o)+ahat_prof(3)*((pv_o+0.01d0*pv_o)**2.0d0)+ahat_prof(4)*r_o+ahat_prof(5)*(r_o**2.0d0)+ahat_prof(6)*(pv_o+0.01d0*pv_o)*r_o+&
!                                 & ahat_prof(7)*((pv_o+0.01d0*pv_o)**3.0d0)+ahat_prof(8)*(r_o**3.0d0)+ahat_prof(9)*((pv_o+0.01d0*pv_o)**2.0d0)*r_o+ahat_prof(10)*(pv_o-0.01d0*pv_o)*(r_o**2.0d0)

     if( ahat(1)+ahat(2)*(p_o-0.0001d0*p_o)+ahat(3)*((p_o-0.0001d0*p_o)**2.0d0)+ahat(4)*r_o+ahat(5)*(r_o**2.0d0)+ahat(6)*(p_o-0.0001d0*p_o)*r_o+&
         & ahat(7)*((p_o-0.0001d0*p_o)**3.0d0)+ahat(8)*(r_o**3.0d0)+ahat(9)*((p_o-0.0001d0*p_o)**2.0d0)*r_o+ahat(10)*(p_o-0.0001d0*p_o)*(r_o**2.0d0)-&
         &(    ahat(1)+ahat(2)*p_o+ahat(3)*(p_o**2.0d0)+ahat(4)*r_o+ahat(5)*(r_o**2.0d0)+ahat(6)*p_o*r_o+&
         & ahat(7)*(p_o**3.0d0)+ahat(8)*(r_o**3.0d0)+ahat(9)*(p_o**2.0d0)*r_o+ahat(10)*p_o*(r_o**2.0d0)    ) <&
          0.000010d0*  (ahat(1)+ahat(2)*(p_o-0.0001d0*p_o)+ahat(3)*((p_o-0.0001d0*p_o)**2.0d0)+ahat(4)*r_o+ahat(5)*(r_o**2.0d0)+ahat(6)*(p_o-0.0001d0*p_o)*r_o+&
         & ahat(7)*((p_o-0.0001d0*p_o)**3.0d0)+ahat(8)*(r_o**3.0d0)+ahat(9)*((p_o-0.0001d0*p_o)**2.0d0)*r_o+ahat(10)*(p_o-0.0001d0*p_o)*(r_o**2.0d0))  ) then

     !if profit_p-profit_(p-epsilon)<0.00001*profit_p instead of if prfit)p-profit(p-epsilon)<0

     ! write(*,*) "pv is at boundary and it is maximal"
     ! write(*,*) "Maximized profits", max_prof(2)
   else
  !   write(*,*) "pv is at boundary and it is not maximal" 
  !   write(*,*) "profits at p-epsilon",ahat(1)+ahat(2)*(p_o-0.0001d0*p_o)+ahat(3)*((p_o-0.0001d0*p_o)**2.0d0)+ahat(4)*r_o+ahat(5)*(r_o**2.0d0)+ahat(6)*(p_o-0.0001d0*p_o)*r_o+&
  !       & ahat(7)*((p_o-0.0001d0*p_o)**3.0d0)+ahat(8)*(r_o**3.0d0)+ahat(9)*((p_o-0.0001d0*p_o)**2.0d0)*r_o+ahat(10)*(p_o-0.0001d0*p_o)*(r_o**2.0d0)
  !   write(*,*) "profits at p", ahat(1)+ahat(2)*p_o+ahat(3)*(p_o**2.0d0)+ahat(4)*r_o+ahat(5)*(r_o**2.0d0)+ahat(6)*p_o*r_o+&
  !       & ahat(7)*(p_o**3.0d0)+ahat(8)*(r_o**3.0d0)+ahat(9)*(p_o**2.0d0)*r_o+ahat(10)*p_o*(r_o**2.0d0)
  !  read(*,*) stopping
     p_o=-99.0d0   
     r_o=-99.0d0
   end if

         
  
     

  end if !case1=0


end if !success=1



if(p_o<0.d0.OR.r_o<0.0d0) then

   maximized_aprofits=-99.0d0
 else

  maximized_aprofits= ahat(1)+ahat(2)*p_o+ahat(3)*(p_o**2.0d0)+ahat(4)*r_o+ahat(5)*(r_o**2.0d0)+ahat(6)*p_o*r_o+&
         & ahat(7)*(p_o**3.0d0)+ahat(8)*(r_o**3.0d0)+ahat(9)*(p_o**2.0d0)*r_o+ahat(10)*p_o*(r_o**2.0d0)
 end if !I will penalize in the likelihihood negative maximized profits



!if(p_o<00d0.OR.r_o<0.0d0) then

!write(*,*) "p_o or r_o negative, p_o, r_o", p_o, r_o
!write(*,*) "conv, conv2, feasible, case1", conv, conv2, feasible, case1

!end if







end subroutine constr_maxprof