MODULE VarDef
IMPLICIT NONE


    integer, parameter   :: p=304
    integer, parameter   :: NWType=3, NCType=3 !Number of types of workers and of kids
    
    real(8)              :: theta(p) , theta2(4) !vector of parameters

    real(8), parameter   :: cs_cap=100.0d0,p_cap=1.2+27391.903/100000.0d0    
                                                                     
    real(8), parameter   :: b=1.07d0 , voucher=27391.903/100000.0d0      !
    real(8), parameter   :: voucher_prim=24856.88/100000.0d0, voucher_med=29926.925
    real(8), parameter    :: oneUSE=0.195d0 !in terms of 100k pesos     
    integer, parameter   :: D=1, Deld=100 !D determines the goodness of the approximation of profits, the higher the better the profits. It does not imply anything
                                           !on the sizes of the datasets to dowlonad 
    integer, parameter   :: Dpr=600 !number of shocks to the per-pupil cost, used to generate distribution of optimal prices p and r 

    !Number of observations in profit interpolating regression
    integer, parameter   :: rnodes=40
    integer, parameter   :: pvnodes=40  
    integer, parameter   :: iter_num=1600  !iter_num=rnodes*pvnodes
   
   !Sample sizes
   !these are needed so that I can call just the size of the dat without having to call the data
    integer, parameter    :: n_mktvd=18 !number of markets used, common to all datasets
    integer, parameter    :: n_cpvd=21589, n_cwvd=3520 !number of primary and secondary students in casen_parents
     integer, parameter   :: n_cp2vd=5000      
   integer, parameter     :: n_wvd=5471, n_svd=100000  
    
     real(8)              :: StartTime, EndTime, MidTime, BeginningTime
 real(8)       :: epsilon_wglobal(4,n_wvd,D), epsilon_pglobal(3,n_svd,D), type_ipglobal(n_svd,D), type_iwglobal(n_wvd,D)
     
real(8), parameter        :: rM_reform= 1.4397666506634855270386  !!actual counterfactual r^M set by government (which induces a projected increase of 30% of wages)
real(8), parameter        :: cutoff=  1.743474         ! value of    1.743474     corresponds to 41th percentile of skill distribution in M schools, which corresponds also to where the new cutoff in terms of PAA stands.
                                                        !the 70th percentile of the PSU distribution is 558.3 (based on fact that mean(st dev) of PSU is 500(110).
														!From Bravo paper, M teacehrs have mean(st dev) of PAA equal to 573.64 (68.96). PSU and PAA are standardised nationally to have the same mean and st dev (even thought they are different tests).
														!From this data, I conclude that the PSU cutoff of 558.3 corresponds to the current 41th percentile in the PAA distribution of M teachers. I then look at what stskill that cutoff corresponds
														! to, that is, what is the 41th percentile in the pop of M teachers in terms of stskills? It is  1.743474
                                                     
                                                    !percentiles of the stskills distribution: 50th 1.9045540094 
													!                                          60th 2.2890496254
													!                                          70th 2.8424665928
													!                                          90th 4.647315502166748   
                                                  													
    
    
    
    
    
    


END MODULE VarDef