subroutine find_optimal(Drep, pv_omat, r_omat, maxaprof_mat)

USE VarDef



IMPLICIT NONE



integer, intent(in)         :: Drep
real(8), intent(in)         :: pv_omat(n_mktvd, Drep)

real(8), intent(out)        ::  r_omat(n_mktvd,Drep), maxaprof_mat(n_mktvd,Drep)

real(8)                     :: low_r, up_r, neg_prof, tol , minimum


integer                     :: idum, sim_cost, mkt
real(8)                     :: shock_cost_stand(Drep), shock_cost(Drep), shock_cost_iter

real(8)                     :: ln_r, pv

real(8)                     :: awV, awM, SV, TSV, zeroSV, zeroSM, DV, EPV
real(8)                     :: unit_revenue, unit_fellow

real(8)    :: rate_M, optimal_v(18)






r_omat=-99.0d0
tol=0.0000000010d0



maxaprof_mat=-99.0d0

!######## Draw cost shocks ############

idum=773
call gasdev(idum, shock_cost_stand,Drep)



 do sim_cost=1,Drep
        shock_cost(sim_cost)=exp( exp(theta2(1))*shock_cost_stand(sim_cost)  )/100.0d0  !the cost is lognormal, so I have to take the exp of the normal draw 
                                                                                      !I dividfe by two ootherwise the cost shock is too high. This is like a change in units. innocuous
        shock_cost_iter=shock_cost(sim_cost)




  !Given the current value of rM, and the current value of the cost shock , mazimize profits (i.e. in each market separately!)
  do mkt=1,n_mktvd
     pv=pv_omat(mkt,sim_cost)


     if(pv<0.0d0) then
       write(*,*) "ERROR! Using a negative price!"
     end if
   ! write(*,*) "calling minization routine"

  
      low_r=0.30d0
      up_r=2.0d0  !1.80d0
     call  fmin(low_r,up_r,tol,mkt, shock_cost_iter, pv, minimum)
   !  write(*,*) "opimtal r according to fmin", minimum
     r_omat(mkt,sim_cost)=minimum
  
  end do !mkt


  end do !sim_cost





!Now compute value of profits at optimal r_omat



 do mkt=1,n_mktvd
  do sim_cost=1,Drep
     ln_r=log(r_omat(mkt,sim_cost))
     pv=pv_omat(mkt,sim_cost)
      call simulate_workers_mkt(mkt, ln_r,awV, awM, SV, TSV, zeroSM, zeroSV )
      call simulate_parents_mkt(mkt, pv, zeroSM, zeroSV, awM,awV, DV, EPV )



       if(DV.ne.0.0d0.AND.SV.ne.0.0d0) then
           !write profit function using actual governmental formulas
           if(0.50d0*oneUSE<EPV.le.oneUSE) then
              unit_revenue=pv-0.10d0*(EPV-0.50d0*oneUSE)
           else if (oneUSE<EPV.le.2.0d0*oneUSE) then
              unit_revenue=pv-0.10d0*0.50d0*oneUSE-0.20d0*(EPV-oneUSE)
           else if (2.0d0*oneUSE<EPV)  then
              unit_revenue=pv-0.10d0*0.50d0*oneUSE-0.20d0*oneUSE-0.350d0*(EPV-2.0d0*oneUSE)
           end if 
        
           if(EPV.le.oneUSE) then
             unit_fellow=0.050d0*EPV
           else if (oneUSE<EPV.le.2.0d0*oneUSE) then
             unit_fellow=0.050d0*oneUSE+0.070d0*(EPV-oneUSE)
           else if(2.0d0*oneUSE<EPV) then
             unit_fellow=0.050d0*oneUSE+0.070d0*oneUSE+0.10d0*(EPV-2.0d0*oneUSE)
           end if

        maxaprof_mat(mkt,sim_cost)=(unit_revenue-unit_fellow)*DV-(theta2(2)+shock_cost(sim_cost))*DV-theta2(3)*DV**2.0d0&
                                   &-(exp(ln_r)*TSV)-theta2(4)*((DV/SV)/45.0d0)


     else 
         maxaprof_mat(mkt,sim_cost)=-99.0d0
    end if  



 end do
end do




end subroutine find_optimal