


PROGRAM Main_Step2

USE VarDef
USE Datasets


IMPLICIT NONE



integer                   :: APPROX_PROF     !This is an indicator for whether to approximate profits and max the approximated profits or to maximize numerically true profits
integer                   :: do_case_05      !
integer , parameter       :: Drep=10         !Maximum number shock draws used: keep the first one for which profit>0
integer, parameter        :: Drep_workpar=1  !number of replicas of workers and parents: just one
integer, parameter        :: iter_rM= 1      !number of counterfactual rM's that I simulate. When this is set to 1, I only run the counterfactual with rM=rM_reform
integer                   :: Drep_used 
real(8)                   :: gamma_step1(212), rates(n_mkt)
integer                   :: i, npar, idum, sim, noeval, sim_cost, mkt
real(8)                   :: ln_r1(n_mkt)     !these are the rental rates estimated in step 1 of the estimation
character(150)            :: outputname
real(8)                   ::  sum_nosolution(18), number_solutions_found
real(8)                   :: diagnostics0(0:iter_rM,1), diagnostics1(0:iter_rM,1)

!shocks and types of workers and parents
real(8)                   :: epsilon_pvec(3*n_s*D), epsilon_p(3,n_s,D), epsilon_wvec(4*n_w*D), epsilon_w(4,n_w,D)   !for the interpolation, I keep drawing large numnbers of workers and parents
real(8)                   :: Psi_w(3), Psi_p(3), unif_w(n_w*D), unif_p(n_s*D)
integer                   :: type_ip(n_s,D), type_iw(n_w,D)

!Interpolating profits: obtain one interpolation per market and per shock draw
real(8)                   :: Reg(iter_num,10), XpX(10,10), XpX_inv(10,10), ahatmat(10,n_mktvd,Dpr),Rsqmat(n_mktvd,Dpr)

!Choosing the lower and upper extremes for the interpolation of ln_r and pv
real(8)                   :: l_lnr, u_lnr, l_p, u_p

!Solutions: one per market and per cost draw  !draw only few shocks, keep only the fist one with positive profits!
real(8)                   :: pv_omat(n_mktvd, Drep), r_omat(n_mkt,Drep), positive_maxaprof(n_mktvd,Drep), maxprof_mat(n_mktvd,Drep)

real(8)                   :: TotwagesM(n_mktvd), SupV(n_mktvd), TSV(n_mktvd), DV(n_mktvd), SM(n_mktvd), EPV(n_mktvd), DM(n_mktvd)
real(8)                   :: gvmtM(n_mktvd), gvmt_Vvoucher(n_mktvd), unit_revenue(n_mktvd), voucher_V(n_mktvd), Tot_fellowships(n_mktvd), unit_fellow(n_mktvd), school_fellow_contrib(n_mktvd), &
                             & gvmtV(n_mktvd), gvmt_Vfellow(n_mktvd), gvmt(n_mktvd)
real(8)                   :: voucherM_mkt(18), extraM_mkt(18)
integer                   :: done(n_mktvd) , found_solution(n_mktvd) !used to select the non-negative optima prices and tuitions and opt profits


!******* counterfactual ********
real(8)                   :: rM       ! this is the price of skills that the government chooses, assume one unique per mkt
integer                   :: rM_int   ! used for do loop
real(8)                   :: gov_baseline, gov_tot(n_mktvd), gov_m(n_mktvd), gov_v(n_mktvd)
real(8)                   :: opt_prof_baseline(n_mktvd)  ! optimal profits of V schools in the baseline scenario

real(8)                   :: entry(n_mktvd)
integer                   :: case
real(8)                   :: results0(0:iter_rM,17),results1(0:iter_rM,17) ! contains rM, mean test score, mean test scoreM, mean test scoreV,  gov exp, gov exp in wages, gov_exp_fellow, 
                                                                           ! mean_skills_t, mean_skills_m, mean_skills_v,  share of enrollm in V for each iteration of rM. 
                                                                           ! one matrix for each case, case0 and case1

real(8)                   :: no_solution(n_mktvd,Drep) !indicator=1 if in at least one market for that iteration we were not able to find a sol to the opt problem
integer                   :: stophere, teststop
real(8)                   :: govM_voucher, govM_extra, govV_voucher, govV_fellow
real(8)                   :: r_entry(0:iter_rM,9)
real(8)                   :: outcomes0(0:iter_rM,10),outcomes1(0:iter_rM,10),outcomes05(0:iter_rM,10)  !70 : 80,10
real(8)                   :: expenditures0(0:iter_rM,8), expenditures1(0:iter_rM,8), expenditures05(0:iter_rM,8)
real(8)                   :: number_M_schools, number_V_schools
!********************************

!variables that I print out to the screen
!expenditures
real(8)                   :: overall_gov, overall_govM, overall_govV, overall_wageM, overall_voucherM, overall_extraM, overall_voucherV, overall_fellowV, overall_DM, overall_DV
real(8)                   :: overall_wageM0, overall_shareV0, overall_gvmt0, overall_gvmtfellow0  !case 0: stay in mkt if profits ar epositive
real(8)                   :: overall_wageM1, overall_shareV1, overall_gvmt1, overall_gvmtfellow1  ! case1 : stay in mkt if profits are at elast as big as old ones
real(8)                   :: EnrollV, Enroll !Used to compute shares


! used in simulation, needed to simulate parents
real(8)                   :: awM_sim(n_mkt), awV_sim(n_mkt), zeroSM_sim(n_mkt), zeroSV_sim(n_mkt)
real(8)                   :: pv_oavg(n_mktvd), lr_oavg(n_mktvd), Shocks_used(n_mktvd)
integer                   :: use_sim(Drep)
real(8)                   :: r_used(n_mktvd), pv_used(n_mktvd), maxaprof_used(n_mktvd)

integer                   :: stopping




!Initializations
!lower and upper bounds for ln_r and p in the interpolating regression
l_lnr=-4.3900d0; 
u_lnr=0.6 
l_p=0.10d0; u_p=3.80d0         

!output
outcomes0=-99.0d0
outcomes1=-99.0d0
outcomes05=-99.0d0
expenditures0=-99.0d0
expenditures1=-99.0d0
expenditures05=-99.0d0
results0=-99.0d0
results1=-99.0d0



open(unit=4658,file='./Vschoolstats_RefEqm2.txt', access='append')
write(4658,*) "case, rM iteration, mkt, pv, rv, maxaprofits"

close(4658)


!###################################################################
!##### Read in input parameters and assign thetas using gamma ######
!###################################################################

!Read in the 4 parameters from step2, then read in the prameters fro mthje previous step

open (unit=7786,file='./solution_aug23')   !file=inputname,access='sequential')
   do i=1,4
      read(7786,*) theta2(i)
  end do
close(7786)


gamma_step1=0.0d0
open(unit=1732,file='./gamma_step1_212_aug22')
do i=1,212
   read(1732,*) gamma_step1(i)
end do
close(1732)


theta=0.0d0

!Assign thetas of workers (the rental rates won't be used)
do i=1,3
  theta(i)=gamma_step1(i)
end do
do i=5,93
 theta(i)=gamma_step1(i-1)
end do
do i=106,109
 theta(i)=gamma_step1(i-13)
end do
 theta(194)=gamma_step1(97)
do i=177, 193
 theta(i)=gamma_step1(i-79)
end do
do i=287,304
 theta(i)=gamma_step1(i-172)
end do

!Now set the thetas to zero so that I don't use the wrong ones 
do i=177,193
 theta(i)=0.0d0 !Letting the rental rates be zero, safety measure (a zero will give me an error message)
end do

!Assign thetas of parents
do i=110, 120
 theta(i)=gamma_step1(i+23)
end do
do i=123,128
 theta(i)=gamma_step1(i+21)
end do
do i=155,157
 theta(i)=gamma_step1(i-5)
end do
do i=162, 165
 theta(i)=gamma_step1(i-9)
end do
 theta(169)=gamma_step1(157)
 theta(171)=gamma_step1(158)
 theta(195)=gamma_step1(159)
do i=197,244
 theta(i)=gamma_step1(i-37)
end do
 theta(247)=gamma_step1(208)
do i=249,252
 theta(i)=gamma_step1(i-40)
end do




!#######################################################
!############## Read in datasets #######################
!######################################################

!SIMCE06_media and primaria together
open(unit=12,file='./SIMCE410_final.txt')
    do i=1,n_s
       read(12,*) id_s(i), mkt7_s(i),primaria_s(i),rural_s(i), nfam_s(i), peduc_s(i), fem_s(i), unempl_s(i), blue_s(i), mincome_s(i), &
       & m_s(i), v_s(i), mtuition_s(i), standability_s(i) 
    end do
close(12)  
!change wage into 100_mila. Mtuition has already been divided by 100mila in the do filke prepare_SIMCE_4_fortran.do (inside Visual Studio)
do i=1,n_s
  mincome_s(i)=mincome_s(i)/100000.0d0
  if(blue_s(i).eq.2) then
   blue_s(i)=0
  end if 
end do


do i=1,n_s
 if(mkt7_s(i).eq.6661) then
     mkt7_s(i)=1
    else if (mkt7_s(i).eq.6662) then
     mkt7_s(i)=2 
    else if (mkt7_s(i).eq.6663) then
     mkt7_s(i)=3 
    else if (mkt7_s(i).eq.6664) then
     mkt7_s(i)=4 
    else if (mkt7_s(i).eq.6665) then
     mkt7_s(i)=5 
    else if (mkt7_s(i).eq.6666) then
     mkt7_s(i)=6 
    else if (mkt7_s(i).eq.6667) then
     mkt7_s(i)=7 
    else if (mkt7_s(i).eq.6668) then
     mkt7_s(i)=8 
    else if (mkt7_s(i).eq.6669) then
     mkt7_s(i)=9 
    else if (mkt7_s(i).eq.66610) then
     mkt7_s(i)=10 
    else if (mkt7_s(i).eq.66612) then
     mkt7_s(i)=11 
    else if (mkt7_s(i).eq.66613) then
     mkt7_s(i)=12 
    else if (mkt7_s(i).eq.66614) then
     mkt7_s(i)=13 
    else if (mkt7_s(i).eq.66615) then
     mkt7_s(i)=14 
    else if (mkt7_s(i).eq.66616) then
     mkt7_s(i)=15 
    else if (mkt7_s(i).eq.66617) then
     mkt7_s(i)=16 
    else if (mkt7_s(i).eq.66618) then
     mkt7_s(i)=17 
    else if (mkt7_s(i).eq.66619) then
     mkt7_s(i)=18 
   end if
end do


!WORKERS UNIQUE
open(unit=13,file='./workers_unique.txt') 
    do i=1,n_w
       read(13,*) id_w(1,i), id_w(2,i), mkt7_w(i), graddeg_w(i), perfec_w(i), nkids_w(i), nkids2_w(i), nkids6_w(i), age_w(i), fem_w(i), &
       & peduc_w(i), m_w(i), v_w(i), nt_w(i), h_w(i),wage_w(i)
    end do
close(13)

!TOTweights_w=0.0d0      
do i=1,n_w
  ! TOTweights_w=TOTweights_w+id_w(2,i)
   wage_w(i)=wage_w(i)/100000.0d0
end do

do i=1,n_w
  age_w(i)=age_w(i)-19

   if(mkt7_w(i).eq.6661) then
     mkt7_w(i)=1
    else if (mkt7_w(i).eq.6662) then
     mkt7_w(i)=2 
    else if (mkt7_w(i).eq.6663) then
     mkt7_w(i)=3 
    else if (mkt7_w(i).eq.6664) then
     mkt7_w(i)=4 
    else if (mkt7_w(i).eq.6665) then
     mkt7_w(i)=5 
    else if (mkt7_w(i).eq.6666) then
     mkt7_w(i)=6 
    else if (mkt7_w(i).eq.6667) then
     mkt7_w(i)=7 
    else if (mkt7_w(i).eq.6668) then
     mkt7_w(i)=8 
    else if (mkt7_w(i).eq.6669) then
     mkt7_w(i)=9 
    else if (mkt7_w(i).eq.66610) then
     mkt7_w(i)=10 
    else if (mkt7_w(i).eq.66612) then
     mkt7_w(i)=11 
    else if (mkt7_w(i).eq.66613) then
     mkt7_w(i)=12 
    else if (mkt7_w(i).eq.66614) then
     mkt7_w(i)=13 
    else if (mkt7_w(i).eq.66615) then
     mkt7_w(i)=14 
    else if (mkt7_w(i).eq.66616) then
     mkt7_w(i)=15 
    else if (mkt7_w(i).eq.66617) then
     mkt7_w(i)=16 
    else if (mkt7_w(i).eq.66618) then
     mkt7_w(i)=17 
    else if (mkt7_w(i).eq.66619) then
     mkt7_w(i)=18 
   end if
end do




!MKT_CHAR
open(unit=16,file='./mkt_char5.csv')
    do i=1,n_mktvd
       read(16,*) mkt7(i),  size_mkt7(i), educ_mkt7(i),   sdeduc_mkt7(i), blue_mkt7(i),mincome_mkt7(i), sdminc_mkt7(i), fona_mkt7(i), fonb_mkt7(i), fonc_mkt7(i),&
                 & fond_mkt7(i),isapre_mkt7(i), chilesol_mkt7(i), rural_mkt7(i), unempl_mkt7(i), nowork_mkt7(i), nsub_mkt7(i), r_13(i), r_15(i), Norte(i),&
                 & Central(i), Sur(i), numM(i), numV(i), numU(i),Drural_mkt7(i), Dchilsol_mkt7(i),studM_mkt7(i),studV_mkt7(i),sharestudV_mkt7(i), teachM_mkt7(i),&
                 & imp_teachV_mkt7(1,i),imp_teachV_mkt7(2,i),imp_teachV_mkt7(3,i),imp_teachV_mkt7(4,i),imp_teachV_mkt7(5,i),imp_teachV_mkt7(6,i),imp_teachV_mkt7(7,i), &
                 & imp_teachV_mkt7(8,i),imp_teachV_mkt7(9,i),imp_teachV_mkt7(10,i),imp_shareteachV_mkt7(1,i),imp_shareteachV_mkt7(2,i),imp_shareteachV_mkt7(3,i),&
                 & imp_shareteachV_mkt7(4,i),imp_shareteachV_mkt7(5,i),imp_shareteachV_mkt7(6,i),imp_shareteachV_mkt7(7,i),imp_shareteachV_mkt7(8,i),&
                 & imp_shareteachV_mkt7(9,i),imp_shareteachV_mkt7(10,i), imp_studteachV(1,i),imp_studteachV(2,i),imp_studteachV(3,i),imp_studteachV(4,i),imp_studteachV(5,i),&
                 & imp_studteachV(6,i),imp_studteachV(7,i),imp_studteachV(8,i),imp_studteachV(9,i),imp_studteachV(10,i), studteachM(i), mean_maxpv(i)
    end do  
close(16)


!Market level categories
!pvd_cat, educd_cat, mincomed_cat
do i=1,n_mkt
 !pvd_cat
 if(mean_maxpv(i)<=40000.0d0.AND.mean_maxpv(i)>=0.0d0) then
   pvd_cat(i)=1
 else if  (mean_maxpv(i)<=48000.0d0.AND.mean_maxpv(i)>40000.0d0) then
   pvd_cat(i)=2
 else if (mean_maxpv(i)<=53500.0d0.AND.mean_maxpv(i)>48000.0d0 ) then
   pvd_cat(i)=3
 else if (mean_maxpv(i)>53500.0d0) then
   pvd_cat(i)=4
 else
   pvd_cat(i)=-99
 end if
 
 !educd_cat
 if(educ_mkt7(i)<=8.60d0.AND.educ_mkt7(i)>=0.0d0) then
  educd_cat(i)=1
 else if (educ_mkt7(i)> 8.60d0.AND.educ_mkt7(i)<=9.30d0) then
  educd_cat(i)=2
 else if (educ_mkt7(i)>9.30d0.AND.educ_mkt7(i)<=10.10d0) then
  educd_cat(i)=3
 else if (educ_mkt7(i)>10.10d0) then
  educd_cat(i)=4
 else
  educd_cat(i)=-99
 end if
 
 !mincomed_cat
 if(mincome_mkt7(i)<=190000.0d0.AND.mincome_mkt7(i)>=0.0d0) then
  mincomed_cat(i)=1
 else if(mincome_mkt7(i)>190000.0d0.AND.mincome_mkt7(i)<=211358.0d0) then
  mincomed_cat(i)=2
 else if (mincome_mkt7(i)>211358.0d0.AND.mincome_mkt7(i)<=250000.0d0) then
  mincomed_cat(i)=3
 else if (mincome_mkt7(i)>250000.0d0) then
  mincomed_cat(i)=4
 else
  mincomed_cat(i)=-99
 end if
 
 !Dblue dummy
 if(blue_mkt7(i).le.0.6490d0) then
  Dblue_mkt7(i)=0
 else
  Dblue_mkt7(i)=1
 end if 
end do

                 

do i=1,n_mkt
  mincome_mkt7(i)=mincome_mkt7(i)/100000.0d0
  mean_maxpv(i)=mean_maxpv(i)/100000.0d0
end do
do i=1,n_mkt
 if(rural_mkt7(i)>=.22) then
  Drural_mkt7(i)=1.0d0
 else
  Drural_mkt7(i)=0.0d0
 end if
 if(chilesol_mkt7(i)>=0.0128) then
  Dchilsol_mkt7(i)=1.0d0
 else
  Dchilsol_mkt7(i)=0.0d0
 end if    
end do

CALL cpu_time (EndTime)
!write(*,*) "Time:", EndTime-StartTime
MidTime=EndTime






!#######################################################################################################################
!   To interpolate the profit function I must iterate over price and rates (evaluatiom points). To speed up the program, 
!   I draw OUTSIDE of these loops the workers' and parents shocks and types. I.e. workers and parents shocks and types 
!   constant across evaluation points in the profit approximating regression
!#########################################################################################################################

!! Use the same shocks as in the baseline scenario
open(unit=87857,file='./baseline_shocks_parents.txt')
  do i=1,n_s
    do sim=1,D
	 
	   read(87857,*) epsilon_p(1,i,sim), epsilon_p(2,i,sim),  epsilon_p(3,i,sim), type_ip(i,sim)


    end do
  end do

close(87857)


open(unit=878571,file='./baseline_shocks_workers.txt')
  do i=1,n_w
    do sim=1,D
	 
	   read(878571,*) epsilon_w(1,i,sim), epsilon_w(2,i,sim), epsilon_w(3,i,sim), epsilon_w(4,i,sim), type_iw(i,sim)


    end do
  end do

close(878571)


 
	do i=1,n_s
 	 do sim=1,D



	   epsilon_pglobal(1,i,sim)=epsilon_p(1,i,sim)
  	   epsilon_pglobal(2,i,sim)=epsilon_p(2,i,sim)
  	   epsilon_pglobal(3,i,sim)=epsilon_p(3,i,sim)
	   type_ipglobal(i,sim)=type_ip(i,sim)

 	 end do 
	end do



	do i=1,n_w
	 do sim=1,D




          epsilon_wglobal(1,i,sim)=epsilon_w(1,i,sim)
          epsilon_wglobal(2,i,sim)=epsilon_w(2,i,sim)
          epsilon_wglobal(3,i,sim)=epsilon_w(3,i,sim)
          epsilon_wglobal(4,i,sim)=epsilon_w(4,i,sim)
		  
		  type_iwglobal(i,sim)=type_iw(i,sim)
		  

	 end do
	end do  


	!Draw one type draw for each individual and simulation
	Psi_w(1)=1.0d0-theta(92)-theta(93)
	Psi_w(2)=theta(92)
	Psi_w(3)=theta(93)

	!write(*,*) "Prob1, prob2, prob3", Psi(1), Psi(2), Psi(3)



	
	!Draw one type draw for each individual
	Psi_p(1)=(1.0d0-theta(127)-theta(128))
	Psi_p(2)=theta(127)
	Psi_p(3)=theta(128)

	

open(unit=1,file='./counterfactual_RefEqm2_log.txt')

!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
!&&&&&&&&&& LOOP OVER rM &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&


r_entry=0.0d0

do rM_int=1, iter_rM !the value of iter_rM is set at the beginning of this subroutine


  write(*,*) ""
  write(*,*) ""
  write(*,*) "******************************"
  write(*,*) "counterfactual rM number", rM_int

  write(1,*) ""
  write(1,*) ""
  write(1,*) "********************************"
  write(1,*) "counterfactual rM number", rM_int
  write(1,*) "********************************"
  if(rM_int.eq.0) then
  rM=0.0d0
  else if(rM_int.eq.1.AND.rM_int.ne.iter_rM) then
  rM=1.0d0 !0.020d0 !(dble(rM_int)/10.0d0)+0.12d0  !=0.2
  else if (rM_int.gt.1.AND.rM_int.lt.iter_rM) then
  rM=1.0d0+0.02*dble(rM_int-1)   
  else ! rM_int==iter_rM. In this case, not only I run the counterfactual at the actual reform level rM, bit I also print out the simulated data.
  rM=rM_reform
  end if

  results0(rM_int,1)=rM
  results1(rM_int,1)=rM




!####################################################################################
! Maximize profits. Either interpolate them and max the approximated profits or #####
! maximize numerically true profits, after fixing the price at the cap ##############
!####################################################################################




APPROX_PROF=0

IF (APPROX_PROF.eq.1) THEN

write(*,*) ""
write(*,*) "Interpolate and compute optimal prices in each market and cost shock draw"  !Drep = number of cost shock draws
write(1,*) ""
write(1,*) "Interpolate and compute optimal prices in each market and cost shock draw" 
! Interpolate profits ########################################
!The matrix Reg has a number of lines equal to the number of observations on prices and rates used in the interpolation, and a number of columns equal to 10, the number of regressors
!used in the interpoalting polynomial
!The regressors are:
!     Reg(iter,1)=constant
!     Reg(iter,2)=pv                          !pv in terms of 100mila pesos
!     Reg(iter,3)=Reg(iter,2)**2.0d0          !pv^2
!     Reg(iter,4)=exp(ln_r)!exp(dble(lnr_iter)/100.0d0) !r (on wage expressed in millions)
!     Reg(iter,5)=Reg(iter,4)**2.0d0          !r^2
!     Reg(iter,6)=Reg(iter,2)*Reg(iter,4)     !pv*r
!     Reg(iter,7)=Reg(iter,2)**3.0d0          !pv^3
!     Reg(iter,8)=Reg(iter,4)**3.0d0          !r^3
!     Reg(iter,9)=Reg(iter,3)*Reg(iter,4)     !pv^2 * r
!     Reg(iter,10)=Reg(iter,2)*Reg(iter,5)    !pv * r^2


!l_lnr=log(rM)   
!l_lnr=log(0.815661256+(rM-2.0d0)*0.815661256/10.0d0)
call  assign_regressors(l_lnr, u_lnr, l_p, u_p, Reg)  !It only builds the vector of regressors Reg. It does not do XpX anymore, bc that depends on the number of misisng obs.
write(*,*) "in main1b, exited assign_regressors"
call Interpolation(rM, Drep,l_lnr, u_lnr, l_p, u_p,outputname,Reg,ahatmat,Rsqmat,epsilon_p,epsilon_w,type_ip, type_iw, pv_omat, r_omat,positive_maxaprof,maxprof_mat)
!(NB: in Interpolation it's called maxprof_mat even if in reality it's APPROXIMATE profits)

write(*,*) ""
write(*,*) "Computed optimal prices"
write(1,*) ""
write(1,*) "Computed optimal prices"

ELSE !APPROX_PROF==0


write(*,*) ""
write(*,*) "Setting p equal to p_cap and numerically maximizing profits wrt r"  
write(1,*) ""
write(1,*) "Setting p equal to p_cap and numerically maximizing profits wrt r"  


pv_omat=p_cap



call find_optimal(rM, Drep,pv_omat, r_omat, maxprof_mat)



write(*,*) ""
write(*,*) "Computed optimal prices"
write(1,*) ""
write(1,*) "Computed optimal prices"
!read(*,*) stopping

END IF









!For each optimal p and r, depending on the Fixed Cost, different industry configurations will arise


write(*,*) ""
write(*,*) "Computing industry configuration under alternative Fixed Cost assumptions"
write(1,*) ""
write(1,*) "Computing industry configuration under alternative Fixed Cost assumptions"
!********* SIMULATION: SIMULATE PARENTS AND WORKERS AT THE OPTIMAL PRICES.





!***************************************************
!&& CASE 0: assuming V schools always stay in the market in counterfactual policy simualtions. FC is not identifiable anyway 
!***************************************************

case=0



!For each market, pick a cost shock draw. I am going to pick the first one


maxaprof_used=-99.0d0
pv_used=-100.0d0
r_used=-100.0d0

done=0             !i.e. i still need to fill in all markets
no_solution=0.0d0  !this variable stays the same in all 3 FC scenarios because it tells me whether I was able to solve the approximated problem in all mkts (if so =0)
   do mkt=1,n_mkt
      do sim=1,Drep
        if(pv_omat(mkt,sim)>0.0d0.AND.r_omat(mkt,sim)>0.0d0.AND.done(mkt).eq.0) then  
         pv_used(mkt)=pv_omat(mkt,1)
         r_used(mkt)=r_omat(mkt,1)
         maxaprof_used(mkt)=maxprof_mat(mkt,1)
         done(mkt)=1
        end if
      end do
     end do
 



found_solution=0   !when found_solution=0 for a market, it means that we could not find a solution for that market, When done2=1 for a market, it means I could find a solution but it was negative.
   do mkt=1,n_mkt
   if(done(mkt).eq.0) then
     do sim=1,Drep
     if(pv_omat(mkt,sim)>0.0d0.AND.r_omat(mkt,sim)>0.0d0.AND.maxprof_mat(mkt,sim)<0.0d0.AND.found_solution(mkt).eq.0.AND.maxprof_mat(mkt,sim).ne.-99.0d0) then !this is actually negative maximized profits
        no_solution(mkt,sim)=0.0d0  
      !  maxaprof_used(mkt)=-98.0d0  !-98 means that I could find a solution, but the profits were negative
        found_solution(mkt)=1
      else
        no_solution(mkt,sim)=1.0d0
      end if



       end do
     end if
   end do


 number_solutions_found=0
 sum_nosolution=0.0d0
 do mkt=1,n_mkt 
 number_solutions_found=number_solutions_found+found_solution(mkt)   !If number_solutions is equal to the number of markets with no V school entry, then we're good: if we don't see a school in a market it's because profits would have been negative, but a solution
                                                                     !to the max problem was found

 do sim=1,Drep
    sum_nosolution(mkt)=sum_nosolution(mkt)+no_solution(mkt,sim)
  end do

   if(sum_nosolution(mkt).eq.dble(Drep)) then
     write(1,*) ""
     write(1,*) "Unable to find a solution in mkt", mkt
     write(1,*) "optimal prices for all shocks are", pv_omat(mkt,1:Drep)
     write(1,*) "optimal rates for all shocks are ", r_omat(mkt,1:Drep)
     write(1,*) "profits", maxprof_mat(mkt,1:Drep)
     write(1,*) ""
   end if
 end do !mkt


    


entry=1.0d0                 
do mkt=1,n_mktvd
  if(maxaprof_used(mkt)<0.0d0)  then

     if(maxaprof_used(mkt)==-99.0d0) then
	       entry(mkt)=0.0d0  
          write(*,*) "In market", mkt, "case=0 there is no V school because either SV=0 or DV=0"
           if(pv_used(mkt).eq.-999.0d0.OR.pv_used(mkt).eq.-994.0d0) then
              write(*,*) "No convergence in constr_maxprof subroutine"
           else if (pv_used(mkt).eq.-99.0d0) then
              write(*,*) "I found a minimum instead of a maximum in constr_maxprof subroutine OR, if no approx, I did not update from initialized value"
           else if (pv_used(mkt).eq.-9911.0d0) then
               write(*,*) "In subroutine constr_maxprof I never updated prices from their initialized values"
            else 
             if(APPROX_PROF.eq.1) then
             write(*,*) "I found the optimal prices and they are negative"
             end if
          end if          
      end if
 end if
end do


write(*,*) ""
write(*,*) "optimal p r and max profits used"
do mkt=1,n_mktvd
   write(*,*) pv_used(mkt), r_used(mkt),  maxaprof_used(mkt)
end do

open(unit=4658,file='./Vschoolstats_RefEqm2.txt', access='append')
do mkt=1,18
  write(4658,'(3I5,3F10.2)') case, rM_int, mkt, pv_used(mkt), r_used(mkt),  maxaprof_used(mkt)
end do
close(4658)



do mkt=1,n_mktvd


  if(entry(mkt).eq.1.0d0) then
    r_entry(rM_int,1)=r_entry(rM_int,1)+pv_used(mkt) !/18.0d0
    r_entry(rM_int,2)=r_entry(rM_int,2)+r_used(mkt)
  end if
  r_entry(rM_int,5)= r_entry(rM_int,5)+entry(mkt)


  end do

    r_entry(rM_int,2)=r_entry(rM_int,2)/r_entry(rM_int,5)
    r_entry(rM_int,1)=r_entry(rM_int,1)/r_entry(rM_int,5)




write(1,*) ""
write(1,*) "number of V schools entering ", entry(1)+entry(2)+entry(3)+entry(4)+entry(5)+entry(6)+entry(7)+entry(8)+entry(9)+entry(10)+entry(11)+entry(12)+entry(13)+entry(14)+entry(15)+entry(16)+entry(17)+entry(18)
write(1,*) "number of markets without a V school", 18-(entry(1)+entry(2)+entry(3)+entry(4)+entry(5)+entry(6)+entry(7)+entry(8)+entry(9)+entry(10)+entry(11)+entry(12)+entry(13)+entry(14)+entry(15)+entry(16)+entry(17)+entry(18))
write(1,*) "of these, it's a legitimate non-entry in this number of cases", number_solutions_found


diagnostics0(rM_int,1)=(18- ( entry(1)+entry(2)+entry(3)+entry(4)+entry(5)+entry(6)+entry(7)+entry(8)+entry(9)+entry(10)+entry(11)+entry(12)+entry(13)+entry(14)+entry(15)+entry(16)+entry(17)+entry(18) ))-number_solutions_found+&
                        &zeroSM_sim(1)+zeroSM_sim(2)+zeroSM_sim(3)+zeroSM_sim(4)+zeroSM_sim(5)+zeroSM_sim(6)+zeroSM_sim(7)+zeroSM_sim(8)+zeroSM_sim(9)+zeroSM_sim(10)+zeroSM_sim(11)+zeroSM_sim(12)+zeroSM_sim(13)+zeroSM_sim(14)&
                        &+zeroSM_sim(15)+zeroSM_sim(16)+zeroSM_sim(17)+zeroSM_sim(18)



 
number_M_schools=0.0d0
number_V_schools=0.0d0
write(*,*) "ABOUT TO CALL SIMDATA_WORKERS2 FROM MAIN1b"
call simdata_workers2_gvmt(rM_int,iter_rM, outcomes0,outcomes1,outcomes05,case,entry,rM, r_used, awM_sim, awV_sim, zeroSM_sim, zeroSV_sim,TotwagesM, SupV, TSV)



do mkt=1,18
 if(zeroSM_sim(mkt).eq.0.0d0) then
  number_M_schools=number_M_schools+1.0d0
 end if

 if(entry(mkt).eq.1.0d0.AND.zeroSV_sim(mkt).eq.1.0d0) then
    write(*,*) "market in which there is entry of V school but SV=0", mkt
    write(1,*) "In market", mkt, " there is a V school but SV=0"
  end if

 if(entry(mkt).eq.0.0d0.AND.zeroSV_sim(mkt).eq.0.0d0) then
    write(*,*) "market in which there is NO entry of V school but POSITIVE SV", mkt
    write(1,*) "In market", mkt, " there is no V school but SV>0"
  end if


 if(zeroSV_sim(mkt).eq.0.0d0) then
  number_V_schools=number_V_schools+1.0d0
 end if

end do
write(*,*) ""
write(*,*) "Number M schools", number_M_schools, "numberV schools",  number_V_schools
write(*,*) "About to call simdata_simce_gvm from main1bt"

call simdata_simce_gvmt(outcomes0,outcomes1, outcomes05,iter_rM,rM_int,case,zeroSM_sim, zeroSV_sim, awM_sim,awV_sim, pv_used,DV,DM , EPV)




gvmtM=0.0d0
extraM_mkt=0.0d0

do mkt=1,n_mkt
  if(DM(mkt)*voucher-TotwagesM(mkt)<0.d0) then !!! Must pay also the difference between revenues and costs

    gvmtM(mkt)=DM(mkt)*voucher+(TotwagesM(mkt)-DM(mkt)*voucher )
 else
   gvmtM(mkt)=DM(mkt)*voucher
 end if
 

   voucherM_mkt(mkt)=DM(mkt)*voucher
if(TotwagesM(mkt)-DM(mkt)*voucher>0.0d0) then 
   extraM_mkt(mkt)=TotwagesM(mkt)-DM(mkt)*voucher
end if
end do





!Now do current expenditures in V school. Expenditures here are in the form of VOUCHERS and in the form of FELLOWSHIPS
!First, compute expenditure in the form of vouchers, taking into account that the voucher is reduced whenever the price exceeds the voucherm which is always the case 
!write profit function using actual governmental formulas

gvmt_Vvoucher=0.0d0

   do mkt=1,n_mkt

           gvmt_Vvoucher(mkt)=voucher*DV(mkt)

   end do



        
   

unit_fellow=0.0d0
school_fellow_contrib=0.0d0
do mkt=1,n_mkt



    gvmt_Vfellow(mkt)=0.068210d0*EPV(mkt)*DV(mkt)


gvmtV(mkt)=gvmt_Vfellow(mkt)+gvmt_Vvoucher(mkt)




gvmt(mkt)=gvmtM(mkt)+gvmtV(mkt)

end do




overall_gov=0.0d0; overall_govM=0.0d0; overall_govV=0.0d0; overall_wageM=0.0d0; overall_voucherM=0.0d0; overall_extraM=0.0d0; overall_voucherV=0.0d0; overall_fellowV=0.0d0
overall_DM=0.0d0; overall_DV=0.0d0

do mkt=1,18
  overall_gov=overall_gov+gvmt(mkt)
  overall_govM=overall_govM+gvmtM(mkt)
  overall_govV=overall_govV+gvmtV(mkt)
  overall_wageM=overall_wageM+TotwagesM(mkt)
  overall_voucherM=overall_voucherM+voucherM_mkt(mkt)
  overall_extraM=overall_extraM+extraM_mkt(mkt)
  overall_voucherV=overall_voucherV+gvmt_Vvoucher(mkt)
  overall_fellowV=overall_fellowV+gvmt_Vfellow(mkt)
  overall_DM=overall_DM+DM(mkt)
  overall_DV=overall_DV+DV(mkt)
end do

write(*,*) "writing gvmt_exp_totals.txt"
open(unit=765761,file='gvmt_exp_RefEqm2_totals.txt')
write(765761,*) "overall_gov,overall_govM,overall_govV,overall_wageM,overall_voucherM,overall_extraM,overall_voucherV,overall_fellowV, overall_DM, overall_DV"

  write(765761,*) overall_gov,overall_govM,overall_govV,overall_wageM,overall_voucherM,overall_extraM,overall_voucherV,overall_fellowV,overall_DM, overall_DV

close(765761)


 expenditures0(rM_int,1)=overall_gov
 expenditures0(rM_int,2)=overall_govM
 expenditures0(rM_int,3)=overall_govV
 expenditures0(rM_int,4)=overall_wageM
 expenditures0(rM_int,5)=overall_voucherM
 expenditures0(rM_int,6)=overall_extraM
 expenditures0(rM_int,7)=overall_voucherV
 expenditures0(rM_int,8)=overall_fellowV


overall_wageM0=0.0d0; overall_shareV0=0.0d0; overall_gvmt0=0.0d0; overall_gvmtfellow0=0.0d0
EnrollV=0.0d0; Enroll=0.0d0

do mkt=1,n_mktvd

 write(*,*) "mkt, gov", mkt, gvmt(mkt)

   overall_wageM0=overall_wageM0+TotwagesM(mkt)
   overall_gvmt0=overall_gvmt0+gvmt(mkt)
   overall_gvmtfellow0=overall_gvmtfellow0+gvmt_Vfellow(mkt)
   EnrollV=EnrollV+DV(mkt)
   Enroll=Enroll+DV(mkt)+DM(mkt)
end do

  overall_shareV0=EnrollV/Enroll


  write(1,*) "Overall government expenditure in CHL pesos", overall_gvmt0 
	write(1,*) ""
  write(1,*) "Overall government expenditure in M schools", overall_govM 
   write(1,*) "    Overall government expenditure in M wages", overall_wageM 
   write(1,*) "    Overall government expenditure in vouchers in M schools", overall_voucherM 
   write(1,*) "    Overall government expenditure: additional expenditure in M becuase vouchers not enough to pay for Teacher wages", overall_extraM 
   write(1,*) ""
  write(1,*) "Overall government expenditure in V schools", overall_govV 
  write(1,*) "     Overall government expenditure in V vouchers", overall_voucherV 
  write(1,*) "     Overall government expenditure in V fellowships", overall_fellowV 

results0(rM_int,1)=rM
results0(rM_int,5)=overall_gvmt0
results0(rM_int,6)=overall_wageM0
results0(rM_int,7)=overall_shareV0



stophere=1
if(stophere.eq.1.AND.rM_int.eq.iter_rM) then
write(*,*) "*************************"
write(*,*) "REACHED END OF PROGRAMME"
write(*,*) "*************************"
end if



end do !rM int

teststop=1
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!! WRITING RESULTS TO FILE
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


if(teststop.eq.0) then


open(unit=87873,file='./outcomesRefEqm2.txt')

write(87873,*) "counterf number, ts,tsm,tsv,tskills,mskills,vskills,dm,dv,sm,sv"
do i=0,iter_rM 
   write(87873,'(11e14.4)') dble(i), outcomes0(i,1:10)
 end do

close(87873)

stophere=1

if(stophere.eq.0) then
open(unit=87874,file='./outcomes11b.txt')

write(87874,*) "counterf number, ts,tsm,tsv,tskills,mskills,vskills,dm,dv,sm,sv"
do i=0,iter_rM 
   write(87874,'(11e14.4)') dble(i), outcomes1(i,1:10)
 end do

close(87874)
end if

if(stophere.eq.0) then
open(unit=87875,file='./outcomes051b.txt')
write(87875,*) "ts,tsm,tsv,tskills,mskills,vskills,dm,dv,sm,sv"
do i=0,iter_rM 
   write(87875,'(11e14.4)') dble(i), outcomes05(i,1:10)
 end do
close(87875)
end if

open(unit=86904,file='./expenditures01b.txt')
write(86904,*) "gov,govM,govV,wageM,voucherM,extraM,voucherV,fellowV"
do i=0,iter_rM 
  write(86904,'(9e14.4)') dble(i), expenditures0(i,1:8)
end do
close(86904)


stophere=1

if(stophere.eq.0) then
open(unit=86905,file='./expenditures11b.txt')
write(86905,*) "gov,govM,govV,wageM,voucherM,extraM,voucherV,fellowV"
do i=0, iter_rM !
  write(86905,'(9e14.4)') dble(i),expenditures1(i,1:8)
end do
close(86905)
end if

if(stophere.eq.0) then
open(unit=86906,file='./expenditures051b.txt')
write(86906,*) "gov,govM,govV,wageM,voucherM,extraM,voucherV,fellowV"
do i=0,iter_rM !
  write(86906,'(9e14.4)') dble(i),expenditures05(i,1:8)
end do
close(86906)
end if






open(unit=3476,file='./r_o_entry_count1b.txt')
  write(3476,*) "rM iteration, market, p_o, r_o, max_profit, entry0, entry1"
do i=0,iter_rM !

       write(3476, '(1I5,9F10.2)')  i,  r_entry(i,1),  r_entry(i,2),  r_entry(i,3),  r_entry(i,4),  r_entry(i,5),  r_entry(i,6), r_entry(i,7), r_entry(i,8), r_entry(i,9)

end do
close(3476)


close(1)



open(unit=110,file='./returns_to_inv_count1b_0.txt') !0 stands for case=0, FC=0
!header: rM, mean_ts, ts_top25, ts_bottom25, gap25, overall government cost, dm, dv, sm, sv

write(111,*) "rM, mean_ts, ts_top25, ts_bottom25, gap25, 0.0d0, overall government cost, 0.0d0, dm, dv, sm, sv, classsize V, classsizeM"
do i=1,iter_rM  
   write(110,'(11F10.2)')  results0(i,1), outcomes0(i,1), outcomes0(i,2), outcomes0(i,3), outcomes0(i,2)-outcomes0(i,3), 0.0d0, results0(i,5), 0.0d0, outcomes0(i,7), outcomes0(i,8), outcomes0(i,9), outcomes0(i,10), outcomes0(i,7)/ outcomes0(i,9), outcomes0(i,8)/outcomes0(i,10)
end do
close(110)


stophere=1

if(stophere.eq.0) then
open(unit=111,file='./returns_to_inv_count1b_1.txt') !0 stands for case=1, FC=old_profits
!header: rM, mean_ts, ts_top25, ts_bottom25, gap25, 0.0d0, overall government cost, 0.0d0, dm, dv, sm, sv

do i=1,iter_rM
    
   write(111,'(11F10.2)')  results1(i,1), outcomes1(i,1), outcomes1(i,2), outcomes1(i,3),outcomes1(i,2)-outcomes1(i,3),0.0d0, results1(i,5), 0.0d0, outcomes1(i,7), outcomes1(i,8), outcomes1(i,9), outcomes1(i,10), outcomes1(i,7)/ outcomes1(i,9), outcomes1(i,8)/outcomes1(i,10)
end do
close(111)
end if

open(unit=1100, file='./diagnostics0_1b.txt')  !
 do i=1,iter_rM
 write(1100,*) diagnostics0(i,1)
end do
close(1100)


stophere=1

if(stophere.eq.0) then
open(unit=1111, file='./diagnostics1_1b.txt')  
 do i=1,iter_rM
 write(1111,*) diagnostics1(i,1)
end do
close(1111)
end if

end if !teststop

END PROGRAM Main_Step2