!reads in abilities of workers in equilibrium



subroutine simdata_simce_gvmt(outcomes0,outcomes1, outcomes05,iter_rM, rM_int,case,zeroSM_sim, zeroSV_sim, awM_sim,awV_sim, pv_used ,DV,DM,EPV)
                        
USE VarDef
USE Datasets
IMPLICIT NONE



integer, intent(in)    :: case, rM_int, iter_rM
real(8), intent(in)    :: awM_sim(n_mkt),awV_sim(n_mkt)
real(8), intent(in)    :: zeroSM_sim(n_mkt), zeroSV_sim(n_mkt)
real(8) , intent(in)   :: pv_used(n_mktvd)
!real(8), intent(inout)    :: results0(0:iter_rM,17), results1(0:iter_rM,17)
real(8), intent(inout)  :: outcomes0(0:iter_rM,10),outcomes1(0:iter_rM,10),outcomes05(0:iter_rM,10)  !0:iter_rM

real(8), intent(out)   :: DV(n_mkt),DM(n_mkt),EPV(n_mkt)

real(8)                :: DV_nation, DM_nation

real(8)                :: epsilon_p(3,n_s,D) , epsilon_pvec(3*n_s*D)
integer                :: noevalSIMCE  !indicator for whether there are zero teachers at all 
real(8)                :: pv_h(n_s), ucM,ucV, awM_scalar, awV_scalar, ucmax
real(8)                :: Psi(3)
real(8)                :: beta0M(n_s), beta0V(n_s)  !this is the constant for type 1 and it varies by mkt
real(8)                :: beta0V_21(n_s), beta0V_31(n_s)  !difference with types two and three, constant across markets
integer                :: type_i(n_s,D)
real(8)                :: unif(n_s*D)


!diagnosis
real(8)                :: avg_tsM, avg_tsV, denomM, denomV, avg_simcaM, avg_simcaV, avg_fracV !average test scores for diagnostic purposes
integer                :: report  !if =1, it reports the values of the test scores for diagnostic purposes
         
 !Simualted dataset (D repetitions per person)           
integer                :: sM(n_s,D), sV(n_s,D)
real(8)                :: sca(n_s,D), scaM(n_s,D), scaV(n_s,D), spv(n_s,D)
real(8)                 :: test_scoreM(n_s,D), test_scoreV(n_s,D)  !write to file the test score that person would have i neach school, independenlty on their choice of school
integer                :: print_dataset  !inedx=1 if I want to print a dataset to file

integer                :: i, sim, ctype, stopping, cat, idum, sim2, mkt, gotoV(n_s,D), gotoM(n_s,D), assigned

real(8)                :: den_weight(n_mkt), weight(n_s)  ! use it to compute DV and avg test scores


!Compute overall mean test scores, and mean test scores by type of school
real(8)                :: mean_ts, mean_tsm, mean_tsv, test_score(n_s,D), totdv, den_meantsv, den_meantsm

!computing welfare

real(8)   :: utility(n_s,D)


!generate income quantile indicators to report test score gaps by income
real(8)   :: bottom_10(n_s), bottom_25(n_s), bottom_50(n_s),top_50(n_s), top_25(n_s), top_10(n_s)
real(8)   :: meants_bottom10, meants_bottom25, meants_bottom50, meants_top50, meants_top25, meants_top10
real(8)   :: mass_bottom10, mass_bottom25, mass_bottom50, mass_top50, mass_top25, mass_top10
real(8)   :: gap10, gap25, gap50
real(8)   :: mass






write(*,*) "Inside simdata_simce2, rM_int=", rM_int



!Initializations
report=0
type_i=-99
noevalSIMCE=0

utility=-99.0d0

meants_bottom10=0.0d0; meants_bottom25=0.0d0; meants_bottom50=0.0d0; meants_top50=0.0d0; meants_top25=0.0d0; meants_top10=0.0d0
 bottom_10=0.0d0; bottom_25=0.0d0; bottom_50=0.0d0; top_50=0.0d0; top_25=0.0d0; top_10=0.0d0
mass_bottom10=0.0d0; mass_bottom25=0.0d0; mass_bottom50=0.0d0; mass_top50=0.0d0; mass_top25=0.0d0; mass_top10=0.0d0
gap10=0.0d0; gap25=0.0d0; gap50=0.0d0






!Draw one type draw for each individual
Psi(1)=(1.0d0-theta(127)-theta(128))
Psi(2)=theta(127)
Psi(3)=theta(128)



!Draw types and error shocks of parents
!use same as baseline
open(unit=87857,file='./baseline_shocks_parents.txt')
  do i=1,n_s
    do sim=1,D
	 
	   read(87857,*) epsilon_p(1,i,sim), epsilon_p(2,i,sim),  epsilon_p(3,i,sim), type_i(i,sim)


    end do
  end do

close(87857)


do i=1,n_s
    do sim=1,D
	  type_ipglobal(i,sim)=type_i(i,sim)
	   if(type_i(i,sim).eq.0) then
	   write(*,*) "ERROR: in subroutine simdata_simce1_RefEqm.f90, did not read in correctly type shock, for i, sim=", i, sim
	 
	   end if


    end do
  end do


!Computing individual level price that each family would have to pay if they chose the V school in their market 
!This depends on the fellowship that each family is eligible for
    
    do i=1,n_s   

       
       pv_h(i)=theta(162)+theta(163)*(pv_used(mkt7_s(i))-voucher)+theta(164)*dble(primaria_s(i))+theta(165)*dble(nfam_s(i))+& !theta(166)*dble(peduc_s(i))+theta(176)*dble(Central(mkt7_s(i)))&
                  &theta(169)*dble(rural_s(i))+theta(171)*mincome_s(i)
    
      if(pv_h(i)>pv_used(mkt7_s(i))-voucher) then
        pv_h(i)=pv_used(mkt7_s(i))-voucher
      else if (pv_h(i)<0.0d0) then      
        pv_h(i)=0.0d0
     end if  
   


  !Assign correct beta0M and beta0V
  if(mkt7_s(i).eq.1) then
     den_weight(1)=den_weight(1)+1.0d0
     beta0M(i)=theta(110)
     beta0V(i)=theta(113)

  
   else if (mkt7_s(i).eq.2) then
     den_weight(2)=den_weight(2)+1.0d0
     beta0M(i)=theta(199)
     beta0V(i)=theta(216)


  
   else if (mkt7_s(i).eq.3) then
     den_weight(3)=den_weight(3)+1.0d0
     beta0M(i)=theta(200)
     beta0V(i)=theta(217)



   else if (mkt7_s(i).eq.4) then
     den_weight(4)=den_weight(4)+1.0d0
     beta0M(i)=theta(201)
     beta0V(i)=theta(218)



   else if (mkt7_s(i).eq.5) then
     den_weight(5)=den_weight(5)+1.0d0
     beta0M(i)=theta(202)
     beta0V(i)=theta(219)




   else if (mkt7_s(i).eq.6) then
     den_weight(6)=den_weight(6)+1.0d0
     beta0M(i)=theta(203)
     beta0V(i)=theta(220)




   else if (mkt7_s(i).eq.7) then
     den_weight(7)=den_weight(7)+1.0d0
     beta0M(i)=theta(204)
     beta0V(i)=theta(221)




   else if (mkt7_s(i).eq.8) then
     den_weight(8)=den_weight(8)+1.0d0
     beta0M(i)=theta(205)
     beta0V(i)=theta(222)




   else if (mkt7_s(i).eq.9) then
     den_weight(9)=den_weight(9)+1.0d0
     beta0M(i)=theta(206)
     beta0V(i)=theta(223)




   else if (mkt7_s(i).eq.10) then
     den_weight(10)=den_weight(10)+1.0d0
     beta0M(i)=theta(207)
     beta0V(i)=theta(224)




   else if (mkt7_s(i).eq.11) then
     den_weight(11)=den_weight(11)+1.0d0
     beta0M(i)=theta(208)
     beta0V(i)=theta(225)




   else if (mkt7_s(i).eq.12) then
     den_weight(12)=den_weight(12)+1.0d0
     beta0M(i)=theta(209)
     beta0V(i)=theta(226)




   else if (mkt7_s(i).eq.13) then
     den_weight(13)=den_weight(13)+1.0d0
     beta0M(i)=theta(210)
     beta0V(i)=theta(227)




   else if (mkt7_s(i).eq.14) then
     den_weight(14)=den_weight(14)+1.0d0
     beta0M(i)=theta(211)
     beta0V(i)=theta(228)




   else if (mkt7_s(i).eq.15) then
     den_weight(15)=den_weight(15)+1.0d0
     beta0M(i)=theta(212)
     beta0V(i)=theta(229)




   else if (mkt7_s(i).eq.16) then
     den_weight(16)=den_weight(16)+1.0d0
     beta0M(i)=theta(213)
     beta0V(i)=theta(230)




   else if (mkt7_s(i).eq.17) then
     den_weight(17)=den_weight(17)+1.0d0
     beta0M(i)=theta(214)
     beta0V(i)=theta(231)




   else if (mkt7_s(i).eq.18) then
     den_weight(18)=den_weight(18)+1.0d0
     beta0M(i)=theta(215)
     beta0V(i)=theta(232)



   end if

  end do !i



!############### Compute simulated choices of parents #########################################
!############### Compute simulated accepted test scores of kids (=0 if sector not chosen) #####
!choice probabilities of parents given teachers' abilities

 
!write(*,*) "INSIDE SIMDATA SIMCE: about to compute utilities "


gotoV=0
gotoM=0
assigned=0


do i=1,n_s



  !Assign income quantile indicators
   if(mincome_s(i).le.0.50d0) then
    bottom_10(i)=1.0d0
   end if
   if(mincome_s(i).le.1.50d0) then
    bottom_25(i)=1.0d0
    bottom_50(i)=1.0d0
   end if
   if(mincome_s(i).gt.1.50) then
    top_50(i)=1.0d0
   end if
   if(mincome_s(i).gt.3.5) then
    top_25(i)=1.0d0
   end if
   if(mincome_s(i).gt.5.5) then
    top_10(i)=1.0d0
    end if
 
  do sim=1,D
  if(type_ipglobal(i,sim).eq.1) then
  ucM=beta0M(i)+theta(116)*awM_sim(mkt7_s(i))+theta(119)*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+theta(120)*dble(peduc_s(i))+&
         &epsilon_pglobal(1,i,sim)+theta(123)*log(mincome_s(i))+theta(124)+theta(234)*dble(primaria_s(i))+theta(235)*dble(rural_s(i))+epsilon_pglobal(3,i,sim) 

  test_scoreM(i,sim)=beta0M(i)+theta(116)*awM_sim(mkt7_s(i))+theta(119)*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+theta(120)*dble(peduc_s(i))+&
         &epsilon_pglobal(1,i,sim)

 

   ucV=beta0V(i)+theta(242)*awV_sim(mkt7_s(i))+theta(236)*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+theta(239)*dble(peduc_s(i))+&
                &epsilon_pglobal(2,i,sim)+theta(123)*log(mincome_s(i)-pv_h(i))

   test_scoreV(i,sim)=beta0V(i)+theta(242)*awV_sim(mkt7_s(i))+theta(236)*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+theta(239)*dble(peduc_s(i))+&
                &epsilon_pglobal(2,i,sim)


   

   
   else if(type_ipglobal(i,sim).eq.2) then
  ucM=beta0M(i)+theta(111)+(theta(116)+theta(117))*awM_sim(mkt7_s(i))+(theta(119)+theta(249))*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+(theta(120)+theta(251))*dble(peduc_s(i))+&
               &epsilon_pglobal(1,i,sim)+(theta(123)+theta(197))*log(mincome_s(i))+theta(124)+theta(125)+theta(234)*dble(primaria_s(i))+theta(235)*dble(rural_s(i))+epsilon_pglobal(3,i,sim)  

  test_scoreM(i,sim)=beta0M(i)+theta(111)+(theta(116)+theta(117))*awM_sim(mkt7_s(i))+(theta(119)+theta(249))*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/dble(nfam_s(i)))**2.0d0+(theta(120)+theta(251))*dble(peduc_s(i))+&
               &epsilon_pglobal(1,i,sim)
  

  ucV=beta0V(i)+theta(114)+(theta(242)+theta(243))*awV_sim(mkt7_s(i))+(theta(236)+theta(237))*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
        &(theta(239)+theta(240))*dble(peduc_s(i))+&
        &epsilon_pglobal(2,i,sim)+(theta(123)+theta(197))*log(mincome_s(i)-pv_h(i)) 

   test_scoreV(i,sim)=beta0V(i)+theta(114)+(theta(242)+theta(243))*awV_sim(mkt7_s(i))+(theta(236)+theta(237))*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
        &(theta(239)+theta(240))*dble(peduc_s(i))+&
        &epsilon_pglobal(2,i,sim)
  
   else if (type_ipglobal(i,sim).eq.3) then
  ucM=beta0M(i)+theta(112)+(theta(116)+theta(118))*awM_sim(mkt7_s(i))+(theta(119)+theta(250))*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
         &(theta(120)+theta(252))*dble(peduc_s(i))+&
         &epsilon_pglobal(1,i,sim)+(theta(123)+theta(198))*log(mincome_s(i))+theta(124)+theta(126)+theta(234)*dble(primaria_s(i))+theta(235)*dble(rural_s(i))+epsilon_pglobal(3,i,sim)

   test_scoreM(i,sim)=beta0M(i)+theta(112)+(theta(116)+theta(118))*awM_sim(mkt7_s(i))+(theta(119)+theta(250))*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
         &(theta(120)+theta(252))*dble(peduc_s(i))+&
         &epsilon_pglobal(1,i,sim)
    
  ucV=beta0V(i)+theta(115)+(theta(242)+theta(244))*awV_sim(mkt7_s(i))+(theta(236)+theta(238))*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
        &(theta(239)+theta(241))*dble(peduc_s(i))+&
        &epsilon_pglobal(2,i,sim)+(theta(123)+theta(198))*log(mincome_s(i)-pv_h(i))

   test_scoreV(i,sim)=beta0V(i)+theta(115)+(theta(242)+theta(244))*awV_sim(mkt7_s(i))+(theta(236)+theta(238))*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
        &(theta(239)+theta(241))*dble(peduc_s(i))+&
        &epsilon_pglobal(2,i,sim)

    end if     
  
  
  
        
 
      if(mincome_s(i)-pv_h(i)>0) then
         ucmax=max(ucM,ucV) 
      else if (mincome_s(i)-pv_h(i)<=0.0d0) then
         ucmax=ucM
      end if

       if(zeroSM_sim(mkt7_s(i)).eq.1.0d0.AND.zeroSV_sim(mkt7_s(i)).eq.0.0d0) then !go to V
         ucmax=ucV
         gotoV(i,sim)=1
         
        
       else if (zeroSM_sim(mkt7_s(i)).eq.0.0d0.AND.zeroSV_sim(mkt7_s(i)).eq.1.0d0) then !go to M
         ucmax=ucM

          
         gotoM(i,sim)=1
         assigned=1
         
       
       end if

     !Case where zeroSM=1 and zeroSV=1: see below
     
     if(ucmax==ucM.OR.gotoM(i,sim).eq.1) then
              utility(i,sim)=ucM
              sV(i,sim)=0
              scaV(i,sim)=-99.0d0 
              spv(i,sim)=-99.0d0
              sM(i,sim)=1
            !cognitive achievement in M = test scores
            if(type_ipglobal(i,sim).eq.1) then
            
              scaM(i,sim)=beta0M(i)+theta(116)*awM_sim(mkt7_s(i))+theta(119)*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+theta(120)*dble(peduc_s(i))+&
                                   &epsilon_pglobal(1,i,sim)

            test_score(i,sim)=scaM(i,sim)
   
             !  if(report.eq.1) then 
             !    if(simcaM_uncondSIMCE(i)<-3.0d0) then
             !       write(*,*) ""
             !       write(*,*) "low tsM", simcaM_uncondSIMCE(i)
             !       write(*,*) "type=1"
             !       write(*,*) "intercept", beta0M(i)
             !       write(*,*) "teachers", theta(116)*awM_sim(mkt7_s(i)), theta(116), awM_sim(mkt7_s(i))
             !       write(*,*) "mincpc", (theta(119))*mincome_s(i)/(dble(nfam_s(i))), (theta(119)), mincome_s(i)/(dble(nfam_s(i)))
             !       write(*,*) "mincpc^2", theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0
             !       write(*,*) "peduc", (theta(120))*dble(peduc_s(i)), (theta(120)), dble(peduc_s(i))
             !       write(*,*) "shock", epsilon_pSIMCE(1,i,sim)!

 		!   else if (simcaM_uncondSIMCE(i)>3.0d0) then
              !      write(*,*) ""
              !      write(*,*) "high tsM", simcaM_uncondSIMCE(i)
              !      write(*,*) "type=1"
              !      write(*,*) "intercept", beta0M(i)
              !      write(*,*) "teachers", theta(116)*awM_sim(mkt7_s(i)), theta(116), awM_sim(mkt7_s(i))
              !      write(*,*) "mincpc", (theta(119))*mincome_s(i)/(dble(nfam_s(i))), (theta(119)), mincome_s(i)/(dble(nfam_s(i)))
              !      write(*,*) "mincpc^2", theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0
              !      write(*,*) "peduc", (theta(120))*dble(peduc_s(i)), (theta(120)), dble(peduc_s(i))
              !      write(*,*) "shock", epsilon_pSIMCE(1,i,sim)

               !   end if
               !end if !report
           else if (type_ipglobal(i,sim).eq.2) then
              scaM(i,sim)=beta0M(i)+theta(111)+(theta(116)+theta(117))*awM_sim(mkt7_s(i))+(theta(119)+theta(249))*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
                              & (theta(120)+theta(251))*dble(peduc_s(i))+&
                              &epsilon_pglobal(1,i,sim) 

             test_score(i,sim)=scaM(i,sim)

               ! if(report.eq.1) then
               ! if(simcaM_uncondSIMCE(i)<-3.00d0) then
               !     write(*,*) ""
               !     write(*,*) "low tsM", simcaM_uncondSIMCE(i)
               !     write(*,*) "type=2"
               !     write(*,*) "intercept", beta0M(i)+theta(111)
               !     write(*,*) "teachers", (theta(116)+theta(117))*awM_sim(mkt7_s(i)), (theta(116)+theta(117)), awM_sim(mkt7_s(i))
               !     write(*,*) "mincpc", (theta(119)+theta(249))*mincome_s(i)/(dble(nfam_s(i))), (theta(119)+theta(249)), mincome_s(i)/(dble(nfam_s(i)))
               !     write(*,*) "mincpc^2", theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0,  theta(195), (mincome_s(i)/(dble(nfam_s(i))))**2.0d0
               !     write(*,*) "peduc", (theta(120)+theta(251))*dble(peduc_s(i)), (theta(120)+theta(251)), dble(peduc_s(i))
               !     write(*,*) "shock", epsilon_pSIMCE(1,i,sim)
               !   else if (simcaM_uncondSIMCE(i)>3.00d0) then
               !     write(*,*) ""
               !     write(*,*) "high tsM", simcaM_uncondSIMCE(i)
               !     write(*,*) "type=2"
               !    write(*,*) "intercept", beta0M(i)+theta(111)
               !     write(*,*) "teachers", (theta(116)+theta(117))*awM_sim(mkt7_s(i)), (theta(116)+theta(117)), awM_sim(mkt7_s(i))
               !     write(*,*) "mincpc", (theta(119)+theta(249))*mincome_s(i)/(dble(nfam_s(i))), (theta(119)+theta(249)), mincome_s(i)/(dble(nfam_s(i)))
               !!     write(*,*) "mincpc^2", theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0,  theta(195), (mincome_s(i)/(dble(nfam_s(i))))**2.0d0
                !    write(*,*) "peduc", (theta(120)+theta(251))*dble(peduc_s(i)), (theta(120)+theta(251)), dble(peduc_s(i))
                !    write(*,*) "shock", epsilon_pSIMCE(1,i,sim)

                ! end if
                !end if !report
        


             else if (type_ipglobal(i,sim).eq.3) then
              scaM(i,sim)=beta0M(i)+theta(112)+(theta(116)+theta(118))*awM_sim(mkt7_s(i))+(theta(119)+theta(250))*mincome_s(i)/(dble(nfam_s(i)))+theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
                   &(theta(120)+theta(252))*dble(peduc_s(i))+epsilon_pglobal(1,i,sim)

              test_score(i,sim)=scaM(i,sim)
      
              ! if(report.eq.1) then
              !  if(simcaM_uncondSIMCE(i)<-3.00d0) then
              !      write(*,*) ""
              !      write(*,*) "low tsM", simcaM_uncondSIMCE(i)
              !      write(*,*) "type=3"
              !      write(*,*) "intercept", beta0M(i)+theta(112)
              !      write(*,*) "teachers", (theta(116)+theta(118))*awM_sim(mkt7_s(i)), (theta(116)+theta(118)),awM_sim(mkt7_s(i))
              !      write(*,*) "mincpc", (theta(119)+theta(250))*mincome_s(i)/(dble(nfam_s(i))),(theta(119)+theta(250)),mincome_s(i)/(dble(nfam_s(i)))
              !      write(*,*) "mincpc^2", theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0,theta(195),(mincome_s(i)/(dble(nfam_s(i))))**2.0d0
              !      write(*,*) "peduc", (theta(120)+theta(252))*dble(peduc_s(i)),(theta(120)+theta(252)),dble(peduc_s(i))
              !      write(*,*) "shock", epsilon_pSIMCE(1,i,sim)

		!else if (simcaM_uncondSIMCE(i)>3.00d0) then
              !      write(*,*) ""
              !      write(*,*) "high tsM", simcaM_uncondSIMCE(i)
              !      write(*,*) "type=3"
              !       write(*,*) "intercept", beta0M(i)+theta(112)
              !      write(*,*) "teachers", (theta(116)+theta(118))*awM_sim(mkt7_s(i)), (theta(116)+theta(118)),awM_sim(mkt7_s(i))
              !      write(*,*) "mincpc", (theta(119)+theta(250))*mincome_s(i)/(dble(nfam_s(i))),(theta(119)+theta(250)),mincome_s(i)/(dble(nfam_s(i)))
              !      write(*,*) "mincpc^2", theta(195)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0,theta(195),(mincome_s(i)/(dble(nfam_s(i))))**2.0d0
              !!      write(*,*) "peduc", (theta(120)+theta(252))*dble(peduc_s(i)),(theta(120)+theta(252)),dble(peduc_s(i))
               !     write(*,*) "shock", epsilon_pSIMCE(1,i,sim)

               !  end if
               !  end if !report
      


             end if


           
     else if (ucmax==ucV.OR.gotoV(i,sim).eq.1) then
             utility(i,sim)=ucV
             sV(i,sim)=1
             scaM(i,sim)=-99.0d0 
             spv(i,sim)=pv_h(i)   
         
           !cognitive achievement in V = test scores
           if(type_ipglobal(i,sim).eq.1) then
            
            scaV(i,sim)=beta0V(i)+theta(242)*awV_sim(mkt7_s(i))+theta(236)*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+theta(239)*dble(peduc_s(i))+&                   
                               &epsilon_pglobal(2,i,sim)

           test_score(i,sim)=scaV(i,sim)

            ! if(report.eq.1) then
  	!	if(simcaV_uncondSIMCE(i)<-3.0d0) then
!		!  write(*,*) ""
		!  write(*,*) "low tsV", simcaV_uncondSIMCE(i)
		!  write(*,*) "type=1"
		!  write(*,*) "intercept",beta0V(i) 
		!  write(*,*) "teachers", theta(242)*awV_sim(mkt7_s(i)),  theta(242), awV_sim(mkt7_s(i))
		!  write(*,*) "mincpc",  theta(236)*mincome_s(i)/(dble(nfam_s(i))),  theta(236), mincome_s(i)/(dble(nfam_s(i)))
		!  write(*,*) "mincpc^2", theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0,  theta(247), (mincome_s(i)/(dble(nfam_s(i))))**2.0d0
		!  write(*,*) "peduc", theta(239)*dble(peduc_s(i)),  theta(239), dble(peduc_s(i))
		!  write(*,*) "shock", epsilon_pSIMCE(2,i,sim)

              ! else if (simcaV_uncondSIMCE(i)>3.0d0) then
		!  write(*,*) ""
		!  write(*,*) "high tsV", simcaV_uncondSIMCE(i)
		!  write(*,*) "type=1"
		!  write(*,*) "intercept",beta0V(i) 
		!  write(*,*) "teachers", theta(242)*awV_sim(mkt7_s(i)),  theta(242), awV_sim(mkt7_s(i))
		!  write(*,*) "mincpc",  theta(236)*mincome_s(i)/(dble(nfam_s(i))),  theta(236), mincome_s(i)/(dble(nfam_s(i)))
		!  write(*,*) "mincpc^2", theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0,  theta(247), (mincome_s(i)/(dble(nfam_s(i))))**2.0d0
		!  write(*,*) "peduc", theta(239)*dble(peduc_s(i)),  theta(239), dble(peduc_s(i))
		!  write(*,*) "shock", epsilon_pSIMCE(2,i,sim)
	!	end if
!		!end if !report
              
                 
             else if (type_ipglobal(i,sim).eq.2) then
             scaV(i,sim)=beta0V(i)+theta(114)+(theta(242)+theta(243))*awV_sim(mkt7_s(i))+(theta(236)+theta(237))*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
                               &(theta(239)+theta(240))*dble(peduc_s(i))+&
                               &epsilon_pglobal(2,i,sim)   

              test_score(i,sim)=scaV(i,sim)

		!if(report.eq.1) then

  		!if(simcaV_uncondSIMCE(i)<-3.0d0) then
		!  write(*,*) ""
		!  write(*,*) "low tsV", simcaV_uncondSIMCE(i)
		!  write(*,*) "type=2"
		!!  write(*,*) "intercept",beta0V(i)+theta(114)
		 !! write(*,*) "teachers", (theta(242)+theta(243))*awV_sim(mkt7_s(i)),(theta(242)+theta(243)), awV_sim(mkt7_s(i))
		 ! write(*,*) "mincpc",  (theta(236)+theta(237))*mincome_s(i)/(dble(nfam_s(i))), (theta(236)+theta(237)), mincome_s(i)/(dble(nfam_s(i)))
		 ! write(*,*) "mincpc^2", theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0,  theta(247), (mincome_s(i)/(dble(nfam_s(i))))**2.0d0
		 ! write(*,*) "peduc", (theta(239)+theta(240))*dble(peduc_s(i)), (theta(239)+theta(240)), dble(peduc_s(i))
		 ! write(*,*) "shock", epsilon_pSIMCE(2,i,sim)

		!else if (simcaV_uncondSIMCE(i)>3.0d0) then
		!  write(*,*) ""
		!  write(*,*) "high tsV", simcaV_uncondSIMCE(i)
		!  write(*,*) "type=2"
		!  write(*,*) "intercept",beta0V(i)+theta(114)
		!  write(*,*) "teachers", (theta(242)+theta(243))*awV_sim(mkt7_s(i)),(theta(242)+theta(243)), awV_sim(mkt7_s(i))
		!  write(*,*) "mincpc",  (theta(236)+theta(237))*mincome_s(i)/(dble(nfam_s(i))), (theta(236)+theta(237)), mincome_s(i)/(dble(nfam_s(i)))
		!  write(*,*) "mincpc^2", theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0,  theta(247), (mincome_s(i)/(dble(nfam_s(i))))**2.0d0
		!  write(*,*) "peduc", (theta(239)+theta(240))*dble(peduc_s(i)), (theta(239)+theta(240)), dble(peduc_s(i))
		!  write(*,*) "shock", epsilon_pSIMCE(2,i,sim)

		!end if
		! end if !report


           else if (type_ipglobal(i,sim).eq.3) then
             scaV(i,sim)=beta0V(i)+theta(115)+(theta(242)+theta(244))*awV_sim(mkt7_s(i))+(theta(236)+theta(238))*mincome_s(i)/(dble(nfam_s(i)))+theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0+&
                               &(theta(239)+theta(241))*dble(peduc_s(i))+&
                               &epsilon_pglobal(2,i,sim)

               test_score(i,sim)=scaV(i,sim)

		!if(report.eq.1) then
  		!if(simcaV_uncondSIMCE(i)<-3.0d0) then
		!  write(*,*) ""
		!  write(*,*) "low tsV", simcaV_uncondSIMCE(i)
		!  write(*,*) "type=3"
		!  write(*,*) "intercept",beta0V(i)+theta(115)
		!  write(*,*) "teachers", (theta(242)+theta(244))*awV_sim(mkt7_s(i)), (theta(242)+theta(244)), awV_sim(mkt7_s(i))
		!  write(*,*) "mincpc",  (theta(236)+theta(238))*mincome_s(i)/(dble(nfam_s(i))),  (theta(236)+theta(238)), mincome_s(i)/(dble(nfam_s(i)))
		!  write(*,*) "mincpc^2", theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0, theta(247), (mincome_s(i)/(dble(nfam_s(i))))**2.0d0
		!!  write(*,*) "peduc", (theta(239)+theta(241))*dble(peduc_s(i)), (theta(239)+theta(241)), dble(peduc_s(i))
		 ! write(*,*) "shock", epsilon_pSIMCE(2,i,sim)

             ! else if(simcaV_uncondSIMCE(i)>3.0d0) then
	!	  write(*,*) ""
		 !! write(*,*) "high tsV", simcaV_uncondSIMCE(i)
		 ! write(*,*) "type=3"
		 ! write(*,*) "intercept",beta0V(i)+theta(115)
		 ! write(*,*) "teachers", (theta(242)+theta(244))*awV_sim(mkt7_s(i)), (theta(242)+theta(244)), awV_sim(mkt7_s(i))
		 ! write(*,*) "mincpc",  (theta(236)+theta(238))*mincome_s(i)/(dble(nfam_s(i))),  (theta(236)+theta(238)), mincome_s(i)/(dble(nfam_s(i)))
		 !! write(*,*) "mincpc^2", theta(247)*(mincome_s(i)/(dble(nfam_s(i))))**2.0d0, theta(247), (mincome_s(i)/(dble(nfam_s(i))))**2.0d0
		 ! write(*,*) "peduc", (theta(239)+theta(241))*dble(peduc_s(i)), (theta(239)+theta(241)), dble(peduc_s(i))
		 ! write(*,*) "shock", epsilon_pSIMCE(2,i,sim)

	!	end if
	!	end if !report

           end if    
                    

     else 
         noevalSIMCE=1  !this is the case in which both SM and SV are equal to zero
         write(*,*) "Problem in sbroutine simulate_simce: did not find optimal choice for parents. family i,child type=", i,ctype
       !  write(*,*) "ucM=", ucM(ctype)
       !  write(*,*) "ucV=", ucV(ctype)
       !  write(*,*) "ucmax=", ucmax(ctype)
       !  write(*,*) "awM=", awM_sim(mkt7_s(i))
       !  write(*,*) "awV=", awV_sim(mkt7_s(i))
        ! read(*,*) stopping
     end if  


       if (zeroSM_sim(mkt7_s(i)).eq.1.0d0.AND.zeroSV_sim(mkt7_s(i)).eq.1.0d0) then !no outcome  
       noevalSIMCE=1
       write(*,*) "No supply of teachers at all!"
        scaM(i,sim)=-99.0d0
        scaV(i,sim)=-99.0d0
        sV(i,sim)=-99
        spv(i,sim)=-99
       test_score(i,sim)=-99.0d0
      
       end if



if(test_score(i,sim).eq.-99.0d0) then
 write(*,*) "for person i, no tst score. is it because no supply of teachers?", noevalSIMCE
end if

end do !sim

end do !i  




DV=0.0d0
DM=0.0d0
mass=0.0d0




 
   do i=1,n_s
  

     if( mkt7_s(i).eq.1) then
       weight(i)=69964.996/ 3283
     end if

     if( mkt7_s(i).eq.2) then
       weight(i)=97091.995/4687
     end if


     if( mkt7_s(i).eq.3) then
       weight(i)=80431.002/ 4078
     end if


     if( mkt7_s(i).eq.4) then
       weight(i)=34857.001/1517
     end if


     if( mkt7_s(i).eq.5) then
       weight(i)=145449.02/ 6745
     end if


     if( mkt7_s(i).eq.6) then
       weight(i)=94161.988/ 4173
     end if


     if( mkt7_s(i).eq.7) then
       weight(i)=141275.01/ 6457
     end if


     if( mkt7_s(i).eq.8) then
       weight(i)=58556.004/ 2150
     end if


     if( mkt7_s(i).eq.9) then
       weight(i)=80961.998/3374
     end if


     if( mkt7_s(i).eq.10) then
       weight(i)=35555.997/1351
     end if


     if( mkt7_s(i).eq.11) then
       weight(i)=70407.012/ 3869
     end if


     if( mkt7_s(i).eq.12) then
       weight(i)=34381.997/ 1768
     end if


     if( mkt7_s(i).eq.13) then
       weight(i)=132718/ 4958
     end if


     if( mkt7_s(i).eq.14) then
       weight(i)=18074.999/ 765
     end if


     if( mkt7_s(i).eq.15) then
       weight(i)=573627.83/ 36582
     end if


     if( mkt7_s(i).eq.16) then
       weight(i)=137462/ 10631
     end if

     if( mkt7_s(i).eq.17) then
       weight(i)=61226.993/ 2761
     end if

     if( mkt7_s(i).eq.18) then
       weight(i)=17787.006/ 851
     end if

    do mkt=1,n_mkt

   do sim=1,D
   if(mkt7_s(i).eq.mkt) then
    DM(mkt)=DM(mkt)+weight(i)*(1.0d0-dble(sV(i,sim)))/dble(D)
    DV(mkt)=DV(mkt)+weight(i)*(dble(sV(i,sim)))/dble(D)
    EPV(mkt)=EPV(mkt)+weight(i)*dble(sV(i,sim))*spv(i,sim)/dble(D)

   end if
   end do !sim


   end do  !mkt



  !Now comput mass in each income quantile
  mass_bottom10=mass_bottom10+weight(i)*bottom_10(i)*dble(D)  
  mass_bottom25=mass_bottom25+weight(i)*bottom_25(i)*dble(D)
  mass_bottom50=mass_bottom50+weight(i)*bottom_50(i)*dble(D)
  mass_top50=mass_top50+weight(i)*top_50(i)*dble(D)
  mass_top25=mass_top25+weight(i)*top_25(i)*dble(D)
  mass_top10=mass_top10+weight(i)*top_10(i)*dble(D)

  !compute overall mass to use as denominator
   mass=mass+weight(i)*dble(D)
  

  end do  !i

do mkt=1,18
  if(zeroSM_sim(mkt).eq.1.0d0.AND.DV(mkt).eq.0.0d0) then
    write(*,*) "ERROR: no teachers in M, but no student goes to V"
    write(*,*) "zeroSM, zeroSV", zeroSM_sim(mkt), zeroSV_sim(mkt)
    write(*,*) "DM, DV", DM(mkt), DV(mkt)
  end if


 if(zeroSV_sim(mkt).eq.1.0d0.AND.DM(mkt).eq.0.0d0) then
    write(*,*) "ERROR: no teachers in V, but no student goes to M"
    write(*,*) "zeroSM, zeroSV", zeroSM_sim(mkt), zeroSV_sim(mkt)
    write(*,*) "DM, DV", DM(mkt), DV(mkt)
  end if

 if(DV(mkt).eq.0.0d0.AND.DM(mkt).eq.0.0d0) then
   write(*,*) "zero demand for enrollment in both schools"
 end if

 
end do


totdv=0.0d0

 do mkt=1,n_mkt
     if(DV(mkt).ne.0.0d0) then
        EPV(mkt)=EPV(mkt)/DV(mkt)

      totdv=totdv+DV(mkt)

     end if

  end do

DV_nation=0.0d0
DM_nation=0.0d0

do mkt=1,18
  DV_nation=DV_nation+DV(mkt)
  DM_nation=DM_nation+DM(mkt)
end do


!Now compute the means

mean_ts=0.0d0; mean_tsm=0.0d0; mean_tsv=0.0d0
den_meantsv=0.0d0; den_meantsm=0.0d0

do i=1,n_s
 do sim=1,D
   if(test_score(i,sim).ne.-99.0d0) then
   mean_ts=mean_ts+test_score(i,sim)*weight(i)  
   mean_tsm=mean_tsm+test_score(i,sim)*(1.0d0-sV(i,sim))*weight(i)
   mean_tsv=mean_tsv+test_score(i,sim)*sV(i,sim)*weight(i)
   den_meantsm=den_meantsm+(1.0d0-sV(i,sim))*weight(i)
   den_meantsv=den_meantsv+sV(i,sim)*weight(i)
   meants_bottom10=meants_bottom10+test_score(i,sim)*weight(i)*bottom_10(i)/mass_bottom10
   meants_bottom25=meants_bottom25+test_score(i,sim)*weight(i)*bottom_25(i)/mass_bottom25
   meants_bottom50=meants_bottom50+test_score(i,sim)*weight(i)*bottom_50(i)/mass_bottom50
   meants_top50=meants_top50+test_score(i,sim)*weight(i)*top_50(i)/mass_top50
   meants_top25=meants_top25+test_score(i,sim)*weight(i)*top_25(i)/mass_top25
   meants_top10=meants_top10+test_score(i,sim)*weight(i)*top_50(i)/mass_top10
   else
    write(*,*) "*** test score = -99 ****"
   end if
end do !sim
end do !i


if(totdv.ne.0.0d0.AND.den_meantsv.eq.0.0d0) then
   write(*,*) "Problem assigning zero denominator to test scores in V but should not"
end if


  if(den_meantsm.ne.0.0d0) then
   mean_tsm=mean_tsm/den_meantsm
  else
    mean_tsm=-99.0d0
  end if
  if(den_meantsv.ne.0.0d0) then
   mean_tsv=mean_tsv/den_meantsv
  else
    mean_tsv=-99.0d0
    write(*,*) "setting mean_tsv to -99 because zero denominator"
  end if
  if(mass.ne.0.0d0) then
    mean_ts=mean_ts/mass !(DM_nation+DV_nation)      !(den_meantsv+den_meantsm)
   else
     mean_ts=-99.0d0
   end if



if (case.eq.0) then

  write(*,*) ""
  write(*,*) "***"
  write(*,*) "Case = 0"
  write(*,*) "Mean test scores ", mean_ts
  write(*,*) "Mean test scores M", mean_tsm
  write(*,*) "Mean test scores V", mean_tsv
  write(*,*) "Gap               ", mean_tsv-mean_tsm
  write(1,*) "Mean test scores ", mean_ts
  write(1,*) "Mean test scores M", mean_tsm
  write(1,*) "Mean test scores V", mean_tsv
  write(1,*) "Gap               ", mean_tsv-mean_tsm
  write(1,*) ""
  write(1,*) "Gap10             ", meants_top10-meants_bottom10
  write(1,*) "ts top 10", meants_top10
  write(1,*) "ts bottom 10", meants_bottom10
  write(1,*) ""
  write(1,*) "Gap25             ", meants_top25-meants_bottom25
  write(1,*) "ts top 25", meants_top25
  write(1,*) "ts bottom 25", meants_bottom25
  write(1,*) ""
  write(1,*) "Gap50             ", meants_top50-meants_bottom50





  outcomes0(rM_int,1)=mean_ts
  outcomes0(rM_int,2)=meants_top25 !!meants_top10-meants_bottom10   !mean_tsm
  outcomes0(rM_int,3)=meants_bottom25 !meants_top25-meants_bottom25 !mean_tsv

  outcomes0(rM_int,7)=DM_nation    !den_meantsm
  outcomes0(rM_int,8)=DV_nation    !den_meantsv


!write(*,*) "writing simdata_counterfactual_RefEqm.txt"
print_dataset=1 
if(rM_int.eq.iter_rM.AND.print_dataset.eq.1) then
write(*,*) "writing simulated parental dataset to file simdata_counterfactual_RefEqm.txt when rM=rM_reform"
open(unit=1223,file='./simdata_simce_counterfactual_RefEqm.txt')


    do i=1,n_s !turn this to 5000 from home or it'll take too long to download
  
       write(1223,*) i,  id_s(i),1,weight(i), mkt7_s(i),type_ipglobal(i,1), primaria_s(i),rural_s(i), nfam_s(i), peduc_s(i), fem_s(i),  mincome_s(i), &
       & m_s(i), v_s(i), mtuition_s(i), standability_s(i)  ,spv(i,1), sV(i,1), awM_sim(mkt7_s(i)), awV_sim(mkt7_s(i)),&
       & pv_used(mkt7_s(i))-voucher, voucher, test_scoreM(i,1), test_scoreV(i,1), utility(i,1)
  
    end do
close(1223)  
end if

!end if

else if (case.eq.1) then

  write(*,*) ""
  write(*,*) "***"
  write(*,*) " Case = 1"
  write(*,*) "Mean test scores ", mean_ts
  write(*,*) "Mean test scores M", mean_tsm
  write(*,*) "Mean test scores V", mean_tsv
  write(*,*) "Gap               ", mean_tsv-mean_tsm

  write(1,*) "Mean test scores ", mean_ts
  write(1,*) "Mean test scores M", mean_tsm
  write(1,*) "Mean test scores V", mean_tsv
  write(1,*) "Gap               ", mean_tsv-mean_tsm
  write(1,*) ""
  write(1,*) "Gap10             ", meants_top10-meants_bottom10
  write(1,*) "ts top 10", meants_top10
  write(1,*) "ts bottom 10", meants_bottom10
  write(1,*) ""
  write(1,*) "Gap25             ", meants_top25-meants_bottom25
  write(1,*) "ts top 25", meants_top25
  write(1,*) "ts bottom 25", meants_bottom25
  write(1,*) ""
  write(1,*) "Gap50             ", meants_top50-meants_bottom50





  outcomes1(rM_int,1)=mean_ts
  outcomes1(rM_int,2)=meants_top25 !meants_top10-meants_bottom10 !mean_tsm
  outcomes1(rM_int,3)=meants_bottom25 !meants_top25-meants_bottom25 !mean_tsv

  outcomes1(rM_int,7)=DM_nation   !den_meantsm
  outcomes1(rM_int,8)=DV_nation    !den_meantsv





print_dataset=0
if(print_dataset.eq.1) then
open(unit=1223,file='./simdata_simce_count_rm1_case1.txt')
    do i=1,n_s !
  
       write(1223,*) id_s(i),1,weight(i), mkt7_s(i),type_ipglobal(i,1), primaria_s(i),rural_s(i), nfam_s(i), peduc_s(i), fem_s(i),  mincome_s(i), &
       & m_s(i), v_s(i), mtuition_s(i), standability_s(i) ,  scaV(i,sim) ,   scaM(i,sim)  ,spv(i,1), sV(i,sim), awM_sim(mkt7_s(i)), awV_sim(mkt7_s(i)),&
       & pv_used(mkt7_s(i))-voucher, voucher, test_scoreM(i,sim), test_scoreV(i,sim)
  
  end do
close(1223) 

end if 

!end if


else if (case.eq.5) then

  outcomes05(rM_int,1)=mean_ts
  outcomes05(rM_int,2)=meants_top25             !meants_top10-meants_bottom10 !mean_tsm
  outcomes05(rM_int,3)= meants_bottom25         !meants_top25-meants_bottom25 !mean_tsv

  outcomes05(rM_int,7)=DM_nation   !den_meantsm
  outcomes05(rM_int,8)=DV_nation   !den_meantsv




print_dataset=0
if (print_dataset.eq.1) then
open(unit=1223,file='./simdata_simce_counterfactual_RefEqm2.txt')
    do i=1,n_s !
  
       write(1223,*) i, id_s(i),1,weight(i), mkt7_s(i),type_ipglobal(i,1), primaria_s(i),rural_s(i), nfam_s(i), peduc_s(i), fem_s(i),  mincome_s(i), &
       & m_s(i), v_s(i), mtuition_s(i), standability_s(i)  ,spv(i,1), sV(i,1), awM_sim(mkt7_s(i)), awV_sim(mkt7_s(i)),&
       & pv_used(mkt7_s(i))-voucher, voucher, test_scoreM(i,1), test_scoreV(i,1),  utility(i,1)
  
  end do
close(1223)  

end if
!end if




end if !case




if(noevalSIMCE.eq.1) then
   write(*,*) "at least one market with no teachers at all"
end if


end subroutine simdata_simce_gvmt