subroutine simulate_workers_mkt(mkt,ln_r,awV, awM, SV, TSV, zeroSM, zeroSV )
USE VarDef
USE Datasets
IMPLICIT NONE



integer, intent(in)    :: mkt
real(8), intent(in)    :: ln_r  !Assume ln_r is the same in all markets

real(8), intent(out)   :: awV, awM, SV, TSV
real(8), intent(out)   :: zeroSM, zeroSV


!To solve workers' model
real(8)                :: simM(n_w,D), simV(n_w,D), simNT(n_w,D), simH(n_w,D), stskills(n_w,D), SM
real(8)                :: constM(NWType), constNT(NWType),lnwageM(n_w,D), lnwageV(n_w,D), lnwageNT(n_w,D), uwM, uwV, uwNT, uwH
real(8)                :: umax
integer                :: i, sim, wtype, cat, stopping, idum


zeroSM=-99.0d0; zeroSV=-99.0d0
SV=0.0d0; TSV=0.0d0; SM=0.0d0





!Now compute teaching skills of each worker in the market given ytpe and shock



do i=1,n_w

  if(mkt7_w(i).eq.mkt) then !otherwise don't loop!
 do sim=1,D

   if(type_iwglobal(i,sim).eq.1) then
      stskills(i,sim)=exp(theta(10)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+theta(16)*dble(perfec_w(i))+&
             & theta(17)*dble(graddeg_w(i))+epsilon_wglobal(3,i,sim))

   else if (type_iwglobal(i,sim).eq.2) then
      stskills(i,sim)=exp(theta(10)+theta(11)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+theta(16)*dble(perfec_w(i))+&
             & theta(17)*dble(graddeg_w(i))+epsilon_wglobal(3,i,sim))
  else if (type_iwglobal(i,sim).eq.3) then
      stskills(i,sim)=exp(theta(10)+theta(12)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+theta(16)*dble(perfec_w(i))+&
             & theta(17)*dble(graddeg_w(i))+epsilon_wglobal(3,i,sim))
   end if
 
  
  if(theta(10)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+theta(16)*dble(perfec_w(i))+&
           & theta(17)*dble(graddeg_w(i))+epsilon_wglobal(3,i,sim).ge.1.0D307.OR.&
           &theta(10)+theta(11)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+theta(16)*dble(perfec_w(i))+&
           & theta(17)*dble(graddeg_w(i))+epsilon_wglobal(3,i,sim).ge.1.0D307.OR.&
           &theta(10)+theta(12)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+theta(16)*dble(perfec_w(i))+&
           & theta(17)*dble(graddeg_w(i))+epsilon_wglobal(3,i,sim).ge.1.0D307) then
    write(*,*) "WARNING: Argument of exp() in subroutine simdata_casenw is dangerously high"
    ! noeval=1
    !write(*,*) "Type any integer to continue"
    !read(*,*) stopping
  end if
 
             
  end do !sim 
   end if !that selects only ppl in current market
end do !i

!Compute optimal choice for each worker, and simulation number

do i=1,n_w
  if(mkt7_w(i).eq.mkt) then

 
  
    
    !NT: notice: they vary by worker's type, NB: constNT=ability constant. ln_r=log of wage
    if(mkt.eq.1) then
     constNT(1)=theta(18)
     constNT(2)=theta(18)+theta(36)
     constNT(3)=theta(18)+theta(54)
     constM(1)=theta(1)
     constM(2)=theta(1)+theta(2)
     constM(3)=theta(1)+theta(3)


    else if (mkt.eq.2) then
     constNT(1)=theta(19)
     constNT(2)=theta(19)+theta(37)
     constNT(3)=theta(19)+theta(55)
     constM(1)=theta(288)
     constM(2)=theta(288)+theta(2)
     constM(3)=theta(288)+theta(3)

    else if (mkt.eq.3) then
     constNT(1)=theta(20)
     constNT(2)=theta(20)+theta(38)
     constNT(3)=theta(20)+theta(56)
     constM(1)=theta(289)
     constM(2)=theta(289)+theta(2)
     constM(3)=theta(289)+theta(3)


    else if (mkt.eq.4) then
     constNT(1)=theta(21)
     constNT(2)=theta(21)+theta(39)
     constNT(3)=theta(21)+theta(57)
     constM(1)=theta(290)
     constM(2)=theta(290)+theta(2)
     constM(3)=theta(290)+theta(3)



    else if (mkt.eq.5) then
     constNT(1)=theta(22)
     constNT(2)=theta(22)+theta(40)
     constNT(3)=theta(22)+theta(58)
     constM(1)=theta(291)
     constM(2)=theta(291)+theta(2)
     constM(3)=theta(291)+theta(3)



    else if (mkt.eq.6) then
     constNT(1)=theta(23)
     constNT(2)=theta(23)+theta(41)
     constNT(3)=theta(23)+theta(59)
     constM(1)=theta(292)
     constM(2)=theta(292)+theta(2)
     constM(3)=theta(292)+theta(3)


    else if (mkt.eq.7) then
     constNT(1)=theta(24)
     constNT(2)=theta(24)+theta(42)
     constNT(3)=theta(24)+theta(60)
     constM(1)=theta(293)
     constM(2)=theta(293)+theta(2)
     constM(3)=theta(293)+theta(3)


    else if (mkt.eq.8) then
     constNT(1)=theta(25)
     constNT(2)=theta(25)+theta(43)
     constNT(3)=theta(25)+theta(61)
     constM(1)=theta(294)
     constM(2)=theta(294)+theta(2)
     constM(3)=theta(294)+theta(3)



    else if (mkt.eq.9) then
     constNT(1)=theta(26)
     constNT(2)=theta(26)+theta(44)
     constNT(3)=theta(26)+theta(62)   
     constM(1)=theta(295)
     constM(2)=theta(295)+theta(2)
     constM(3)=theta(295)+theta(3)



    else if (mkt.eq.10) then
     constNT(1)=theta(27)
     constNT(2)=theta(27)+theta(45)
     constNT(3)=theta(27)+theta(63)
     constM(1)=theta(296)
     constM(2)=theta(296)+theta(2)
     constM(3)=theta(296)+theta(3)


    else if (mkt.eq.11) then
     constNT(1)=theta(28)
     constNT(2)=theta(28)+theta(46)
     constNT(3)=theta(28)+theta(64)
     constM(1)=theta(297)
     constM(2)=theta(297)+theta(2)
     constM(3)=theta(297)+theta(3)



    else if (mkt.eq.12) then
     constNT(1)=theta(29)
     constNT(2)=theta(29)+theta(47)
     constNT(3)=theta(29)+theta(65)
     constM(1)=theta(298)
     constM(2)=theta(298)+theta(2)
     constM(3)=theta(298)+theta(3)


    else if (mkt.eq.13) then
     constNT(1)=theta(30)
     constNT(2)=theta(30)+theta(48)
     constNT(3)=theta(30)+theta(66)
     constM(1)=theta(299)
     constM(2)=theta(299)+theta(2)
     constM(3)=theta(299)+theta(3)



    else if (mkt.eq.14) then
     constNT(1)=theta(31)
     constNT(2)=theta(31)+theta(49)
     constNT(3)=theta(31)+theta(67)
     constM(1)=theta(300)
     constM(2)=theta(300)+theta(2)
     constM(3)=theta(300)+theta(3)



    else if (mkt.eq.15) then
     constNT(1)=theta(32)
     constNT(2)=theta(32)+theta(50)
     constNT(3)=theta(32)+theta(68)
     constM(1)=theta(301)
     constM(2)=theta(301)+theta(2)
     constM(3)=theta(301)+theta(3)



    else if (mkt.eq.16) then
     constNT(1)=theta(33)
     constNT(2)=theta(33)+theta(51)
     constNT(3)=theta(33)+theta(69)
     constM(1)=theta(302)
     constM(2)=theta(302)+theta(2)
     constM(3)=theta(302)+theta(3)



    else if (mkt.eq.17) then
     constNT(1)=theta(34)
     constNT(2)=theta(34)+theta(52)
     constNT(3)=theta(34)+theta(70)
     constM(1)=theta(303)
     constM(2)=theta(303)+theta(2)
     constM(3)=theta(303)+theta(3)



    else if (mkt.eq.18) then
     constNT(1)=theta(35)
     constNT(2)=theta(35)+theta(53)
     constNT(3)=theta(35)+theta(71)
     constM(1)=theta(304)
     constM(2)=theta(304)+theta(2)
     constM(3)=theta(304)+theta(3)

    
    end if

do sim=1,D

   !lnwageM(i,sim)=log(rate_M)+log(stskills(i,sim))
  
   if(type_iwglobal(i,sim).eq.1) then
   
    
      lnwageM(i,sim)=constM(1)+theta(5)*dble(age_w(i))+theta(6)*(dble(age_w(i))**2.0d0)+theta(7)*dble(fem_w(i))+theta(8)*dble(perfec_w(i))+&
                    & theta(9)*dble(graddeg_w(i))+epsilon_wglobal(2,i,sim)



     lnwageV(i,sim) =ln_r+theta(10)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+&
                           & theta(16)*dble(perfec_w(i))+theta(17)*dble(graddeg_w(i))+epsilon_wglobal(3,i,sim)
     lnwageNT(i,sim)=constNT(1)+theta(72)*dble(age_w(i))+theta(73)*(dble(age_w(i))**2.0d0)+theta(74)*dble(fem_w(i))+theta(75)*dble(perfec_w(i))+&
                       & theta(76)*dble(graddeg_w(i))+epsilon_wglobal(4,i,sim) 
     uwM=lnwageM(i,sim)+theta(77)
     uwV=lnwageV(i,sim)+theta(80)
     uwNT=lnwageNT(i,sim)
     uwH=theta(83)+theta(86)*dble(fem_w(i))+theta(87)*dble(fem_w(i))*dble(nkids_w(i))+theta(88)*dble(age_w(i))+theta(194)*(dble(age_w(i)))**2.0d0+&
               & theta(89)*dble(nkids_w(i))+theta(90)*dble(nkids2_w(i))+&
               & theta(91)*(dble(nkids6_w(i))-dble(nkids2_w(i)))+epsilon_wglobal(1,i,sim)
   
   else if (type_iwglobal(i,sim).eq.2) then

  lnwageM(i,sim)=constM(2)+theta(5)*dble(age_w(i))+theta(6)*(dble(age_w(i))**2.0d0)+theta(7)*dble(fem_w(i))+theta(8)*dble(perfec_w(i))+&
                    & theta(9)*dble(graddeg_w(i))+epsilon_wglobal(2,i,sim)


   
     lnwageV(i,sim) =ln_r+theta(10)+theta(11)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+&
                      & theta(16)*dble(perfec_w(i))+theta(17)*dble(graddeg_w(i))+epsilon_wglobal(3,i,sim)
     lnwageNT(i,sim)=constNT(2)+theta(72)*dble(age_w(i))+theta(73)*(dble(age_w(i))**2.0d0)+theta(74)*dble(fem_w(i))+theta(75)*dble(perfec_w(i))+&
                     & theta(76)*dble(graddeg_w(i))+epsilon_wglobal(4,i,sim)
     uwM=lnwageM(i,sim)+theta(77)+theta(78)
     uwV=lnwageV(i,sim)+theta(80)+theta(81)
     uwNT=lnwageNT(i,sim)
     uwH=theta(83)+theta(84)+theta(86)*dble(fem_w(i))+theta(87)*dble(fem_w(i))*dble(nkids_w(i))+theta(88)*dble(age_w(i))+&
               & theta(194)*(dble(age_w(i)))**2.0d0+theta(89)*dble(nkids_w(i))+theta(90)*dble(nkids2_w(i))+&
               & theta(91)*(dble(nkids6_w(i))-dble(nkids2_w(i)))+epsilon_wglobal(1,i,sim)



  else if (type_iwglobal(i,sim).eq.3) then

  lnwageM(i,sim)=constM(3)+theta(5)*dble(age_w(i))+theta(6)*(dble(age_w(i))**2.0d0)+theta(7)*dble(fem_w(i))+theta(8)*dble(perfec_w(i))+&
                    & theta(9)*dble(graddeg_w(i))+epsilon_wglobal(2,i,sim)



     lnwageV(i,sim) =ln_r+theta(10)+theta(12)+theta(13)*dble(age_w(i))+theta(14)*(dble(age_w(i))**2.0d0)+theta(15)*dble(fem_w(i))+ &
                       & theta(16)*dble(perfec_w(i))+theta(17)*dble(graddeg_w(i))+epsilon_wglobal(3,i,sim)
     lnwageNT(i,sim)=constNT(3)+theta(72)*dble(age_w(i))+theta(73)*(dble(age_w(i))**2.0d0)+theta(74)*dble(fem_w(i))+theta(75)*dble(perfec_w(i))+ &
                      & theta(76)*dble(graddeg_w(i))+epsilon_wglobal(4,i,sim)
     uwM=lnwageM(i,sim)+theta(77)+theta(79)
     uwV=lnwageV(i,sim)+theta(80)+theta(82)
     uwNT=lnwageNT(i,sim)
     uwH=theta(83)+theta(85)+theta(86)*dble(fem_w(i))+theta(87)*dble(fem_w(i))*dble(nkids_w(i))+theta(88)*dble(age_w(i))+&
           & theta(194)*(dble(age_w(i)))**2.0d0+theta(89)*dble(nkids_w(i))+theta(90)*dble(nkids2_w(i))+&
           & theta(91)*(dble(nkids6_w(i))-dble(nkids2_w(i)))+epsilon_wglobal(1,i,sim)   
   
end if
  

   umax=max(uwM,uwV,uwNT,uwH)
   if(umax==uwM) then
    simM(i,sim)=1.0d0
    simV(i,sim)=0.0d0
    simNT(i,sim)=0.0d0
    simH(i,sim)=0.0d0
   
   
   else if(umax==uwV) then
    simM(i,sim)=0.0d0
    simV(i,sim)=1.0d0
    simNT(i,sim)=0.0d0
    simH(i,sim)=0.0d0
   

   else if (umax==uwNT) then
    simM(i,sim)=0.0d0
    simV(i,sim)=0.0d0
    simNT(i,sim)=1.0d0
    simH(i,sim)=0.0d0
     
   else if (umax==uwH) then
    simM(i,sim)=0.0d0
    simV(i,sim)=0.0d0
    simNT(i,sim)=0.0d0
    simH(i,sim)=1.0d0
   

   else
    write(*,*) "Problem in subroutine simulate_workers: did not find optimal choice for worker i, of type, sim number", i, wtype, sim
    !read(*,*) stopping
   end if  


  end do !sim
 

end if !that selects only ppl in that market
end do !i





awM=0.0d0
awV=0.0d0
SM=0.0d0
SV=0.0d0
TSV=0.0d0

do i=1,n_w

 if(mkt7_w(i).eq. mkt) then

  do sim=1,D

  if(simM(i,sim).eq.1.0d0) then
    SM=SM+id_w(2,i)
    awM=awM+stskills(i,sim)*id_w(2,i)

  end if

  if(simV(i,sim).eq.1.0d0) then
    SV=SV+id_w(2,i)
    awV=awV+stskills(i,sim)*id_w(2,i)
    TSV=TSV+stskills(i,sim)*id_w(2,i)
  end if

   end do !sim

  end if !that selects only ppl in that mkt
end do !i


zeroSM=0.0d0
zeroSV=0.0d0




 
 if(SM.ne.0.0d0) then
   awM=awM/SM

  else
    zeroSM=1.0d0
 end if
  if(SV.ne.0.0d0) then
    awV=awV/SV
  else
    zeroSV=1.0d0
 end if


!Now divide TSV and SV by tot number of simulations to get the correct supply (in the averages, it cancels out)

  SM=SM/dble(D)
  SV=SV/dble(D)
  TSV=TSV/dble(D)






end subroutine simulate_workers_mkt
