program prepare_matrices

IMPLICIT NONE


real(8)  :: W(607,607), V(607,607), Gamma(607,212)
real(8)  :: weighting_parents(321,321), weighting_workers(286,286), derivative_parents(321,212), derivative_workers(286,212)
real(8)  :: var_parents(321,321), var_workers(286,286)

integer  :: k, kk, p



!Initialize
W=0.0d0
V=0.0d0
Gamma=0.0d0
weighting_parents=0.0d0
weighting_workers=0.0d0
derivative_parents=0.0d0
derivative_workers=0.0d0
var_parents=0.0d0
var_workers=0.0d0



open(unit=11,file='inverseSIMCE.txt')
do k=1,321
     read(11,*) weighting_parents(k,1:321)
end do

close(11)

!write(*,*) "first line weighting_parents", weighting_parents(1,1:321)
!write(*,*) "last line weighting_parents", weighting_parents(321,1:321)

open(unit=12,file='inverseworkers.txt')
do k=1,286
     read(12,*) weighting_workers(k,1:286)
end do
close(12)

!write(*,*) "first line weighting workers", weighting_workers(1,1:286)
!write(*,*) "last line weighting workers", weighting_workers(286,1:286)


!To build W matrix, premultiply weighting_parents by (1/0.71919097**2) and weighting_workers by (1/0.28080903**2)

do k=1,321
 do kk=1,321
    W(k,kk)=(1.0d0/0.719190970d0**2.0d0)*weighting_parents(k,kk)
  end do
end do

do k=322,607
  do kk=322,607
    W(k,kk)=(1.0d0/0.280809030d0**2.0d0)*weighting_workers(k-321,kk-321)
  end do
end do

open(unit=22,file='./W.txt')
  do k=1,607
   do kk=1,607
      write(22,*) W(k,kk)
   end do
  end do
close(22)





open(unit=13,file='./FULLVar_SIMCE.txt')
do k=1,321
 do kk=1,321
    read(13,*) var_parents(k,kk)
  end do
end do
close(13)

!write(*,*) "first line var_parents", var_parents(1,1:321)
!write(*,*) "last line var_parents", var_parents(321,1:321)

open(unit=14,file='./FULLVar_workers.txt')
do k=1,286
 do kk=1,286
    read(14,*) var_workers(k,kk)
  end do
end do
close(14)
!write(*,*) "first line var_workers", var_workers(1,1:286)
!write(*,*) "last line var_workers", var_workers(286,1:286)


do k=1,321
 do kk=1,321
    V(k,kk)=(0.71919097**2.0d0)*var_parents(k,kk)
 end do
end do

do k=322,607
  do kk=322,607
      V(k,kk)=(0.28080903**2.0d0)*var_workers(k-321,kk-321)
  end do
end do

  open(unit=21,file='./V.txt')
   do k=1,607
     do kk=1,607
        write(21,*) V(k,kk)
     end do
    end do
  close(21)


open(unit=15,file='./Derivative_parents.txt')

do k=1,321
  do kk=1,212
     read(15,*) derivative_parents(k,kk)
  end do
end do

close(15)


open(unit=16,file='./Derivative_workers.txt')

do k=1,286
  do kk=1,212
     read(16,*) derivative_workers(k,kk)
  end do
end do

close(16)


do k=1,321
  do kk=1,212
    Gamma(k,kk)=0.719190970d0*derivative_parents(k,kk)
  end do
end do

do k=322,607
   do kk=1,212
     Gamma(k,kk)=0.280809030d0*derivative_workers(k-321,kk)
   end do
end do


write(*,*) "Elementsof Gamma"
open(unit=23,file='./Gamma.txt')
 do k=1,607
  do kk=1,212  
 ! write(*,*) "Row", k
 ! write(*,*) "Column", kk
    write(23,*)  Gamma(k,kk)
   end do
  end do
close(23)

!write(*,*) "row 607 of Gamma"
!write(*,*) Gamma(607,1:212)

write(*,*) "***************************"
write(*,*) "Last row of W", W(607,:)


write(*,*) "***************************"
write(*,*) "Last row of V", V(607,:)









end program prepare_matrices



