!he in the name of this subroutine stands for higher-order method in the calculation of the numerical derivative (derivative approximation by finite differences)
!compute the M x p matrix of derivative of the parents' moments w.r.t. model parameters

!compute the M x p matrix of derivative of the parents' moments w.r.t. all parameters
!M = 321 = number of parents' moments, p = 212 = number of parameters (including 18 rental rates) 






PROGRAM Deriv_parents

USE VarDef
USE Datasets


IMPLICIT NONE

!####################### VARIABLE DECLARATION ########################


real(8)        :: gamma_step1(212), npar, gamma_workers(132) !number of parameters plus 17 rental rates to estimate
character(150) :: inputname, outputname, tag
integer        :: i, stopping, k, kk, wtype, ctype, skiploop, idum, mkt, sim_cost, iter, iter_r, iter_pv,docalib, docalibprof, apps, sim, s
integer, parameter :: Snum=4 !!number of evaluation points in grid [frac* theta, (1.0 + (1-frac)* theta], e.g. [0.80 theta, 1.2 theta]
real(8), parameter    :: frac=0.85d0 
real(8)        :: momi_parents(n_s,321), momi_parents_0(n_s,321)

real(8)        :: Derivative_parents(321,212), Derivative_parents_eval(321,212,0:Snum), Moments_parents_for_interpol(321,212,0:Snum)  !matrix with dataset for interpolation, where 286 moments are calculated for each of the Snum evaluation points of each of the 132 parameters
real(8)        :: parameters(212), h_bump
real(8)        :: mom_parents_mat(321,0:Snum)  !moments for each grid value s


integer        :: bu

real(8)        :: epsilon_pvec(3*n_s*D), epsilon_p(3,n_s,D)
real(8)        :: epsilon_wvec(4*n_w*D), epsilon_w(4,n_w,D)

real(8)        :: awM(n_mkt), awV(n_mkt)
integer        :: noeval, zeroSM(n_mkt), zeroSV(n_mkt)

Derivative_parents=0.0d0
Derivative_parents_eval=0.0d0
Moments_parents_for_interpol=0.0d0

mom_parents_mat=0.0d0

h_bump=(2.00-2.00*frac)/real(Snum)


!#######################################################

!############## Read in datasets #######################

!######################################################
!SIMCE06_media and primaria together
open(unit=12,file='./SIMCE410_final.txt')
    do i=1,n_s
       read(12,*) id_s(i), mkt7_s(i),primaria_s(i),rural_s(i), nfam_s(i), peduc_s(i), fem_s(i), unempl_s(i), blue_s(i), mincome_s(i), &
       & m_s(i), v_s(i), mtuition_s(i), standability_s(i) 
    end do
close(12)  


do i=1,n_s
  mincome_s(i)=mincome_s(i)/100000.0d0
  if(blue_s(i).eq.2) then
   blue_s(i)=0
  end if 
end do

do i=1,n_s
 if(mkt7_s(i).eq.6661) then
     mkt7_s(i)=1
    else if (mkt7_s(i).eq.6662) then
     mkt7_s(i)=2 
    else if (mkt7_s(i).eq.6663) then
     mkt7_s(i)=3 
    else if (mkt7_s(i).eq.6664) then
     mkt7_s(i)=4 
    else if (mkt7_s(i).eq.6665) then
     mkt7_s(i)=5 
    else if (mkt7_s(i).eq.6666) then
     mkt7_s(i)=6 
    else if (mkt7_s(i).eq.6667) then
     mkt7_s(i)=7 
    else if (mkt7_s(i).eq.6668) then
     mkt7_s(i)=8 
    else if (mkt7_s(i).eq.6669) then
     mkt7_s(i)=9 
    else if (mkt7_s(i).eq.66610) then
     mkt7_s(i)=10 
    else if (mkt7_s(i).eq.66612) then
     mkt7_s(i)=11 
    else if (mkt7_s(i).eq.66613) then
     mkt7_s(i)=12 
    else if (mkt7_s(i).eq.66614) then
     mkt7_s(i)=13 
    else if (mkt7_s(i).eq.66615) then
     mkt7_s(i)=14 
    else if (mkt7_s(i).eq.66616) then
     mkt7_s(i)=15 
    else if (mkt7_s(i).eq.66617) then
     mkt7_s(i)=16 
    else if (mkt7_s(i).eq.66618) then
     mkt7_s(i)=17 
    else if (mkt7_s(i).eq.66619) then
     mkt7_s(i)=18 
   end if
end do

 !### read in the workers' dataset ######




!WORKERS UNIQUE
open(unit=13,file='./workers_unique.txt') !a dot between final and trim indicates that this is the dataset with the corrected weights (corrected using idoneidad and fraction teaching obtained in original casen, before imputation)
    do i=1,n_w
       read(13,*) id_w(1,i), id_w(2,i), mkt7_w(i), graddeg_w(i), perfec_w(i), nkids_w(i), nkids2_w(i), nkids6_w(i), age_w(i), fem_w(i), &
       & peduc_w(i), m_w(i), v_w(i), nt_w(i), h_w(i),wage_w(i)
    end do
close(13)


     
do i=1,n_w
   wage_w(i)=wage_w(i)/100000.0d0
  
end do

do i=1,n_w

   age_w(i)=age_w(i)-19

   if(mkt7_w(i).eq.6661) then
     mkt7_w(i)=1
    else if (mkt7_w(i).eq.6662) then
     mkt7_w(i)=2 
    else if (mkt7_w(i).eq.6663) then
     mkt7_w(i)=3 
    else if (mkt7_w(i).eq.6664) then
     mkt7_w(i)=4 
    else if (mkt7_w(i).eq.6665) then
     mkt7_w(i)=5 
    else if (mkt7_w(i).eq.6666) then
     mkt7_w(i)=6 
    else if (mkt7_w(i).eq.6667) then
     mkt7_w(i)=7 
    else if (mkt7_w(i).eq.6668) then
     mkt7_w(i)=8 
    else if (mkt7_w(i).eq.6669) then
     mkt7_w(i)=9 
    else if (mkt7_w(i).eq.66610) then
     mkt7_w(i)=10 
    else if (mkt7_w(i).eq.66612) then
     mkt7_w(i)=11 
    else if (mkt7_w(i).eq.66613) then
     mkt7_w(i)=12 
    else if (mkt7_w(i).eq.66614) then
     mkt7_w(i)=13 
    else if (mkt7_w(i).eq.66615) then
     mkt7_w(i)=14 
    else if (mkt7_w(i).eq.66616) then
     mkt7_w(i)=15 
    else if (mkt7_w(i).eq.66617) then
     mkt7_w(i)=16 
    else if (mkt7_w(i).eq.66618) then
     mkt7_w(i)=17 
    else if (mkt7_w(i).eq.66619) then
     mkt7_w(i)=18 
   end if
end do




!MKT_CHAR
open(unit=16,file='./mkt_char5.csv')
    do i=1,n_mktvd
       read(16,*) mkt7(i),  size_mkt7(i), educ_mkt7(i),   sdeduc_mkt7(i), blue_mkt7(i),mincome_mkt7(i), sdminc_mkt7(i), fona_mkt7(i), fonb_mkt7(i), fonc_mkt7(i),&
                 & fond_mkt7(i),isapre_mkt7(i), chilesol_mkt7(i), rural_mkt7(i), unempl_mkt7(i), nowork_mkt7(i), nsub_mkt7(i), r_13(i), r_15(i), Norte(i),&
                 & Central(i), Sur(i), numM(i), numV(i), numU(i),Drural_mkt7(i), Dchilsol_mkt7(i),studM_mkt7(i),studV_mkt7(i),sharestudV_mkt7(i), teachM_mkt7(i),&
                 & imp_teachV_mkt7(1,i),imp_teachV_mkt7(2,i),imp_teachV_mkt7(3,i),imp_teachV_mkt7(4,i),imp_teachV_mkt7(5,i),imp_teachV_mkt7(6,i),imp_teachV_mkt7(7,i), &
                 & imp_teachV_mkt7(8,i),imp_teachV_mkt7(9,i),imp_teachV_mkt7(10,i),imp_shareteachV_mkt7(1,i),imp_shareteachV_mkt7(2,i),imp_shareteachV_mkt7(3,i),&
                 & imp_shareteachV_mkt7(4,i),imp_shareteachV_mkt7(5,i),imp_shareteachV_mkt7(6,i),imp_shareteachV_mkt7(7,i),imp_shareteachV_mkt7(8,i),&
                 & imp_shareteachV_mkt7(9,i),imp_shareteachV_mkt7(10,i), imp_studteachV(1,i),imp_studteachV(2,i),imp_studteachV(3,i),imp_studteachV(4,i),imp_studteachV(5,i),&
                 & imp_studteachV(6,i),imp_studteachV(7,i),imp_studteachV(8,i),imp_studteachV(9,i),imp_studteachV(10,i), studteachM(i), mean_maxpv(i)
    end do  
close(16)



!Market level categories
!pvd_cat, educd_cat, mincomed_cat
do i=1,n_mkt
 !pvd_cat
 if(mean_maxpv(i)<=40000.0d0.AND.mean_maxpv(i)>=0.0d0) then
   pvd_cat(i)=1
 else if  (mean_maxpv(i)<=48000.0d0.AND.mean_maxpv(i)>40000.0d0) then
   pvd_cat(i)=2
 else if (mean_maxpv(i)<=53500.0d0.AND.mean_maxpv(i)>48000.0d0 ) then
   pvd_cat(i)=3
 else if (mean_maxpv(i)>53500.0d0) then
   pvd_cat(i)=4
 else
   pvd_cat(i)=-99
 end if
 
 !educd_cat
 if(educ_mkt7(i)<=8.60d0.AND.educ_mkt7(i)>=0.0d0) then
  educd_cat(i)=1
 else if (educ_mkt7(i)> 8.60d0.AND.educ_mkt7(i)<=9.30d0) then
  educd_cat(i)=2
 else if (educ_mkt7(i)>9.30d0.AND.educ_mkt7(i)<=10.10d0) then
  educd_cat(i)=3
 else if (educ_mkt7(i)>10.10d0) then
  educd_cat(i)=4
 else
  educd_cat(i)=-99
 end if
 
 !mincomed_cat
 if(mincome_mkt7(i)<=190000.0d0.AND.mincome_mkt7(i)>=0.0d0) then
  mincomed_cat(i)=1
 else if(mincome_mkt7(i)>190000.0d0.AND.mincome_mkt7(i)<=211358.0d0) then
  mincomed_cat(i)=2
 else if (mincome_mkt7(i)>211358.0d0.AND.mincome_mkt7(i)<=250000.0d0) then
  mincomed_cat(i)=3
 else if (mincome_mkt7(i)>250000.0d0) then
  mincomed_cat(i)=4
 else
  mincomed_cat(i)=-99
 end if
 
 !Dblue dummy
 if(blue_mkt7(i).le.0.6490d0) then
  Dblue_mkt7(i)=0
 else
  Dblue_mkt7(i)=1
 end if 
end do

                 
!All monetary variables (individual and market level) are in terms of 100k pesos

do i=1,n_mkt
  mincome_mkt7(i)=mincome_mkt7(i)/100000.0d0
  mean_maxpv(i)=mean_maxpv(i)/100000.0d0
end do
do i=1,n_mkt
 if(rural_mkt7(i)>=.22) then
  Drural_mkt7(i)=1.0d0
 else
  Drural_mkt7(i)=0.0d0
 end if
 if(chilesol_mkt7(i)>=0.0128) then
  Dchilsol_mkt7(i)=1.0d0
 else
  Dchilsol_mkt7(i)=0.0d0
 end if    
end do

CALL cpu_time (EndTime)
!write(*,*) "Time:", EndTime-StartTime
MidTime=EndTime







!###################################################################

!##### Read in final estimate of the parameters               ######

!###################################################################


gamma_step1=0.0d0
!gamma_parents=0.0d0

!First, read in gamma_step1: fixed.

open(unit=376,file='./gamma_step1_212_aug22')
read(376,*)

do i=1,212
   read(376,*) gamma_step1(i)
end do
close(unit=376)





 !*** draw N(0,1) shocks *************
  !Draw shocks of SIMCE parents

write(*,*) "Draw shocks"

    idum=7777
   call gasdev(idum,epsilon_pvec,3*n_s*D)
!********************************************




!########### Bump one gamma_step1 paramter at a time #######################



do i=1,212
 parameters(i)=gamma_step1(i)
end do

do bu=1,212

write(*,*) "bu=", bu

do s=0,Snum
write(*,*) "s=", s
     parameters(bu)=frac*gamma_step1(bu)+real(s)*(gamma_step1(bu)/real(Snum))*(2.0d0-2.0d0*frac)  
  



!Assign thetas using gamma_step1, one element of which has been bumped 


!Assign thetas of workers
do i=1,3
  theta(i)=parameters(i)
end do
do i=5,93
 theta(i)=parameters(i-1)
end do
do i=106,109
 theta(i)=parameters(i-13)
end do
 theta(194)=parameters(97)
do i=177, 193
 theta(i)=parameters(i-79)
end do
do i=287,304
 theta(i)=parameters(i-172)
end do





!Assign thetas of parents
do i=110, 120
 theta(i)=parameters(i+23)
end do
do i=123,128
 theta(i)=parameters(i+21)
end do
do i=155,157
 theta(i)=parameters(i-5)
end do
do i=162, 165
 theta(i)=parameters(i-9)
end do
 theta(169)=parameters(157)
 theta(171)=parameters(158)
 theta(195)=parameters(159)
do i=197,244
 theta(i)=parameters(i-37)
end do
 theta(247)=parameters(208)
do i=249,252
 theta(i)=parameters(i-40)
end do




!##############################################################################
!Create a matrix containing the original parameter vector, and one new vector where in each one only one parameter is bumped
!Notice: I only bump the workers' paramters. Loop over ALL gamma_step1, but if gamma_step1 is such that it is a parents' moment, skip 
!the calculation of the derivative




!#####################################################################################################################

!########################### Draw shocks by datasets and compute moments #############################################

!#####################################################################################################################
call simability_workers(noeval,zeroSM, zeroSV, awM, awV)




CALL cpu_time (StartTime)




 
do i=1,n_s
 do sim=1,D
  epsilon_p(1,i,sim)=exp(theta(156))*epsilon_pvec(i+(sim-1)*n_s)          !production of cogn ach in M
   
  epsilon_p(2,i,sim)=exp(theta(157))*epsilon_pvec(n_s*D+i+(sim-1)*n_s)  !production of cogn ach in V
  epsilon_p(3,i,sim)=exp(theta(155))*epsilon_pvec(2*n_s*D+i+(sim-1)*n_s)!preference for M
 end do 
end do




call  momi_matrix( epsilon_p,awM,awV,zeroSM,zeroSV, momi_parents)



do k=1,321
  do i=1,n_s
   mom_parents_mat(k,s)=mom_parents_mat(k,s)+ momi_parents(i,k)/real(n_s)
   
   end do
end do



end do !s

!Now calculated the derivative of the moment vector with respect to the current parameter (indexed by bu), using a higher order method for numerical derivative calculation 

do k=1,321
   Derivative_parents(k,bu)=(mom_parents_mat(k,0)-8.0*mom_parents_mat(k,1)+8.0*mom_parents_mat(k,3)-mom_parents_mat(k,4))/(12.0*h_bump)
end do


!Now reset the bumped parameter to its original value, so that in next iteration within do loop I am bumping only one parameter

write(*,*) "resetting bumped parameter", bu

!set parameters equal to its original value
parameters(bu)=gamma_step1(bu)




write(*,*) "done calculating derivative of all moments for element", bu
end do !bu



!write(*,*) "Derivative_parents", Derivative_parents

write(*,*) "Writing Derivative_parents to file, ROWS=moments, COLUMNS=parmaters"


open(unit=8675,file='./Derivative_parents85.txt')
do k=1,321
  do i=1,212
    write(8675,*) Derivative_parents(k,i)

  end do
end do

close(8675)

END PROGRAM Deriv_parents


