
subroutine momi_matrix( epsilon_p,awM,awV,zeroSM,zeroSV, momi_parents)

USE VarDef
USE Datasets
IMPLICIT NONE

!Ity uses finer categorization with 10 categories for minc per capita, minc and peduc



integer, intent(in)        :: zeroSM(n_mkt), zeroSV(n_mkt)
real(8), intent(in)        :: awM(n_mkt),awV(n_mkt)
real(8), intent(in)        ::  epsilon_p(3,n_s,D)  
real(8), intent(out)       ::  momi_parents(321,n_s)

integer                    :: i, stopping, k, kk, wtype, ctype, skiploop, idum, sim


!SIMCE categories
integer, dimension(n_s)    :: mincpercap_cat, peduc_cat, minc_cat, mtuition_cat, nfam_cat, mincpercapsq_cat   !mincome per capita
!category indeces
integer                    :: mincpc_c, mincpcsq_c, peduc_c, fem_c, unem_c, educd_c, blue_c, blued_c, minc_c, mincd_c, rural_c, central_c, pv_c,nfam_c, sec, primaria_c, mtuition_c

integer                    :: mkt, yp, peduc, yp2, prim, nfam, rur, y, centr


!individual level differences between actual and simulated
real(8)                    :: fracV(n_s), tsM(n_s), tsV(n_s), pVdiff(n_s), tssqV(n_s), tssqM(n_s), pVsqdiff(n_s)

real(8)                    ::  momi_simce(n_s,321)



!used by simulate_simce2
real(8)                    :: simcV_uncondSIMCE(n_s)
real(8)                    :: simcaM_uncondSIMCE(n_s), simcaV_uncondSIMCE(n_s),sim_apv_uncond(n_s)  !simulated cognitive achievement, simulated "accepted" cognit achiev in M, =0 of M not chosen
real(8)                    :: simcasqM_uncondSIMCE(n_s), simcasqV_uncondSIMCE(n_s), sim_sqapv_uncond(n_s)
integer                    :: noevalSIMCE

!counter
integer        :: counta, countaa, countb, countbb, countc, countcc, countd, countdd, counte, countee, countf, countff, countg, countgg, counth, counthh, counti, countii, countl, countm, &
                  & countn, counto, countp, countq, countr, counts, countt, countu
!Boundaries between moments

integer, parameter  :: capa=18, capb=118, capc=136, capd=236, cape=248, capf=258, capg=276, caph=294, capi=304, capl=314, capm=317, capn=319, capo=321  
        

!Dummies for cell
real(8)            :: Dm(n_s,18), Dypp(n_s,10,10),  Dprnr(n_s,0:1,3,0:1), Dy(n_s,10),  Dn(n_s,3),  Dp(n_s,0:1), Dr(n_s,0:1), Dyp(n_s,10), Dpeduc(n_s,10) ! Dyc(n_s,4,0:1), Drc(n_s,0:1,0:1) , 



integer   :: divide_SE

real(8)  :: merror_vec(n_s)  !measurement error on the fellowship

real(8)   :: avg_tsM, avg_tsV, denM, denV, simavg_tsM, simavg_tsV, simdenM, simdenV, simavg_tsVall, simavg_tsMall  !for diagnositc purposes
real(8)   :: simavg_tsM_actualV, simavg_tsV_actualM  !these ar ethe simulated accepted V and M est scores for those who in the real sata were instead in M and V respectively






!Initializations
 momi_simce=0.0d0 

!Initialize counters
!counta=0; countb=capa; countd=capb  ; counte=capd   ; countg=cape   ; counth=capg   ; counti=caph   ; countl=capi  ; countm=capl    ; countn=capm    ; counto=capn   
!countq=capo   ; countr=capq


!countaa=capa; countb=capaa; countbb=capb; countc=capbb; countcc=capc; countd=capcc; countdd=capd; counte=capdd; countee=cape; countf=capee; countff=capf; countg=capff; countgg=capg; counth=capgg
! counthh=caph; counti=caphh; countii=capi; countl=capii; countm=capl
! countn=capm; counto=capn; countp=capo; countq=capp; countr=capq

counta=0; countb=capa  ; countc=capb   ; countd=capc   ; counte=capd  ; countf=cape   ; countg=capf   ; counth=capg   ; counti=caph   ; countl=capi   ; countm=capl    ; countn=capm   ; counto=capn
countp=capo

!Initialize dummies
Dm=0.0d0; Dypp=0.0d0;  Dprnr=0.0d0; Dy=0.0d0;  Dn=0.0d0;  Dp=0.0d0; Dr=0.0d0; Dyp=0.0d0; Dpeduc=0.0d0










!####################################################################

!## GENERATE CATEGORIES #############################################

!####################################################################


do i=1,n_s

!mincome_100mila divided by family size
if(mincome_s(i)/dble(nfam_s(i)).le.0.15d0) then
  mincpercap_cat(i)=1
else if (mincome_s(i)/dble(nfam_s(i)).gt.0.15d0.AND.mincome_s(i)/dble(nfam_s(i)).le.0.25d0) then
 mincpercap_cat(i)=2  
else if (mincome_s(i)/dble(nfam_s(i)).gt.0.25d0.AND.mincome_s(i)/dble(nfam_s(i)).le.0.36d0) then
 mincpercap_cat(i)=3 
else if (mincome_s(i)/dble(nfam_s(i)).gt.0.360d0.AND.mincome_s(i)/dble(nfam_s(i)).le.0.45d0) then
 mincpercap_cat(i)=4
else if (mincome_s(i)/dble(nfam_s(i)).gt.0.450d0.AND.mincome_s(i)/dble(nfam_s(i)).le.0.50d0) then
 mincpercap_cat(i)=5

else if (mincome_s(i)/dble(nfam_s(i)).gt.0.500d0.AND.mincome_s(i)/dble(nfam_s(i)).le.0.70d0) then
 mincpercap_cat(i)=6

else if (mincome_s(i)/dble(nfam_s(i)).gt.0.700d0.AND.mincome_s(i)/dble(nfam_s(i)).le.0.840d0) then
 mincpercap_cat(i)=7

else if (mincome_s(i)/dble(nfam_s(i)).gt.0.840d0.AND.mincome_s(i)/dble(nfam_s(i)).le.1.130d0) then
 mincpercap_cat(i)=8

else if (mincome_s(i)/dble(nfam_s(i)).gt.1.130d0.AND.mincome_s(i)/dble(nfam_s(i)).le.1.750d0) then
 mincpercap_cat(i)=9

else if (mincome_s(i)/dble(nfam_s(i)).gt.1.750d0) then
 mincpercap_cat(i)=10

end if


!mincome per capita squared
if((mincome_s(i)/dble(nfam_s(i)))**2.0d0.le.0.127551d0) then
  mincpercapsq_cat(i)=1
else if ((mincome_s(i)/dble(nfam_s(i)))**2.0d0.gt.0.127551d0.AND.(mincome_s(i)/dble(nfam_s(i)))**2.0d0.le.0.250d0) then
 mincpercapsq_cat(i)=2  
else if ((mincome_s(i)/dble(nfam_s(i)))**2.0d0.gt.0.250d0.AND.(mincome_s(i)/dble(nfam_s(i)))**2.0d0.le.1.2656250d0) then
 mincpercapsq_cat(i)=3 
else if ((mincome_s(i)/dble(nfam_s(i)))**2.0d0.gt.1.2656250d0) then
 mincpercapsq_cat(i)=4
end if




!peduc_h
if( peduc_s(i).le.6.50d0) then
 peduc_cat(i)=1
else if (peduc_s(i).gt.6.50d0.AND.peduc_s(i).le.8.0d0) then
 peduc_cat(i)=2
else if (peduc_s(i).gt.8.00d0.AND.peduc_s(i).le.9.50d0) then
 peduc_cat(i)=3
else if (peduc_s(i).gt.9.50d0.AND.peduc_s(i).le.10.50d0) then
 peduc_cat(i)=4

else if (peduc_s(i).gt.10.50d0.AND.peduc_s(i).le.11.50d0) then
 peduc_cat(i)=5

else if (peduc_s(i).gt.11.50d0.AND.peduc_s(i).le.12.00d0) then
 peduc_cat(i)=6

else if (peduc_s(i).gt.12.00d0.AND.peduc_s(i).le.12.50d0) then
 peduc_cat(i)=7

else if (peduc_s(i).gt.12.50d0.AND.peduc_s(i).le.13.00d0) then
 peduc_cat(i)=8

else if (peduc_s(i).gt.13.00d0.AND.peduc_s(i).le.14.0d0) then
 peduc_cat(i)=9

else if (peduc_s(i).gt.14.00d0) then
 peduc_cat(i)=10

end if

!mincome_h
if(mincome_s(i).le.0.50d0) then
 minc_cat(i)=1

else if (mincome_s(i).gt.0.50d0.AND.mincome_s(i).le.1.50d0) then
 minc_cat(i)=2

else if (mincome_s(i).gt.1.50d0.AND.mincome_s(i).le.2.50d0) then
 minc_cat(i)=3

else if (mincome_s(i).gt.2.50d0.AND.mincome_s(i).le.3.50d0) then
 minc_cat(i)=4

else if (mincome_s(i).gt.3.50d0.AND.mincome_s(i).le.4.50d0) then
 minc_cat(i)=5

else if (mincome_s(i).gt.4.50d0.AND.mincome_s(i).le.5.50d0) then
 minc_cat(i)=6

else if (mincome_s(i).gt.5.50d0.AND.mincome_s(i).le.7.00d0) then
 minc_cat(i)=7

else if (mincome_s(i).gt.7.00d0.AND.mincome_s(i).le.9.00d0) then
 minc_cat(i)=8

else if (mincome_s(i).gt.9.00d0.AND.mincome_s(i).le.11.00d0) then
 minc_cat(i)=9

else if (mincome_s(i).gt.11.0d0) then
 minc_cat(i)=10

end if

!pv_h = pV-fellowship (where pv=price nett of voucher)
if(mean_maxpv(mkt7_s(i)).ge.0.0d0.AND.mean_maxpv(mkt7_s(i)).le.0.40d0) then
 mtuition_cat(i)=1
else if (mean_maxpv(mkt7_s(i)).gt.0.40d0.AND.mean_maxpv(mkt7_s(i)).le.0.48d0) then
 mtuition_cat(i)=2
else if (mean_maxpv(mkt7_s(i)).gt.0.48d0.AND.mean_maxpv(mkt7_s(i)).le.0.535) then  
  mtuition_cat(i)=3
else if (mean_maxpv(mkt7_s(i)).gt.0.535) then
 mtuition_cat(i)=4
end if   

!nfam_cat
if(nfam_s(i).le.3) then
 nfam_cat(i)=1
else if (nfam_s(i).gt.3.AND.nfam_s(i).le.6) then
 nfam_cat(i)=2
 else if (nfam_s(i).gt.6) then
 nfam_cat(i)=3
end if  
 
end do


!###########################################################################

! ## Create dummies for whether person belongs to a certain cell or not   ###

!###########################################################################

		do i=1,n_s
		
	 	  do mkt=1,n_mkt
                   if(mkt7_s(i).eq.mkt) then
                     Dm(i,mkt)=1.0d0
                   end if
		  end do

		  do yp=1,10
		   do peduc=1,10
		    if(mincpercap_cat(i).eq.yp.AND.peduc_cat(i).eq.peduc) then
                    Dypp(i,yp,peduc)=1.0d0
                  end if
		   end do
		  end do

	

		do prim=0,1
		 do nfam=1,3
		  do rur=0,1
		   if(primaria_s(i).eq.1.AND.nfam_cat(i).eq.nfam.AND.rural_s(i).eq.1) then
 		      Dprnr(i,prim,nfam,rur)=1.0d0
	          end if
		  end do
		 end do
	       end do



	       do y=1,10
	         if(minc_cat(i).eq.y) then
	            Dy(i,y)=1.0d0
	         end if
		end do

		do nfam=1,3
		 if(nfam_cat(i).eq.nfam) then
		   Dn(i,nfam)=1.0d0
		  end if
		end do

		do prim=0,1
		 if(primaria_s(i).eq.1) then
		   Dp(i,prim)=1.0d0
		 end if
	       end do

	      do rur=0,1
		!do centr=0,1
		 if(rural_s(i).eq.rur) then
		   Dr(i,rur)=1.0d0
		  end if
		!end do
	      end do



          do yp=1,10
           if(mincpercap_cat(i).eq.yp) then
             Dyp(i,yp)=1.0d0
           end if
   
          end do

          do peduc=1,10
          if(peduc_cat(i).eq.peduc) then
            Dpeduc(i,peduc)=1.0d0
          end if

           end do


	end do !i







!#####################################################################

!## INDIVIDUAL LEVEL MOMENTS ##########################################

!######################################################################

call simulate_simce2(zeroSM, zeroSV, awM,awV,epsilon_p, simcV_uncondSIMCE,simcaM_uncondSIMCE,simcaV_uncondSIMCE,sim_apv_uncond , simcasqM_uncondSIMCE, simcasqV_uncondSIMCE, sim_sqapv_uncond, noevalSIMCE )

if(noevalSIMCE.eq.1) then

write(*,*) "noevalSIMCE=1, which means that BOTH  zeroSM and zeroSV are equal to 1"

else


!compute individual level differences, (fracV and test scores times dummy), and then compute moments

!Draw measurement errors on fellowship

!write(*,*) "Drawing shokcs"
idum=7779
!write(*,*) "Calling gasdev"
merror_vec=0.0d0
call gasdev(idum,merror_vec,n_s)
!write(*,*) "called gasdev"

do i=1,n_s
  merror_vec(i)=exp(theta(233))*merror_vec(i)   
end do




do i=1,n_s


   
   fracV(i)=(simcV_uncondSIMCE(i)-dble(v_s(i)))



   tsM(i)=simcaM_uncondSIMCE(i)-  standability_s(i)*dble(m_s(i))
   tsV(i)=simcaV_uncondSIMCE(i)-  standability_s(i)*dble(v_s(i))
   tssqM(i)=simcasqM_uncondSIMCE(i)-(standability_s(i)**2.0d0)*dble(m_s(i))
   tssqV(i)=simcasqV_uncondSIMCE(i)-( standability_s(i) **2.0d0)*dble(v_s(i))


 if(mtuition_s(i).ne.-99.0d0) then
   ! pVdiff(i)=sim_apv_uncond(i)*dble(v_s(i))-( mtuition_s(i)-merror_vec(i)  )*dble(v_s(i))
   ! pVsqdiff(i)=sim_sqapv_uncond(i)*dble(v_s(i))-(  (mtuition_s(i) -merror_vec(i)  )**2.0d0)*dble(v_s(i))

    pVdiff(i)=sim_apv_uncond(i)-( mtuition_s(i)-merror_vec(i)  )*dble(v_s(i))
    pVsqdiff(i)=sim_sqapv_uncond(i)-(  (mtuition_s(i) -merror_vec(i)  )**2.0d0)*dble(v_s(i))

 else
    pVdiff(i)=0.0d0
    pVsqdiff(i)=0.0d0
 end if





end do



end if !noevalSIMCE


!###############################################################

!## Fill in moment vector #####################################

!##############################################################

!tsM       mkt         18   a

!tsM       mpc peduc   25   b



!tsV       mkt         18   d

!tsV       mpc peduc   25   e



!pV     prim nfam rur   12  g

!pV     minc       5   h

!pV     mkt             18  i


!fracV  mkt             18  l
!fracV  peduc       5  m
!fracV  minc            5   n
!fracV  nfam            3   o

!fracV  primaria        2   q
!fracV  rur        2   r
!tot=156

!add squared test scores NO!!!
!tsMsq mkt 18
!tsM sq mpc 10
!tsMsq peduc 10
!tsVsq mkt 18
!tsVsq mpc 10
!tsVsq peduc 10
!tot=487





!I've already initialized the counters (remember to move counters here when computing derivative of moment vector)

divide_SE=1  


!tsM by mkt counta
do mkt=1,n_mkt
 counta=counta+1
  do i=1,n_s
    momi_simce(i,counta)=Dm(i,mkt)*tsM(i)
    if(divide_SE.eq.1) then
        momi_simce(i,counta)=Dm(i,mkt)*tsM(i)/.9954727
    end if
  end do
end do




!tsM by mpc and peduc 12 b
do yp=1,10
 do peduc=1,10
  countb=countb+1
   do i=1,n_s
      momi_simce(i,countb)=Dypp(i,yp,peduc)*tsM(i)
    if(divide_SE.eq.1) then
      momi_simce(i,countb)=Dypp(i,yp,peduc)*tsM(i)/.9954727
    end if
  end do
 end do
end do







!tsV by mkt countd
do mkt=1,n_mkt
 countc=countc+1
  do i=1,n_s
    momi_simce(i,countc)=Dm(i,mkt)*tsV(i)
    if(divide_SE.eq.1) then
        momi_simce(i,countc)=Dm(i,mkt)*tsV(i)/.969985
    end if
  end do
end do





!tsV by mpc and peduc 12 e
do yp=1,10
 do peduc=1,10
  countd=countd+1
   do i=1,n_s
      momi_simce(i,countd)=Dypp(i,yp,peduc)*tsV(i)
    if(divide_SE.eq.1) then
      momi_simce(i,countd)=Dypp(i,yp,peduc)*tsV(i)/.969985
    end if
  end do
 end do
end do






!pV prim nfam rur 12 g
do prim=0,1
 do nfam=1,3
  do rur=0,1
  counte=counte+1
    do i=1,n_s
      momi_simce(i,counte)=Dprnr(i,prim,nfam,rur)*pVdiff(i)
    if(divide_SE.eq.1) then
      momi_simce(i,counte)=Dprnr(i,prim,nfam,rur)*pVdiff(i)/3.30647
    end if

   end do !i
  end do
 end do
end do





!pV minc  h
do y=1,10
   countf=countf+1
    do i=1,n_s
     momi_simce(i,countf)=Dy(i,y)*pVdiff(i)    
    if(divide_SE.eq.1) then
      momi_simce(i,countf)=Dy(i,y)*pVdiff(i)/3.30647
    end if
   end do !i
end do





!pV mkt i
do mkt=1,n_mkt
  countg=countg+1
  do i=1,n_s
   momi_simce(i,countg)=Dm(i,mkt)*pVdiff(i)
   if(divide_SE.eq.1) then
      momi_simce(i,countg)=Dm(i,mkt)*pVdiff(i)/3.30647
    end if
 end do !i
end do !m






!fracV mkt l
do mkt=1,n_mkt
  counth=counth+1
   do i=1,n_s
    momi_simce(i,counth)=Dm(i,mkt)*fracV(i)

    if(divide_SE.eq.1) then
      momi_simce(i,counth)=Dm(i,mkt)*fracV(i)/.4987428
     end if
   end do !i
end do

!fracV by mpc and peduc 12 m
!do yp=1,10
 do peduc=1,10
  counti=counti+1
   do i=1,n_s
      momi_simce(i,counti)=Dpeduc(i,peduc)*fracV(i)
    if(divide_SE.eq.1) then
      momi_simce(i,counti)=Dpeduc(i,peduc)*fracV(i)/.4987428
    end if
  end do
 end do
!end do






!fraV by mincome n
do y=1,10
  countl=countl+1
   do i=1,n_s
    momi_simce(i,countl)=Dy(i,y)*fracV(i)
    if(divide_SE.eq.1) then
    momi_simce(i,countl)=Dy(i,y)*fracV(i)/.4987428
    end if
   end do


end do







!fracV by nfam o

do nfam=1,3
   countm=countm+1
   do i=1,n_s
   momi_simce(i,countm)=Dn(i,nfam)*fracV(i)
    if(divide_SE.eq.1) then
   momi_simce(i,countm)=Dn(i,nfam)*fracV(i)/.4987428
    end if
   end do


end do





!frac V by primaria q
do prim=0,1
  countn=countn+1
  do i=1,n_s
   momi_simce(i,countn)=Dp(i,prim)*fracV(i)
    if(divide_SE.eq.1) then  
   momi_simce(i,countn)=Dp(i,prim)*fracV(i)/.4987428

    end if
   end do

end do




!fracV by rural   r

do rur=0,1

   counto=counto+1
   do i=1,n_s
    momi_simce(i,counto)=Dr(i,rur)*fracV(i)
    if(divide_SE.eq.1) then
    momi_simce(i,counto)=Dr(i,rur)*fracV(i)/.4987428
    end if
   end do !i


end do



!momi_parents obtained by ivnerting rows and columns in momi_simce



 do i=1,n_s
   do k=1,321
     momi_parents(k,i)=momi_simce(i,k)
   end do
 end do



END subroutine momi_matrix