
program Main_March
USE VarDef
USE Datasets


IMPLICIT NONE

!####################### VARIABLE DECLARATION ########################


real(8)        :: gamma_step1(212), npar, gamma_workers(132) !number of parameters plus 17 rental rates to estimate
character(150) :: inputname, outputname, tag
character(61)  :: path
integer        :: i, stopping, k, kk, wtype, ctype, skiploop, idum, mkt, sim_cost, iter, iter_r, iter_pv,docalib, docalibprof, apps, noeval, sim

real(8)        ::  epsilon_w(4,n_w,D), epsilon_wvec(4*n_w*D)
!real(8)        :: epsilon_p(3,n_cp,D) 



integer        :: zeroSM(n_mkt), zeroSV(n_mkt), weighting

integer      :: matchwage, matchsquare, matchfrac, matchELD
integer      :: matchfrac_casenw






!used to compute avg ability of teahcers, needed to match parents' moments, ie read in by mom_simce and mom_casenp
real(8)        :: sumweight_wM(n_mkt), sumweight_wV(n_mkt), awM(n_mkt), awV(n_mkt)
!moments: outputs of mom_* subroutines
real(8)        ::  momvec_simce(2602)   !momvec_simce(498)
real(8)        :: momvec_casenp(510)
real(8)        :: momvec_workers(286)

!weighting matrices
real(8)       :: W_WORKERS(286,286)
!objective function
real(8)        :: objf_I


integer        :: highab !a signal = 1 if ability of teachers too high at that parameter value


!Relative to the objective function: weighting matrix
real(8)   :: MpWWORKERS(286)





CALL cpu_time (BeginningTime)



!###################################################################

!##### Read in input parameters and assign thetas using gamma ######

!###################################################################


gamma_step1=0.0d0
gamma_workers=0.0d0

!First, read in gamma_step1: fixed.

open(unit=376,file='./gamma_step1_212_aug22')
read(376,*)

do i=1,212
   read(376,*) gamma_step1(i)
end do
close(unit=376)




!Assign thetas
do i=1,3
  theta(i)=gamma_step1(i)
end do
do i=5,93
 theta(i)=gamma_step1(i-1)
end do
do i=106,109
 theta(i)=gamma_step1(i-13)
end do
 theta(194)=gamma_step1(97)
do i=177, 193
 theta(i)=gamma_step1(i-79)
end do
do i=287,304
 theta(i)=gamma_step1(i-172)
end do





!#######################################################

!############## Read in datasets #######################

!######################################################



!WORKERS UNIQUE
open(unit=13,file='./workers_unique.txt') !a dot between final and trim indicates that this is the dataset with the corrected weights (corrected using idoneidad and fraction teaching obtained in original casen, before imputation)
    do i=1,n_w
       read(13,*) id_w(1,i), id_w(2,i), mkt7_w(i), graddeg_w(i), perfec_w(i), nkids_w(i), nkids2_w(i), nkids6_w(i), age_w(i), fem_w(i), &
       & peduc_w(i), m_w(i), v_w(i), nt_w(i), h_w(i),wage_w(i)
    end do
close(13)



     
do i=1,n_w
   wage_w(i)=wage_w(i)/100000.0d0
end do

do i=1,n_w

   age_w(i)=age_w(i)-19

   if(mkt7_w(i).eq.6661) then
     mkt7_w(i)=1
    else if (mkt7_w(i).eq.6662) then
     mkt7_w(i)=2 
    else if (mkt7_w(i).eq.6663) then
     mkt7_w(i)=3 
    else if (mkt7_w(i).eq.6664) then
     mkt7_w(i)=4 
    else if (mkt7_w(i).eq.6665) then
     mkt7_w(i)=5 
    else if (mkt7_w(i).eq.6666) then
     mkt7_w(i)=6 
    else if (mkt7_w(i).eq.6667) then
     mkt7_w(i)=7 
    else if (mkt7_w(i).eq.6668) then
     mkt7_w(i)=8 
    else if (mkt7_w(i).eq.6669) then
     mkt7_w(i)=9 
    else if (mkt7_w(i).eq.66610) then
     mkt7_w(i)=10 
    else if (mkt7_w(i).eq.66612) then
     mkt7_w(i)=11 
    else if (mkt7_w(i).eq.66613) then
     mkt7_w(i)=12 
    else if (mkt7_w(i).eq.66614) then
     mkt7_w(i)=13 
    else if (mkt7_w(i).eq.66615) then
     mkt7_w(i)=14 
    else if (mkt7_w(i).eq.66616) then
     mkt7_w(i)=15 
    else if (mkt7_w(i).eq.66617) then
     mkt7_w(i)=16 
    else if (mkt7_w(i).eq.66618) then
     mkt7_w(i)=17 
    else if (mkt7_w(i).eq.66619) then
     mkt7_w(i)=18 
   end if
end do




!MKT_CHAR
open(unit=16,file='./mkt_char5.csv')
    do i=1,n_mktvd
       read(16,*) mkt7(i),  size_mkt7(i), educ_mkt7(i),   sdeduc_mkt7(i), blue_mkt7(i),mincome_mkt7(i), sdminc_mkt7(i), fona_mkt7(i), fonb_mkt7(i), fonc_mkt7(i),&
                 & fond_mkt7(i),isapre_mkt7(i), chilesol_mkt7(i), rural_mkt7(i), unempl_mkt7(i), nowork_mkt7(i), nsub_mkt7(i), r_13(i), r_15(i), Norte(i),&
                 & Central(i), Sur(i), numM(i), numV(i), numU(i),Drural_mkt7(i), Dchilsol_mkt7(i),studM_mkt7(i),studV_mkt7(i),sharestudV_mkt7(i), teachM_mkt7(i),&
                 & imp_teachV_mkt7(1,i),imp_teachV_mkt7(2,i),imp_teachV_mkt7(3,i),imp_teachV_mkt7(4,i),imp_teachV_mkt7(5,i),imp_teachV_mkt7(6,i),imp_teachV_mkt7(7,i), &
                 & imp_teachV_mkt7(8,i),imp_teachV_mkt7(9,i),imp_teachV_mkt7(10,i),imp_shareteachV_mkt7(1,i),imp_shareteachV_mkt7(2,i),imp_shareteachV_mkt7(3,i),&
                 & imp_shareteachV_mkt7(4,i),imp_shareteachV_mkt7(5,i),imp_shareteachV_mkt7(6,i),imp_shareteachV_mkt7(7,i),imp_shareteachV_mkt7(8,i),&
                 & imp_shareteachV_mkt7(9,i),imp_shareteachV_mkt7(10,i), imp_studteachV(1,i),imp_studteachV(2,i),imp_studteachV(3,i),imp_studteachV(4,i),imp_studteachV(5,i),&
                 & imp_studteachV(6,i),imp_studteachV(7,i),imp_studteachV(8,i),imp_studteachV(9,i),imp_studteachV(10,i), studteachM(i), mean_maxpv(i)
    end do  
close(16)

!Market level categories
!pvd_cat, educd_cat, mincomed_cat
do i=1,n_mkt
 !pvd_cat
 if(mean_maxpv(i)<=40000.0d0.AND.mean_maxpv(i)>=0.0d0) then
   pvd_cat(i)=1
 else if  (mean_maxpv(i)<=48000.0d0.AND.mean_maxpv(i)>40000.0d0) then
   pvd_cat(i)=2
 else if (mean_maxpv(i)<=53500.0d0.AND.mean_maxpv(i)>48000.0d0 ) then
   pvd_cat(i)=3
 else if (mean_maxpv(i)>53500.0d0) then
   pvd_cat(i)=4
 else
   pvd_cat(i)=-99
 end if
 
 !educd_cat
 if(educ_mkt7(i)<=8.60d0.AND.educ_mkt7(i)>=0.0d0) then
  educd_cat(i)=1
 else if (educ_mkt7(i)> 8.60d0.AND.educ_mkt7(i)<=9.30d0) then
  educd_cat(i)=2
 else if (educ_mkt7(i)>9.30d0.AND.educ_mkt7(i)<=10.10d0) then
  educd_cat(i)=3
 else if (educ_mkt7(i)>10.10d0) then
  educd_cat(i)=4
 else
  educd_cat(i)=-99
 end if
 
 !mincomed_cat
 if(mincome_mkt7(i)<=190000.0d0.AND.mincome_mkt7(i)>=0.0d0) then
  mincomed_cat(i)=1
 else if(mincome_mkt7(i)>190000.0d0.AND.mincome_mkt7(i)<=211358.0d0) then
  mincomed_cat(i)=2
 else if (mincome_mkt7(i)>211358.0d0.AND.mincome_mkt7(i)<=250000.0d0) then
  mincomed_cat(i)=3
 else if (mincome_mkt7(i)>250000.0d0) then
  mincomed_cat(i)=4
 else
  mincomed_cat(i)=-99
 end if
 
 !Dblue dummy
 if(blue_mkt7(i).le.0.6490d0) then
  Dblue_mkt7(i)=0
 else
  Dblue_mkt7(i)=1
 end if 
end do

                 
!All monetary variables (individual and market level) are in terms of 100mila pesos
!-->> change all mkt level variables used in the model in terms of 100mila pesos (notice: standad deviation is in terms of pesos
!and not 100mila pesos, but it is not used anymore)
do i=1,n_mkt
  mincome_mkt7(i)=mincome_mkt7(i)/100000.0d0
  mean_maxpv(i)=mean_maxpv(i)/100000.0d0
end do
do i=1,n_mkt
 if(rural_mkt7(i)>=.22) then
  Drural_mkt7(i)=1.0d0
 else
  Drural_mkt7(i)=0.0d0
 end if
 if(chilesol_mkt7(i)>=0.0128) then
  Dchilsol_mkt7(i)=1.0d0
 else
  Dchilsol_mkt7(i)=0.0d0
 end if    
end do

CALL cpu_time (EndTime)
!write(*,*) "Time:", EndTime-StartTime
MidTime=EndTime



!#####################################################################################################################

!########################### Draw shocks by datasets and compute moments #############################################

!#####################################################################################################################


CALL cpu_time (StartTime)


!Draw epsilon_w i.e. the worker's shocks

! Draw D draws for every worker, and shock type
idum=3333
call gasdev(idum,epsilon_wvec,4*n_w*D)

do i=1,n_w
 do sim=1,D
  epsilon_w(1,i,sim)=exp(theta(106))*epsilon_wvec(i+(sim-1)*n_w)        !preference for Home
  epsilon_w(2,i,sim)=exp(theta(107))*epsilon_wvec(n_w*D+i+(sim-1)*n_w)   !shock in M wage
  epsilon_w(3,i,sim)=exp(theta(108))*epsilon_wvec(2*n_w*D+i+(sim-1)*n_w) !shock in V wage
  epsilon_w(4,i,sim)=exp(theta(109))*epsilon_wvec(3*n_w*D+i+(sim-1)*n_w) !shock in NT wage
  
 end do
end do  




  call compute_variance( epsilon_w)


   





end program Main_March