subroutine compute_variance( epsilon_w)

USE VarDef
USE Datasets
IMPLICIT NONE



real(8),intent(in)  ::  epsilon_w(4,n_w,D)
real(8)             :: momvec_workers(286)

real(8)  :: TOTweightsNT_w


real(8)  :: momi_workers(n_w,286) !contains individual level moments

!categories
integer, dimension(n_w)   :: sec_cw, age_cat,peduc_cat, nkids_cat, nkids2_cat, nkids36_cat, fine_age

!spit out by simulate workers
real(8)  :: sM(n_w), sV(n_w), sNT(n_w),  sH(n_w)
real(8)  ::  swageM(n_w), swageV(n_w), swageNT(n_w)
real(8)  ::  swagesqM(n_w), swagesqV(n_w), swagesqNT(n_w)

!Indeces for whether individual belongs to a cell
real(8)  :: Dafp(n_w,4,0:1,0:1), Dafg(n_w,4,0:1,0:1), Dm(n_w,18), Dfn(n_w,0:1,0:3) , Dg(n_w,0:1), Dp(n_w,0:1), Dn2a(n_w,0:1,4), Dn36(n_w,0:1), Dfineage(n_w,8)


integer :: sim, i, k, kk

!borders between moments in the var cov matrix
!borders that guarnatee that matrix is invertible
!borders between moments in the var cov matrix
integer, parameter  :: capa=16, capb=32, capc=48, capd=50, cape=52,  capf=54, capg=72, caph=90, capi=108,  capl=110, capm=112, capn=114, capo=130,  capp=146,&
          & capq=162,  capr=180, caps=198, capt=216, capu=224, capv=232, capz=240, capa2=248, &
           & capb2=256, capc2=264, capd2=266, cape2=268, capf2=270, capg2=278, caph2=286


!counters for the rows and columns of the variance covariance matrix
integer   :: counta, countb, countc, countd,  counte,  countf, countg,  counth,  counti,  countl, countm, countn, &
              & counto, countp, countq, countr, counts, countt, countu, countv, countz, counta2, countb2, countc2, countd2, counte2, countf2, countg2, counth2

!to loop through categories
integer  :: age_c, fem_c, perfec_c, grad_c, mkt, nkids_c, nkids2_c, nkids36_c

!individual moment conditions
real(8), dimension(n_w)  ::      wageNT_mom, wagesqNT_mom, fracNT_mom, fracV_mom, fracM_mom, wageM_mom, wagesqM_mom, wageV_mom, wagesqV_mom

!switch that divides by standard error from data
integer  :: divide_SE

real(8)   :: Totweight

integer :: diagonal
real(8) :: Var_workers(286,286), inverse, inverseworkers(286,286) ! outerproduct(n_w,286,286), 



!Initializations

momi_workers=0.0d0; momvec_workers=0.0d0

Totweight=0.0d0


Dafp=0.0d0; Dafg=0.0d0; Dm=0.0d0; Dfn=0.0d0; Dg=0.0d0; Dp=0.0d0;  Dn2a=0.0d0; Dn36=0.0d0; Dfineage=0.0d0

counta=0; countb=capa; countc=capb ; countd=capc ;  counte=capd ;  countf=cape ; countg=capf ;  counth=capg ;  counti=caph ;  countl=capi ; countm=capl ; countn=capm 
counto=capn ; countp=capo ; countq=capp ; countr=capq ; counts=capr ; countt=caps ; countu=capt ; countv=capu ; countz=capv ; counta2=capz ; countb2=capa2 ; countc2=capb2 
countd2=capc2 ; counte2=capd2 ; countf2=cape2 ; countg2=capf2; counth2=capg2


 

!#####################################################

!##### Assign categories ############################

!#####################################################

do i=1,n_w

Totweight=Totweight+id_w(2,i)

!sector category
 !age category
   if(age_w(i)+19.le.30.0d0) then
    age_cat(i)=1
   else if (age_w(i)+19.gt.30.0d0.AND.age_w(i)+19.le.40.0d0) then
    age_cat(i)=2 
   else if (age_w(i)+19.gt.40.0d0.AND.age_w(i)+19.le.50.0d0) then
    age_cat(i)=3
   else if (age_w(i)+19.gt.50) then
    age_cat(i)=4
   end if      

 !fine age category
   if(age_w(i)+19.le.31) then
     fine_age(i)=1
   else if (age_w(i)+19.gt.31.AND.age_w(i)+19.le.36) then
     fine_age(i)=2
   else if (age_w(i)+19.gt.36.AND.age_w(i)+19.le.39) then
     fine_age(i)=3
   else if (age_w(i)+19.gt.39.AND.age_w(i)+19.le.45) then
     fine_age(i)=4
   else if (age_w(i)+19.gt.45.AND.age_w(i)+19.le.48) then
     fine_age(i)=5
   else if (age_w(i)+19.gt.48.AND.age_w(i)+19.le.52) then
    fine_age(i)=6
   else if (age_w(i)+19.gt.52.AND.age_w(i)+19.le.56) then
    fine_age(i)=7
   else if (age_w(i)+19.gt.56) then
     fine_age(i)=8
   end if


  !peduc category
   if(peduc_w(i)<=8.0d0 ) then
    peduc_cat(i)=1
   else if (peduc_w(i)>8.0d0 .AND. peduc_w(i)<=12.0d0) then
    peduc_cat(i)=2
   else
    peduc_cat(i)=3
   end if  
   
   !nkids category
   if(nkids_w(i)<3.AND.nkids_w(i)>=0) then
    nkids_cat(i)=nkids_w(i)
   else if (nkids_w(i)>=3) then
   nkids_cat(i)=3
   else
   nkids_cat(i)=-99
   end if
   
   !nkids2 category
   if(nkids2_w(i).eq.0 ) then
   nkids2_cat(i)=0
   else if (nkids2_w(i)>0) then
   nkids2_cat(i)=1 
   else 
   nkids2_cat(i)=-99
   end if
   
   !nkids36 category
   if(nkids6_w(i)-nkids2_w(i).eq.0 ) then
   nkids36_cat(i)=0
   else if (nkids6_w(i)-nkids2_w(i)>0) then
   nkids36_cat(i)=1 
   else 
   nkids36_cat(i)=-99
   end if
   
   
end do





!##########################################################################################

!#### Create dummies for whether a person belongs to a certain cell or not ################

!##########################################################################################

do i=1,n_w

do age_c=1,4
 do fem_c=0,1
  do perfec_c=0,1
    if(age_cat(i).eq.age_c.AND.fem_w(i).eq.fem_c.AND.perfec_w(i).eq.perfec_c) then
      Dafp(i,age_c,fem_c,perfec_c)=1.0d0
    end if
  end do
 end do
end do

do age_c=1,8
  if(fine_age(i).eq.age_c) then
    Dfineage(i,age_c)=1.0d0
  end if
end do

do age_c=1,4
 do fem_c=0,1
  do grad_c=0,1
   if(age_cat(i).eq.age_c.AND.fem_w(i).eq.fem_c.AND.graddeg_w(i).eq.grad_c) then
     Dafg(i,age_c,fem_c,grad_c)=1.0d0
   end if

  end do
 end do
end do

do grad_c=0,1
  if(graddeg_w(i).eq.grad_c) then
    Dg(i,grad_c)=1.0d0
  end if
end do


do mkt=1,n_mkt
  if(mkt7_w(i).eq.mkt) then
     Dm(i,mkt)=1.0d0
  end if
end do

do perfec_c=0,1
  if(perfec_w(i).eq.perfec_c) then
    Dp(i,perfec_c)=1.0d0
  end if
end do


do fem_c=0,1
 do nkids_c=0,3
   if(fem_w(i).eq.fem_c.AND.nkids_cat(i).eq.nkids_c) then
    Dfn(i,fem_c,nkids_c)=1.0d0
   end if
 end do
end do


 do nkids2_c=0,1
  do age_c=1,4
    if(nkids2_cat(i).eq.nkids2_c.AND.age_cat(i).eq.age_c) then
      Dn2a(i,nkids2_c,age_c)=1.0d0
    end if
  end do
 end do

do nkids36_c=0,1
   if(nkids36_cat(i).eq.nkids36_c) then
     Dn36(i,nkids36_c)=1.0d0
  end if
end do




end do !i




!##########################################################

!### Individual level deviations between model and data #############################

!##########################################################

wageNT_mom=0.0d0
wagesqNT_mom=0.0d0
wageM_mom=0.0d0
wagesqM_mom=0.0d0
wageV_mom=0.0d0
wagesqV_mom=0.0d0

fracV_mom=0.0d0
fracNT_mom=0.0d0
!fracH_mom=0.0d0
fracM_mom=0.0d0

call simulate_workers( epsilon_w, sM,sV, sNT, sH, swageM, swageV, swageNT, swagesqM, swagesqV, swagesqNT  )


do i=1,n_w
 if(wage_w(i)>0.0d0) then
 wageNT_mom(i)=(  swageNT(i)-  wage_w(i)*dble(nt_w(i))  )*id_w(2,i)  
 wagesqNT_mom(i)=(   swagesqNT(i)-  dble(nt_w(i))*(wage_w(i)**2.0d0)  )*id_w(2,i)

 wageM_mom(i)=(  swageM(i)-  wage_w(i)*dble(m_w(i))  )*id_w(2,i)  
 wagesqM_mom(i)=(   swagesqM(i)-  dble(m_w(i))*(wage_w(i)**2.0d0)  )*id_w(2,i)

 wageV_mom(i)=(  swageV(i)-  wage_w(i)*dble(v_w(i))  )*id_w(2,i)  
 wagesqV_mom(i)=(   swagesqV(i)-  dble(v_w(i))*(wage_w(i)**2.0d0)  )*id_w(2,i)



 
 end if


 fracNT_mom(i)=(  sNT(i)-dble(nt_w(i))  )*id_w(2,i)
 fracM_mom(i)=(   sM(i)-dble(m_w(i))  )*id_w(2,i)
 fracV_mom(i)=(   sV(i)-dble(v_w(i))  )*id_w(2,i)

 
end do





!####################################################

!##### Fill in moment vector #######################

!##################################################



divide_SE=1

!wageM   age_c fem_c perfec_c 16 a
do age_c=1,4
 do fem_c=0,1
  do perfec_c=0,1
   counta=counta+1     
    do i=1,n_w
      momi_workers(i,counta)=Dafp(i,age_c,fem_c,perfec_c)*wageM_mom(i)
      if(divide_SE.eq.1) then
         momi_workers(i,counta)=Dafp(i,age_c,fem_c,perfec_c)*wageM_mom(i)/ 1.550827
      end if
        end do !i
  end do
 end do
end do

!wageV   age_c fem_c perfec_c 16 a
do age_c=1,4
 do fem_c=0,1
  do perfec_c=0,1
   countb=countb+1
    do i=1,n_w
      momi_workers(i,countb)=Dafp(i,age_c,fem_c,perfec_c)*wageV_mom(i)
      if(divide_SE.eq.1) then
         momi_workers(i,countb)=Dafp(i,age_c,fem_c,perfec_c)*wageV_mom(i)/ 1.25907
      end if
        end do !i
  end do
 end do
end do


!wageNT   age_c fem_c perfec_c 16 a
do age_c=1,4
 do fem_c=0,1
  do perfec_c=0,1
   countc=countc+1
    do i=1,n_w
      momi_workers(i,countc)=Dafp(i,age_c,fem_c,perfec_c)*wageNT_mom(i)
      if(divide_SE.eq.1) then
         momi_workers(i,countc)=Dafp(i,age_c,fem_c,perfec_c)*wageNT_mom(i)/ 5.354306
      end if
        end do !i
  end do
 end do
end do




!wageM   grad_c   2 b
  do grad_c=0,1
   countd=countd+1
    do i=1,n_w
      momi_workers(i,countd)=Dg(i,grad_c)*wageM_mom(i)
      if(divide_SE.eq.1) then
      momi_workers(i,countd)=Dg(i,grad_c)*wageM_mom(i)/ 1.550827
      end if
    end do !i
  end do

!wageM   grad_c   2 b
  do grad_c=0,1
   counte=counte+1
    do i=1,n_w
      momi_workers(i,counte)=Dg(i,grad_c)*wageV_mom(i)
      if(divide_SE.eq.1) then
      momi_workers(i,counte)=Dg(i,grad_c)*wageV_mom(i)/1.25907
      end if
    end do !i
  end do


!wageNT   grad_c   2 b
  do grad_c=0,1
   countf=countf+1
    do i=1,n_w
      momi_workers(i,countf)=Dg(i,grad_c)*wageNT_mom(i)
      if(divide_SE.eq.1) then
      momi_workers(i,countf)=Dg(i,grad_c)*wageNT_mom(i)/5.354306
      end if
    end do !i
  end do




!wageM   mkt                  18 c
do mkt=1,n_mkt
 countg=countg+1
  do i=1,n_w
    momi_workers(i,countg)=Dm(i,mkt)*wageM_mom(i)
      if(divide_SE.eq.1) then
        momi_workers(i,countg)=Dm(i,mkt)*wageM_mom(i)/1.550827
      end if
  end do
end do

!wageV   mkt                  18 c
do mkt=1,n_mkt
 counth=counth+1
  do i=1,n_w
    momi_workers(i,counth)=Dm(i,mkt)*wageV_mom(i)
      if(divide_SE.eq.1) then
        momi_workers(i,counth)=Dm(i,mkt)*wageV_mom(i)/1.25907
      end if
  end do
end do


!wageNT   mkt                  18 c
do mkt=1,n_mkt
 counti=counti+1
  do i=1,n_w
    momi_workers(i,counti)=Dm(i,mkt)*wageNT_mom(i)
      if(divide_SE.eq.1) then
        momi_workers(i,counti)=Dm(i,mkt)*wageNT_mom(i)/5.354306
      end if
  end do
end do





!fracM   perfec_c 2 d  fracNT_mom 

  do perfec_c=0,1
   countl=countl+1
   do i=1,n_w
    momi_workers(i,countl)=Dp(i,perfec_c)*fracM_mom(i)
      if(divide_SE.eq.1) then
    momi_workers(i,countl)=Dp(i,perfec_c)*fracM_mom(i)/.2929787
      end if
   end do
  end do

!fracV   perfec_c 2 d  fracV_mom 

  do perfec_c=0,1
   countm=countm+1
   do i=1,n_w
    momi_workers(i,countm)=Dp(i,perfec_c)*fracV_mom(i)
      if(divide_SE.eq.1) then
    momi_workers(i,countm)=Dp(i,perfec_c)*fracV_mom(i)/.2683031
      end if
   end do
  end do



!fracNT   perfec_c 2 d  fracNT_mom 

  do perfec_c=0,1
   countn=countn+1
   do i=1,n_w
    momi_workers(i,countn)=Dp(i,perfec_c)*fracNT_mom(i)
      if(divide_SE.eq.1) then
    momi_workers(i,countn)=Dp(i,perfec_c)*fracNT_mom(i)/.4570806
      end if
   end do
  end do




!fracM   age_c fem_c grad_c   16 e  fracM_mom
do age_c=1,4
 do fem_c=0,1
  do grad_c=0,1
   counto=counto+1
   do i=1,n_w
    momi_workers(i,counto)=Dafg(i,age_c,fem_c,grad_c)*fracM_mom(i)
      if(divide_SE.eq.1) then
    momi_workers(i,counto)=Dafg(i,age_c,fem_c,grad_c)*fracM_mom(i)/.2929787
      end if
   end do
  end do
 end do
end do

!fracV  age_c fem_c grad_c   16 e  fracV_mom
do age_c=1,4
 do fem_c=0,1
  do grad_c=0,1
   countp=countp+1
   do i=1,n_w
    momi_workers(i,countp)=Dafg(i,age_c,fem_c,grad_c)*fracV_mom(i)
      if(divide_SE.eq.1) then
    momi_workers(i,countp)=Dafg(i,age_c,fem_c,grad_c)*fracV_mom(i)/.2683031
      end if
   end do
  end do
 end do
end do


!fracNT   age_c fem_c grad_c   16 e  fracNT_mom
do age_c=1,4
 do fem_c=0,1
  do grad_c=0,1
   countq=countq+1
   do i=1,n_w
    momi_workers(i,countq)=Dafg(i,age_c,fem_c,grad_c)*fracNT_mom(i)
      if(divide_SE.eq.1) then
    momi_workers(i,countq)=Dafg(i,age_c,fem_c,grad_c)*fracNT_mom(i)/.4570806
      end if
   end do
  end do
 end do
end do





!fracM   mkt                  18 f  fracNT_mom
do mkt=1,n_mkt
 countr=countr+1
  do i=1,n_w
   momi_workers(i,countr)=Dm(i,mkt)*fracM_mom(i)
      if(divide_SE.eq.1) then
   momi_workers(i,countr)=Dm(i,mkt)*fracM_mom(i)/.2929787
      end if
  end do
end do

!fracV   mkt                  18 f  fracV_mom
do mkt=1,n_mkt
 counts=counts+1
  do i=1,n_w
   momi_workers(i,counts)=Dm(i,mkt)*fracV_mom(i)
      if(divide_SE.eq.1) then
   momi_workers(i,counts)=Dm(i,mkt)*fracV_mom(i)/.2683031 
      end if
  end do
end do


!fracM   mkt                  18 f  fracNT_mom
do mkt=1,n_mkt
 countt=countt+1
  do i=1,n_w
   momi_workers(i,countt)=Dm(i,mkt)*fracNT_mom(i)
      if(divide_SE.eq.1) then
   momi_workers(i,countt)=Dm(i,mkt)*fracNT_mom(i)/.4570806
      end if
  end do
end do





!fracM   fem_c nkids_c        8  g  fracNT_mom
do fem_c=0,1
 do nkids_c=0,3
  countu=countu+1
  do i=1,n_w
   momi_workers(i,countu)=Dfn(i,fem_c,nkids_c)*fracM_mom(i)
      if(divide_SE.eq.1) then
   momi_workers(i,countu)=Dfn(i,fem_c,nkids_c)*fracM_mom(i)/.2929787
      end if
  end do
 end do
end do

!fracV   fem_c nkids_c        8  g  fracV_mom
do fem_c=0,1
 do nkids_c=0,3
  countv=countv+1
  do i=1,n_w
   momi_workers(i,countv)=Dfn(i,fem_c,nkids_c)*fracV_mom(i)
      if(divide_SE.eq.1) then
   momi_workers(i,countv)=Dfn(i,fem_c,nkids_c)*fracV_mom(i)/ .2683031
      end if
  end do
 end do
end do


!fracNT   fem_c nkids_c        8  g  fracNT_mom
do fem_c=0,1
 do nkids_c=0,3
  countz=countz+1
  do i=1,n_w
   momi_workers(i,countz)=Dfn(i,fem_c,nkids_c)*fracNT_mom(i)
      if(divide_SE.eq.1) then
   momi_workers(i,countz)=Dfn(i,fem_c,nkids_c)*fracNT_mom(i)/.4570806
      end if
  end do
 end do
end do





!fracM   nkids2_c age   16 h  fracM_mom
 do nkids2_c=0,1
  do age_c=1,4
    counta2=counta2+1
    do i=1,n_w
      momi_workers(i,counta2)=Dn2a(i,nkids2_c,age_c)*fracM_mom(i)
      if(divide_SE.eq.1) then
      momi_workers(i,counta2)=Dn2a(i,nkids2_c,age_c)*fracM_mom(i)/.2929787
      end if
     end do !i
  end do
 end do


!fracV   nkids2_c age   16 h  fracM_mom
 do nkids2_c=0,1
  do age_c=1,4
    countb2=countb2+1
    do i=1,n_w
      momi_workers(i,countb2)=Dn2a(i,nkids2_c,age_c)*fracV_mom(i)
      if(divide_SE.eq.1) then
      momi_workers(i,countb2)=Dn2a(i,nkids2_c,age_c)*fracV_mom(i)/.2683031
      end if
     end do !i
  end do
 end do



!fracNT   nkids2_c age   16 h  fracM_mom
 do nkids2_c=0,1
  do age_c=1,4
    countc2=countc2+1
    do i=1,n_w
      momi_workers(i,countc2)=Dn2a(i,nkids2_c,age_c)*fracNT_mom(i)
      if(divide_SE.eq.1) then
      momi_workers(i,countc2)=Dn2a(i,nkids2_c,age_c)*fracNT_mom(i)/.4570806 
      end if
     end do !i
  end do
 end do




!frac M n36
do nkids36_c=0,1
   countd2=countd2+1
     do i=1,n_w
    momi_workers(i,countd2)=Dn36(i,nkids36_c)*fracM_mom(i)
      if(divide_SE.eq.1) then
    momi_workers(i,countd2)=Dn36(i,nkids36_c)*fracM_mom(i)/.2929787
      end if
  end do !i
end do



!frac V n36
do nkids36_c=0,1
   counte2=counte2+1
     do i=1,n_w
    momi_workers(i,counte2)=Dn36(i,nkids36_c)*fracV_mom(i)
      if(divide_SE.eq.1) then
    momi_workers(i,counte2)=Dn36(i,nkids36_c)*fracV_mom(i)/.2683031
      end if
  end do !i
end do



!frac M n36
do nkids36_c=0,1
   countf2=countf2+1
     do i=1,n_w
    momi_workers(i,countf2)=Dn36(i,nkids36_c)*fracNT_mom(i)
      if(divide_SE.eq.1) then
    momi_workers(i,countf2)=Dn36(i,nkids36_c)*fracNT_mom(i)/.4570806 
      end if
  end do !i
end do


!wageM   fine age
do age_c=1,8
   countg2=countg2+1
    do i=1,n_w
      momi_workers(i,countg2)=Dfineage(i,age_c)*wageM_mom(i)
      if(divide_SE.eq.1) then
         momi_workers(i,countg2)=Dfineage(i,age_c)*wageM_mom(i)/ 1.550827
      end if
      end do !i

end do

!wageV   age_c fem_c perfec_c 16 a
do age_c=1,8
   counth2=counth2+1
     do i=1,n_w
        momi_workers(i,counth2)=Dfineage(i,age_c)*wageV_mom(i)
      if(divide_SE.eq.1) then
         momi_workers(i,counth2)=Dfineage(i,age_c)*wageV_mom(i)/ 1.25907
      end if
     end do !i
end do








!########################################################
!## average across i's to create momvec_casenw(286)  ####
!########################################################



momvec_workers=0.0d0


do k=1,286
 do i=1,n_w
   momvec_workers(k)=momvec_workers(k)+momi_workers(i,k)/Totweight
 end do
end do





!###################################################
!############## compute variance ###################
!###################################################





Var_workers=0.0d0



!Now compute the variance by summing over i within each cell of outerproduct

do k=1,286
 do kk=1,286
  do i=1,n_w

   Var_workers(k,kk)=Var_workers(k,kk)+(momi_workers(i,k)*momi_workers(i,kk))/(Totweight**2.0d0)

   end do
  end do
end do



!###################
!write the var cov to file used for the standard errors, this is always the FULL var covariance irrespective of the one we use for weighting

write(*,*) "writing var cov matrix to file"

open(unit=878576,file='./FULLVar_workers.txt')

  do k=1,286
    do kk=1,286
      write(878576,*) Var_workers(k,kk)
    end do
  end do

close(878576)



!#####################


diagonal=1

if(diagonal.eq.1) then

 write(*,*) "selecting only the diagonal"
  do k=1,286
   do kk=1,286
     if(k.ne.kk) then
      Var_workers(k,kk)=0.0d0
     end if
   end do
 end do

end if


!write the var cov to file used for weighting

write(*,*) "writing var cov matrix to file"

open(unit=878576,file='./Var_workers.txt')

  do k=1,286
    do kk=1,286
      write(878576,*) Var_workers(k,kk)
    end do
  end do

close(878576)

!write the worker portion of the diagonal weighting matrix


!write simce portion of diagonal weighting matrix

write(*,*) "writing diagonal weighting matrix"

inverseworkers=0.0d0
  do k=1,286
     inverseworkers(k,k)=1.0d0/Var_workers(k,k)
  end do
  
open(unit=878571,file='./inverseworkers.txt')


  do k=1,286
    do kk=1,286
      write(878571,*) inverseworkers(k,kk)
    end do
  end do
  
  

close(878571)




end subroutine compute_variance
