* Author: Michela Tincani (UCL)
* Year: 2020
*** analyse teacher labor supply
clear all
set more off
pause on
*change name of directory to current one:
global data_do_files="C:/Users/uctpm/Dropbox/projects/JMP/QE_revision/data and programs" 

use workers_unique

gen choice=1 if M==1
replace choice=2 if V==1
replace choice=3 if NT==1
replace choice=4 if H==1





label var fem "Female"
label var nkids "Number of children"
label var nkidsXfem "Number of Children X Female"
label var age "Age"
label var agesq "Age Squared" 


**** teahcer labour supply, Table C2
 probit teach i.fem  nkids  c.nkids#i.fem  age c.age#c.age if work==1 [pweight=weight]
 eststo m1: margins, dydx(*) post
  probit M i.fem  nkids   c.nkids#i.fem  age c.age#c.age if teach==1 [pweight=weight]
 eststo m2: margins, dydx(*) post

 probit work  i.fem  nkids  c.nkids#i.fem  age c.age#c.age  [pweight=weight]
 eststo m3: margins, dydx(*) post


	
	esttab m1 m2 m3  using "$data_do_files\tables\LabourSupply.tex", replace /// 
label booktabs b(3) se(3)  star(* 0.10 ** 0.05 *** 0.01) wrap mtitles ("Teach" "Teach in public sector" "Work") longtable nonumbers pr2   ///
title(Labour supply \label{LabSupply}) nonotes addnotes("Standard errors in parentheses. Results from Probit Regression of the outcome variable on:" "gender, number of children, number of children interacted with gender, age, age squared." ///
"Marginal effects reported. Inverse Probability Weights." "Samples restrictions by columns: (1): individuals who work, (2): individuals who teach," " (3): full sample.")




*** wage regressions, Table C3
label var perfect "Prof. Certifications"
label var graddeg "Graduate Degree"
 reg lwage age agesq fem perfect graddeg if M==1 [pweight=weight]
 eststo mlogwage
 * 
  reg lwage age agesq fem perfect graddeg if V==1 [pweight=weight]
  eststo vlogwage
 * 
  reg lwage age agesq fem perfect graddeg if NT==1 [pweight=weight]
  eststo ntlogwage
  
  	esttab mlogwage vlogwage ntlogwage  using "$data_do_files\tables\wages.tex", replace /// 
label booktabs b(3) se(3)  star(* 0.10 ** 0.05 *** 0.01) wrap mtitles ("Public" "Voucher" "Non-Teaching") longtable nonumbers r2  ///
title(Log-wage regressions by occupatonal sector: descriptive analysis \label{Logwage}) nonotes addnotes("Standard errors in parentheses. Dependent variable: logwage. Inverse Probability Weights." )
  
  
  
