*Author: Michela Tincani (UCL)
*Year: 2020
*** analyse demand for education
clear all
set more off
pause on
*change name of directory to current one:
global data_do_files="C:/Users/uctpm/Dropbox/projects/JMP/QE_revision/data and programs" 

use SIMCE410_final

gen income_pro_capite=mincome /nfam
gen income_pro_capite_sq=income_pro_capite*income_pro_capite

gen income_pro_capite_thousand=income_pro_capite/1000
gen income_pro_capite_sq_thousand=income_pro_capite_sq/1000000
gen logmincome=log(mincome)

gen mincome_thousand=mincome/1000
gen mincome_100thousand=mincome/100000

gen income_pro_capite_100thousand=income_pro_capite/100000
gen income_pro_capite_sq_100thousand=income_pro_capite_sq/10000000000

label var logmincome "Log income"
label var primaria "Primary"
label var rural "Rural"
label var peduc "Parents' education"
label var income_pro_capite_thousand "Income pro-capite (1,000 CLP)"
label var income_pro_capite_100thousand "Income pro-capite (100,000 CLP)"
label var income_pro_capite_sq_thousand  "Squared income pro-capite (1,000 CLP)"
label var income_pro_capite_sq_100thousand  "Squared income pro-capite (100,000 CLP)"
label var nfam "Family size"
label var mincome_thousand "Income (1,000 CLP)"
label var mincome_100thousand "Income (100,000 CLP)"

** choice of school, Table C4
probit m logmincome  primaria rural peduc nfam
 eststo m1: margins, dydx(*) post
esttab m1 using "$data_do_files\tables\Schoolchoice.tex", replace label booktabs b(3) se(3) star(* 0.10 ** 0.05 *** 0.01) /// 
wrap mtitles("Public School") not pr2 title(Demand for public sector schooling \label{EducDemand}) longtable nonotes ///
addnotes("Results from Probit regression of the outcome variable on log household income, elementary school dummy, rural home dummy, parental education, family size." "Standard errors in parentheses. Marginal effects reported.")






*** achievement regressions, Table C5
reg standability  peduc income_pro_capite_thousand income_pro_capite_sq_thousand	 if m==1
eststo mscore
reg standability  peduc income_pro_capite_thousand income_pro_capite_sq_thousand	 if v==1
eststo vscore
	esttab  mscore vscore using "$data_do_files\tables\achievement.tex", replace  /// 
label booktabs b(3) se(3) star(* 0.10 ** 0.05 *** 0.01) wrap mtitles("Public" "Voucher") not r2 /// *drop(fem nkids nkidsXfem age agesq)  ///
title(Achievement by school sector \label{Achievement}) longtable nonotes addnotes("Standard errors in parentheses.")

reg standability  peduc income_pro_capite_100thousand income_pro_capite_sq_100thousand	 if m==1
eststo mscore100
reg standability  peduc income_pro_capite_100thousand income_pro_capite_sq_100thousand	 if v==1
eststo vscore100

	esttab  mscore100 vscore100 using "$data_do_files\tables\achievement100.tex", replace  /// 
label booktabs b(3) se(3) star(* 0.10 ** 0.05 *** 0.01) wrap mtitles("Public" "Voucher") not r2 /// *drop(fem nkids nkidsXfem age agesq)  ///
title(Achievement by school sector \label{Achievement}) longtable nonotes addnotes("Standard errors in parentheses.")


